<?xml version="1.0" encoding="ISO-8859-1"?>
<!DOCTYPE xsl:stylesheet [
<!ENTITY nbsp "&#160;">
]>

<xsl:transform
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:xs="http://www.w3.org/2001/XMLSchema"
    xmlns:java="xalan://xml.apache.org/xalan/java"
    xmlns:fn="http://projets.admisource.gouv.fr/xemelios/namespaces#functions"
    xmlns:added="http://projets.admisource.gouv.fr/xemelios/namespaces#added"
    xmlns:n="http://www.minefi.gouv.fr/cp/helios/pes_v2/facture"    
    exclude-result-prefixes="fn java" version="2.0">

    <xsl:output method="xml" indent="yes"/>

    <!--xsl:output encoding="##output-encoding##"/>
    <xsl:output version="##xml-version##"/-->

    <xsl:output encoding="ISO-8859-1"/>
    <xsl:output version="1.0"/>
    <xsl:param name="language" select="'fr'"/>

    <xsl:template match="/*[position()=1]">
        <xsl:if test="local-name() = 'PESFacture'">
            <DOC_PES_Facture xmlns="http://www.minefi.gouv.fr/cp/helios/pes_v2/facture"
                                  xmlns:added="http://projets.admisource.gouv.fr/xemelios/namespaces#added"
                                  xmlns:n="http://www.minefi.gouv.fr/cp/helios/pes_v2/facture">
                <xsl:if test="IdVer">
                    <xsl:call-template name="writeElement">
                        <xsl:with-param name="el" select="IdVer"/>
                    </xsl:call-template>
                </xsl:if>
                <xsl:if test="Annee">
                    <xsl:call-template name="writeElement">
                        <xsl:with-param name="el" select="Annee"/>
                    </xsl:call-template>
                </xsl:if>
                <xsl:if test="NumSequence">
                    <xsl:call-template name="writeElement">
                        <xsl:with-param name="el" select="NumSequence"/>
                    </xsl:call-template>
                </xsl:if>
                <xsl:if test="Date">
                    <xsl:call-template name="writeElement">
                        <xsl:with-param name="el" select="Date"/>
                    </xsl:call-template>
                </xsl:if>
                <xsl:if test="Emetteur">
                    <xsl:call-template name="writeElement">
                        <xsl:with-param name="el" select="Emetteur"/>
                    </xsl:call-template>
                </xsl:if>
                <xsl:element name="PESFacture" namespace="http://www.minefi.gouv.fr/cp/helios/pes_v2/facture">
                    <xsl:attribute name="collectivite" namespace="http://projets.admisource.gouv.fr/xemelios/namespaces#added">
                        <xsl:value-of select="./Emetteur/InfoTiers/RefTiers/@V"></xsl:value-of>
                    </xsl:attribute>
                    <xsl:for-each select="./@*">
                        <xsl:attribute name="{local-name(.)}" namespace="{namespace-uri(.)}">
                            <xsl:value-of select="."/>
                        </xsl:attribute>
                    </xsl:for-each>
                    <xsl:for-each select="./*">
                        <xsl:call-template name="writeElement">
                            <xsl:with-param name="el" select="."/>
                        </xsl:call-template>
                    </xsl:for-each>
                </xsl:element>
                <xsl:for-each select="./Nomenclatures">
                    <xsl:call-template name="writeElement">
                        <xsl:with-param name="el" select="."/>
                    </xsl:call-template>
                </xsl:for-each>
            </DOC_PES_Facture>
       </xsl:if>
    </xsl:template>
    
    <xsl:template name="writeElement">
        <xsl:param name="el"/>
        <xsl:choose>
            <xsl:when test="string-length(local-name($el)) &gt; 0">
                <xsl:variable name="tagName" select="local-name($el)"/>
                <xsl:element name="{$tagName}" namespace="http://www.minefi.gouv.fr/cp/helios/pes_v2/facture">
                    <xsl:for-each select="$el/@*">
                        <xsl:attribute name="{local-name(.)}">
                            <xsl:value-of select="."/>
                        </xsl:attribute>
                    </xsl:for-each>                    
                    <xsl:for-each select="$el/*">
                        <xsl:call-template name="writeElement">
                            <xsl:with-param name="el" select="."/>
                        </xsl:call-template>
                    </xsl:for-each>
                    <xsl:value-of select="$el/text()" disable-output-escaping="yes"/>
                </xsl:element>
            </xsl:when>
            <xsl:otherwise><xsl:comment><xsl:value-of select="local-name($el)"/></xsl:comment></xsl:otherwise>
        </xsl:choose>
        
    </xsl:template>
</xsl:transform>
