
package fr.gouv.finances.cp.xemelios.plugin.signerfichier;

/*
 * DlgSignerfichierFull.java
 *
 * Created on 23 septembre 2008, 09:16
 */
import fr.gouv.finances.cp.xemelios.plugin.signerfichier.FileSigner;
import fr.gouv.finances.cp.xemelios.plugin.signerfichier.IFileSigner;
import javax.swing.JFileChooser;
import javax.swing.SwingUtilities;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.filechooser.FileFilter;
import java.io.File;
import fr.gouv.finances.cp.xemelios.ui.MainWindow;
import fr.gouv.finances.cp.xemelios.common.config.DocumentModel;
import fr.gouv.finances.cp.xemelios.common.config.DocumentsModel;
import fr.gouv.finances.cp.xemelios.common.config.TraitementExterneModel;
import java.util.Enumeration;
import org.apache.log4j.Logger;

/**
 *
 * @author  laurent.meckert
 */
public class DlgSignerfichier extends javax.swing.JDialog {

   private JFrame parentWindow;
   File modelBaseDirectory;
   File fileToSign = null;
   File fileToGenerate = null;
   File certFile = null;
   JFileChooser fc;
   DlgKeystore dialogKeystore;
   static Logger logger = Logger.getLogger(DlgSignerfichier.class);
   IFileSigner signer = null;

   //later private TraitementExterneModel texModel = null;
   private DocumentModel docModel = null;

   /** Creates new form DlgSignerfichier */
   public DlgSignerfichier(java.awt.Frame parent, boolean modal) {
      super(parent, modal);
      initComponents();

      if (MainWindow.instance != null) {// Sinon on a tout faux
         DocumentsModel docModels = null;
         docModels = MainWindow.instance.getDocModels();
         docModel = docModels.getDocumentById("PES_Aller");
         logger.info(docModel);
         modelBaseDirectory = new File(docModel.getBaseDirectory());
         // logger.info(docModel);
         // later texModel = docModel.getTraitementExterneById("verification-signature");


      } else {


      }
      setLocationRelativeTo(parent);
   }

   /**
    * 
    */
   public void ShowInputFileSelector() {
      if (fileToSign != null) {
         fc = new JFileChooser(fileToSign);
      } else {
         fc = new JFileChooser(".");
      }
      fc.addChoosableFileFilter(new FileFilter() {

            public boolean accept(File f) {
               return f.isDirectory() || f.getName().toUpperCase().endsWith("XML");
            }

            public String getDescription() {
               return "Document XML";
            }
         });
      // Show open dialog; this method does not return until the dialog is closed
      fc.showOpenDialog(null);
      fileToSign = fc.getSelectedFile();
      if (fileToSign != null) {
         textFieldInputFile.setText(fileToSign.getAbsolutePath());
         fileToGenerate = new File(fileToSign.getAbsolutePath() + ".out.xml");

      }
   }

   /**
    * 
    */
   public void ShowCertFileSelector() {
      if (fileToSign != null) {
         fc = new JFileChooser(certFile);
      } else {
         fc = new JFileChooser(".");
      }
      fc.addChoosableFileFilter(new FileFilter() {

            public boolean accept(File f) {
               return f.isDirectory() || f.getName().toUpperCase().endsWith("KS") || f.getName().toUpperCase().endsWith("JKS") || f.getName().toUpperCase().endsWith("JCE") || f.getName().toUpperCase().endsWith("P12") || f.getName().toUpperCase().endsWith("PFX");
            }

            public String getDescription() {
               return "Magasins de cls (.ks, .jks, .jce, .p12, .pks)";
            }
         });
      // Show open dialog; this method does not return until the dialog is closed
      fc.showOpenDialog(null);
      certFile = fc.getSelectedFile();
      if (certFile != null) {
         textFieldCertFile.setText(certFile.getAbsolutePath());

         if (dialogKeystore == null) {
            JFrame frame = new JFrame("test");
            dialogKeystore = new DlgKeystore(frame, true);
         }
         signer.setKeystoreFile(certFile);
         dialogKeystore.setSigner(signer);
         dialogKeystore.setTitle("Ouverture du fichier " + certFile.getName());
         try {
            dialogKeystore.setMode(dialogKeystore.MODE_KEYSTORE);
         } catch(Exception e) {
            e.printStackTrace();
         }
         dialogKeystore.setVisible(true);
      }
   }

   /**
    * Montre le rsultat de la vrification
    * @param signer 
    */
   public void showStatus(IFileSigner signer) {
      String bla = signer.getStatusAsString();

      int sever = signer.getStatusAsSeverity();

      JOptionPane.showMessageDialog(parentWindow,
                                    bla,
                                    "Rsultat de la vrification",
                                    sever == FileSigner.SIGN_VERYBAD ? JOptionPane.ERROR_MESSAGE : (sever == FileSigner.SIGN_BAD ? JOptionPane.WARNING_MESSAGE : JOptionPane.PLAIN_MESSAGE));
   }

   /** This method is called from within the constructor to
    * initialize the form.
    * WARNING: Do NOT modify this code. The content of this method is
    * always regenerated by the Form Editor.
    */
   @SuppressWarnings("unchecked")
      // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
      private void initComponents() {

      jButtonInputFile = new javax.swing.JButton();
      textFieldInputFile = new java.awt.TextField();
      label1 = new java.awt.Label();
      jLabel2 = new javax.swing.JLabel();
      textFieldCertFile = new java.awt.TextField();
      jButtonInputFile1 = new javax.swing.JButton();
      label2 = new java.awt.Label();
      jButtonOK = new javax.swing.JButton();
      jComboBoxAliases = new javax.swing.JComboBox();
      jButtonAnnuler = new javax.swing.JButton();
      label4 = new java.awt.Label();
      label3 = new java.awt.Label();

      setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

      jButtonInputFile.setText("...");
      jButtonInputFile.setName("jButtonInputFile"); // NOI18N
      jButtonInputFile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
               jButtonInputFileActionPerformed(evt);
            }
         });

      textFieldInputFile.setEnabled(false);
      textFieldInputFile.setName("textFieldInputFile"); // NOI18N

      label1.setText("1) Chosir le fichier  signer");

      jLabel2.setFont(new java.awt.Font("Tahoma", 1, 13));
      jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
      jLabel2.setText("SIGNER UN FICHIER PES");

      textFieldCertFile.setEnabled(false);
      textFieldCertFile.setName("textFieldInputFile"); // NOI18N

      jButtonInputFile1.setText("...");
      jButtonInputFile1.setName("jButtonCerttFile"); // NOI18N
      jButtonInputFile1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
               jButtonInputFile1ActionPerformed(evt);
            }
         });

      label2.setText("2) Choisir  un fichier de type \"magasin de cls\"");

      jButtonOK.setText("OK");
      jButtonOK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
               jButtonOKActionPerformed(evt);
            }
         });

      jComboBoxAliases.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));

      jButtonAnnuler.setText("Annuler");
      jButtonAnnuler.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
               jButtonAnnulerActionPerformed(evt);
            }
         });

      label4.setText("3) Choisir votre cl prive");

      label3.setText("3) Lancer la signature");

      org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
      getContentPane().setLayout(layout);
      layout.setHorizontalGroup(
                                layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                .add(layout.createSequentialGroup()
                                     .add(27, 27, 27)
                                     .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                          .add(label3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                          .add(layout.createSequentialGroup()
                                               .add(jButtonOK)
                                               .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 277, Short.MAX_VALUE)
                                               .add(jButtonAnnuler))
                                          .add(layout.createSequentialGroup()
                                               .add(22, 22, 22)
                                               .add(jLabel2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 381, Short.MAX_VALUE))
                                          .add(label2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                          .add(label4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                          .add(layout.createSequentialGroup()
                                               .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                                    .add(textFieldInputFile, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 303, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                                    .add(label1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 315, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                                    .add(textFieldCertFile, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 303, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                               .add(43, 43, 43)
                                               .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                                                    .add(jButtonInputFile)
                                                    .add(jButtonInputFile1)))
                                          .add(jComboBoxAliases, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 325, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                     .addContainerGap(23, Short.MAX_VALUE))
                                );
      layout.setVerticalGroup(
                              layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                              .add(layout.createSequentialGroup()
                                   .addContainerGap()
                                   .add(jLabel2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 16, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                   .add(21, 21, 21)
                                   .add(label1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                   .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                   .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                        .add(textFieldInputFile, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                        .add(jButtonInputFile))
                                   .add(17, 17, 17)
                                   .add(label2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                   .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                   .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                        .add(layout.createSequentialGroup()
                                             .add(jButtonInputFile1)
                                             .add(14, 14, 14)
                                             .add(label4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                        .add(textFieldCertFile, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                   .add(1, 1, 1)
                                   .add(jComboBoxAliases, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                   .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 33, Short.MAX_VALUE)
                                   .add(label3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 32, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                   .add(2, 2, 2)
                                   .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                        .add(jButtonOK)
                                        .add(jButtonAnnuler))
                                   .add(20, 20, 20))
                              );

      label1.getAccessibleContext().setAccessibleName("1) Choisir le fichier  signer");
      label3.getAccessibleContext().setAccessibleName("4) Lancer la signature");

      pack();
   }// </editor-fold>//GEN-END:initComponents

   private void jButtonInputFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonInputFileActionPerformed
      ShowInputFileSelector();
      signer.setInputFile(fileToSign);

      try {
         signer.loadInputFile();
      } catch (Exception e) {
         e.printStackTrace();
         showStatus(signer);
      }

   }//GEN-LAST:event_jButtonInputFileActionPerformed

   private void jButtonInputFile1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonInputFile1ActionPerformed
      // TODO add your handling code here:
      ShowCertFileSelector();
      //  IFileSigner signer = dialogKeystore.getSigner();
      if (signer != null) {

         jComboBoxAliases.removeAllItems();
         try {
            for (Enumeration e = signer.getAliases(); e.hasMoreElements();) {
               //System.out.println(e.nextElement());
               jComboBoxAliases.addItem(e.nextElement());
            }
         } catch (Exception e) {
            e.printStackTrace();
         }
      }
   }//GEN-LAST:event_jButtonInputFile1ActionPerformed

   private void jButtonAnnulerActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonAnnulerActionPerformed
      // TODO add your handling code here:
      close();
   }//GEN-LAST:event_jButtonAnnulerActionPerformed

   private void jButtonOKActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonOKActionPerformed
      // TODO add your handling code here:
   
      if (dialogKeystore != null) {
         if (signer != null) {
            try {
               signer.setAlias((String) (jComboBoxAliases.getSelectedItem()));
        
               signer.setAliasPassword(signer.getKeystorePassword());
               // Premier essai avec le mot de passe generique du fichier 
               signer.loadAlias();

               // Si a ne marche pas on demande le mdp specifique de la cle
               if(!signer.loadPkOK()) {
                  dialogKeystore.setTitle("Ouverture de la cle prive  " + signer.getAlias());
                  dialogKeystore.setMode(dialogKeystore.MODE_ALIAS);
                  dialogKeystore.setVisible(true);
               }
               if(signer.loadPkOK()) {

                  // Show save dialog; this method does not return until the dialog is closed
                  if (fileToGenerate != null) {
                     fc = new JFileChooser(fileToGenerate);
                  } else {
                     fc = new JFileChooser(".");
                  }
                  fc.addChoosableFileFilter(new FileFilter() {

                        public boolean accept(File f) {
                           return f.isDirectory() || f.getName().toUpperCase().endsWith("XML");
                        }

                        public String getDescription() {
                           return "Document XML";
                        }
                     });
                  fc.showSaveDialog(null);
                  fileToGenerate = fc.getSelectedFile();
                  if (fileToGenerate == null) {
                     return;
                  }
                  signer.setOutputFile(fileToGenerate);
                  signer.sign();
                  showStatus(signer);
                  close();
               }else {
                  showStatus(signer);
                  return;
               }
            } catch (Exception e) {
               e.printStackTrace();
               showStatus(signer);
            }
         }
      }
   }//GEN-LAST:event_jButtonOKActionPerformed
   public void run() {
      setSize(465, 470);
      FileSignerFactory fsf = FileSignerFactory.newInstance();
      fsf.setAttribute(FileSignerFactory.USE_APACHEXMLSEC, true);
      fsf.setNsCtx(docModel.getNamespaces());
  
      try {
         signer = fsf.newFileSigner();
         signer.addIntersectFilter("//n:Bordereau");
      } catch (Exception e) {
         e.printStackTrace();
      }

      jComboBoxAliases.removeAllItems();
      setVisible(true);
   }
   /**
    * 
    */
   public void close() {
      if(dialogKeystore != null)
         SwingUtilities.getWindowAncestor(dialogKeystore).dispose();
      dialogKeystore = null;
      SwingUtilities.getWindowAncestor(this).dispose();
   }
   /**
    * @param args the command line arguments
    */
   public static void main(String args[]) {
      Runnable mainTask = new Runnable() {
            public void run() {
               JFrame frame = new JFrame("test");
               DlgSignerfichier dialog = new DlgSignerfichier(frame, true);
               dialog.addWindowListener(new java.awt.event.WindowAdapter() {

                     @Override
                        public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                     }
                  });

               dialog.run();

            }
         };

      Thread t = new Thread(mainTask);
      t.setPriority(Thread.NORM_PRIORITY);


      java.awt.EventQueue.invokeLater(t);

   }

   // Variables declaration - do not modify//GEN-BEGIN:variables
   private javax.swing.JButton jButtonAnnuler;
   private javax.swing.JButton jButtonInputFile;
   private javax.swing.JButton jButtonInputFile1;
   private javax.swing.JButton jButtonOK;
   private javax.swing.JComboBox jComboBoxAliases;
   private javax.swing.JLabel jLabel2;
   private java.awt.Label label1;
   private java.awt.Label label2;
   private java.awt.Label label3;
   private java.awt.Label label4;
   private java.awt.TextField textFieldCertFile;
   private java.awt.TextField textFieldInputFile;
   // End of variables declaration//GEN-END:variables

}
