<?xml version="1.1" encoding="iso-8859-1"?>
<!DOCTYPE xsl:stylesheet [
<!ENTITY nbsp "&#160;">
]>
<xsl:transform
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 version="2.0"
>

<xsl:output
 method="html"
 encoding="iso-8859-1"
 indent="yes"
 />

<!-- pour eviter les sorties parasites de tags non matches -->
<xsl:template match="*">
</xsl:template>

<!-- parametre implicite pour tous les format-number utilises dans la feuille-->
<xsl:decimal-format
                    decimal-separator="."
                    grouping-separator=" "
/>   

<!-- La date -->
<data xmlns="data.uri">
<mois xml:lang="fr">
   <m>Janvier</m><m>Fvrier</m><m>Mars</m><m>Avril</m>
   <m>Mai</m><m>Juin</m><m>Juillet</m><m>Aot</m>
   <m>Septembre</m><m>Octobre</m><m>Novembre</m><m>Dcembre</m>
</mois>
</data>

<xsl:param name="language" select="'fr'"/>

<!-- 2001-02-28 => 28/02/2001 -->
<xsl:template name="slash-date">
 <xsl:param name="datebrute"/>
<date xmlns:data="data.uri" xsl:exclude-result-prefixes="data">
   <xsl:value-of select="substring($datebrute, 9, 2)"/>
   <xsl:text>/</xsl:text>
   <xsl:value-of select="substring($datebrute, 6, 2)"/>
   <xsl:text>/</xsl:text>
   <xsl:value-of select="substring($datebrute, 1, 4)"/>
</date>
</xsl:template>

<!-- 2001-02-28 => 28 fevrier 2001 -->
<xsl:template name="iso-date">
 <xsl:param name="datebrute"/>
<date xmlns:data="data.uri" xsl:exclude-result-prefixes="data">
   <xsl:value-of select="substring($datebrute, 9, 2)"/>
   <xsl:text> </xsl:text>
   <xsl:variable name="mois" select="number(substring($datebrute, 6, 2))"/>
   <!-- dans la ligne suivante, le moteur de transformation remplace @@XSL_LOCATION@@ par le nom et l'emplacement de ce fichier -->
   <xsl:value-of select="document('@@XSL_LOCATION@@')/*/data:data/data:mois[lang($language)]/data:m[$mois]"/>
   <xsl:text> </xsl:text>
   <xsl:value-of select="substring($datebrute, 1, 4)"/>
</date>
</xsl:template>

<!-- 02 =>  fevrier-->
<xsl:template name="iso-mois">
 <xsl:param name="datebrute"/>
<date xmlns:data="data.uri" xsl:exclude-result-prefixes="data">
   <xsl:variable name="mois" select="number($datebrute)"/>
   <xsl:value-of select="document('@@XSL_LOCATION@@')/*/data:data/data:mois[lang($language)]/data:m[$mois]"/>
</date>
</xsl:template>




<xsl:template match="/DocumentPaye">
<HTML>
<HEAD>
<STYLE>
body {
    font-family: verdana, sans-serif;
    font-size: 10px;
}

table {
	border-style: solid;
	border-width: 1px;
	border-color: black;
}
thead th {
	border-style: solid;
	border-width: 1px;
	font-size: 12px;
	font-weight: bold
}

tbody tr td {
	font-size: 11px;
	border-style: solid;
	border-width: 1px;
	border-color: black;
}
.titre {
	font-weight: bold;
	text-align: center;
}
</STYLE>
</HEAD>
<BODY>
<xsl:apply-templates  />
</BODY>
</HTML>
</xsl:template>

<xsl:template match="Nomenclatures">
<xsl:apply-templates  />
</xsl:template>

<xsl:template match="/DocumentPaye/Nomenclatures/NomenclatureEvtPaye">
<h2><xsl:value-of select="Description/@V"/></h2>
<table cellspacing="0px" cellpadding="1px">
<tbody>
<tr><td class="titre">Libelle</td><td class="titre">Code</td></tr>
<xsl:apply-templates/>
</tbody>
</table>
<br/>
</xsl:template>

<xsl:template match="/DocumentPaye/Nomenclatures/NomenclatureCaisse">
<h2><xsl:value-of select="Description/@V"/></h2>
<table cellspacing="0px" cellpadding="1px">
<tbody>
<tr><td class="titre">Libelle</td><td class="titre">Code</td></tr>
<xsl:apply-templates/>
</tbody>
</table>
<br/>
</xsl:template>

<xsl:template match="/DocumentPaye/Nomenclatures/NomenclatureBudget">
<h2><xsl:value-of select="Description/@V"/></h2>
<table cellspacing="0px" cellpadding="1px">
<tbody>
<tr><td class="titre">Libelle</td><td class="titre">Code</td></tr>
<xsl:apply-templates/>
</tbody>
</table>
<br/>
</xsl:template>

<xsl:template match="/DocumentPaye/Nomenclatures/NomenclatureNature">
<h2><xsl:value-of select="Description/@V"/></h2>
<table cellspacing="0px" cellpadding="1px">
<tbody>
<tr><td class="titre">Libelle</td><td class="titre">Code</td></tr>
<xsl:apply-templates/>
</tbody>
</table>
<br/>
</xsl:template>

<xsl:template match="/DocumentPaye/Nomenclatures/NomenclatureRubriquePaye">	<!-- celui-ci est particulier -->
<h2><xsl:value-of select="Description/@V"/></h2>
<table cellspacing="0px" cellpadding="1px">
<tbody>
<tr>
 <td class="titre">Libelle</td>
 <td class="titre">Code</td>
 <td class="titre">Code Caisse</td>
 <td class="titre">Code Nature <i>(part employeur)</i></td>
 <td class="titre">Code Nature <i>(part salariale)</i></td>
</tr>
<xsl:apply-templates/>
</tbody>
</table>
<br/>
</xsl:template>
<!-- fin structure globale-->


<xsl:template match="NomenclatureEvtPaye/Correspondance">
<tr><td><xsl:value-of select="Libelle/@V"/>&nbsp;</td><td><xsl:value-of select="Code/@V"/>&nbsp;</td></tr>
</xsl:template>

<xsl:template match="NomenclatureCaisse/Correspondance">
<tr><td><xsl:value-of select="Libelle/@V"/>&nbsp;</td><td><xsl:value-of select="Code/@V"/>&nbsp;</td></tr>
</xsl:template>

<xsl:template match="NomenclatureNature/Correspondance">
<tr><td><xsl:value-of select="Libelle/@V"/>&nbsp;</td><td><xsl:value-of select="Code/@V"/>&nbsp;</td></tr>
</xsl:template>

<xsl:template match="NomenclatureBudget/Correspondance">
<tr><td><xsl:value-of select="Libelle/@V"/>&nbsp;</td><td><xsl:value-of select="Code/@V"/>&nbsp;</td></tr>
</xsl:template>

<xsl:template match="NomenclatureRubriquePaye/Correspondance">	<!-- le cas particulier -->
<tr>
 <td><xsl:value-of select="Libelle/@V"/>&nbsp;</td>
 <td><xsl:value-of select="Code/@V"/>&nbsp;</td>
 <td><xsl:value-of select="CodeCaisse/@V"/>&nbsp;</td>
 <td><xsl:value-of select="CodeNatureEmp/@V"/>&nbsp;</td>
 <td><xsl:value-of select="CodeNatureSal/@V"/>&nbsp;</td>
</tr>
</xsl:template>


<xsl:template  name="enteteGauche">
<!-- 2 colonnes pour cadre employeur a gauche
4 rangee 
1 rangee vide pour alignement
cadre employeur
cadre ape siret
cadre ursaff matricule
-->
<table style="text-align: left; width: 100%; height: 100%;  vertical-align: top; " border="0">
<tr><!--1 rangee vide pour alignement-->
  <td colspan="2">
    <br/>&nbsp;
    <br/>
  </td>
</tr> 
<tr>
 <td width="60%" class="cadreEmployeur">
     <xsl:choose>
     <xsl:when test="../Etablissement">
            <xsl:call-template name="cadreEmployeur">  
             <xsl:with-param name="etabOuEmployeur" select="../Etablissement"/>
            </xsl:call-template>
      </xsl:when>
     <xsl:otherwise>
            <xsl:call-template name="cadreEmployeur">  
              <xsl:with-param name="etabOuEmployeur" select="//Employeur"/>
            </xsl:call-template>
     </xsl:otherwise> 
  </xsl:choose>
 </td>
 <td>&nbsp;
   <br/>
 </td>
</tr>

<tr>
 <td colspan="2">
  <xsl:choose>
     <xsl:when test="../Etablissement">
            <xsl:call-template name="cadreApeSiret">  
             <xsl:with-param name="etabOuEmployeur" select="../Etablissement"/>
            </xsl:call-template>
      </xsl:when>
     <xsl:otherwise>
            <xsl:call-template name="cadreApeSiret">  
              <xsl:with-param name="etabOuEmployeur" select="//Employeur"/>
            </xsl:call-template>
     </xsl:otherwise> 
  </xsl:choose>
 </td>
</tr>
<tr>
 <td colspan="2">
 &nbsp;
   <br/>
  </td>
</tr>
<tr>
  <td colspan="2">
    <xsl:call-template name="cadreEmploye1"/>  
  </td>
</tr>
</table>
</xsl:template>



<xsl:template  name="enteteDroite">
<!-- 3 colonnes pour cadre bulletin a droite et un peu de blanc
encore plus a droite
3 rangees 
1 rangee periode
1 rangee cadre bulletin de paye
1 rangee cadre employe nom adresse
-->
<TABLE style="text-align: left; width: 100%; height: 100%;  vertical-align: top; " border="0" >
<tr>
  <td>&nbsp;
   <br/>
  </td>
  <td colspan="2">
  <xsl:call-template name="cadrePeriode"/> 
 </td>
</tr>
<tr><!--1 rangee vide pour alignement-->
  <td colspan="3">&nbsp;
    <br/>
  </td>
</tr> 

<tr>
  <td>&nbsp;
   <br/>
  </td>
 <td class="cadreBulletin">
   <xsl:call-template name="cadreBulletin"/> 
  </td>
  <td>&nbsp;
    <br/>
  </td>
</tr>
<tr><!--1 rangee vide pour alignement-->
  <td colspan="3">&nbsp;
    <br/>
  </td>
</tr> 
<tr>
  <td colspan="2" class="cadreEmploye2">
    <xsl:call-template name="cadreEmploye2"/> 
  </td>
  <td>
   <br/>
  </td>
</tr>
</TABLE>
</xsl:template>


<xsl:template name="cadreEmployeur">
 <xsl:param name="etabOuEmployeur"/>
   <span class="nomemployeur"><xsl:value-of select="$etabOuEmployeur/Nom/@V"/></span><br/><br/>
   <xsl:value-of select="$etabOuEmployeur/Adresse/Adr1/@V"/><br/>
   <xsl:value-of select="$etabOuEmployeur/Adresse/Adr2/@V"/><br/>
   <xsl:value-of select="$etabOuEmployeur/Adresse/Adr3/@V"/><br/><br/>
   <xsl:value-of select="$etabOuEmployeur/Adresse/CP/@V"/>&nbsp;<xsl:value-of select="$etabOuEmployeur/Adresse/Ville/@V"/>
</xsl:template>

<xsl:template name="cadreApeSiret">
<xsl:param name="etabOuEmployeur"/>
<span class="titresapesiret">
  No APE:
</span><xsl:value-of select="//Employeur/APE/@V"/>&nbsp;
<span class="titresapesiret">
SIRET:
</span>
<xsl:value-of select="$etabOuEmployeur/Siret/@V"/><br/>
<span class="titresapesiret">URSSAF : </span>
<xsl:value-of select="$etabOuEmployeur/NumUrssaf/@V"/>
</xsl:template>
  
<xsl:template name="cadreEmploye1">
<xsl:for-each select=".">
<span class="titresemploye1">MATRICULE : </span><xsl:value-of select="Agent/Matricule/@V"/><br/>
<span class="titresemploye1">Nbre Heures : </span><xsl:value-of select="NbHeureTotal/@V"/><br/>
<span class="titresemploye1">Nbre Heures Sup : </span><xsl:value-of select="NbHeureSup/@V"/><br/>
<span class="titresemploye1">Qualification : </span><xsl:value-of select="Agent/EmploiMetier/@V"/><br/>
<span class="titresemploye1">Nomenclature statutaire : </span>
<xsl:value-of select="Agent/RefNomenStatutaire/Code/@V"/>
</xsl:for-each>
</xsl:template> 

<xsl:template name="cadrePeriode">
<!-- Bidouille d'alignement  -->
<xsl:for-each select="Periode">
<table style="width: 100%; ">
<tr>
<td align="right">
<span class="periodeperiode">PERIODE DU</span>
</td>
<td align="center">
<xsl:call-template name="slash-date" >
<xsl:with-param name="datebrute" select="DateDebut/@V" />
</xsl:call-template>
<!--<xsl:value-of select="DateDebut/@V"/> -->
</td>
<td align="left">
<span class="periodeperiode">AU</span>
</td>
<td align="center">
<span>
<xsl:call-template name="slash-date" >
<xsl:with-param name="datebrute" select="DateFin/@V" />
</xsl:call-template>
</span>
</td>
</tr>
</table>
</xsl:for-each>
</xsl:template> 


<xsl:template name="cadreBulletin">
<center><H1>BULLETIN DE PAYE</H1></center><br/>
<center><span class="bulletinmoisannee">
<xsl:call-template name="iso-mois" >
<xsl:with-param name="datebrute" select="/DocumentPaye/Mois/@V" />
</xsl:call-template>&nbsp;<xsl:value-of select="/DocumentPaye/Annee/@V"/></span></center>
</xsl:template> 

<xsl:template name="cadreEmploye2">
<xsl:for-each select="Agent">
 <span class="employe2">
<xsl:value-of select="Civilite/@V"/>&nbsp; 
<xsl:value-of select="Nom/@V"/>&nbsp; 
<xsl:value-of select="ComplNom/@V"/><br/>
<xsl:value-of select="Prenom/@V"/><br/><br/>
<xsl:value-of select="Adresse/Adr1/@V"/><br/><br/>
<xsl:value-of select="Adresse/CP/@V"/>&nbsp;<xsl:value-of select="Adresse/Ville/@V"/>
 </span>
</xsl:for-each>
</xsl:template> 



<xsl:template  name="categorie">
<TABLE class="categorie" >
<thead>
<tr>
<th>CAT</th><th>G.R.</th><th>ECH.</th><th>INDICE</th><th>NBI</th><th>SF</th><th>TX</th>
</tr>
</thead>
<tbody>
<xsl:for-each select=".">
<tr>
   <td><xsl:value-of select="Agent/Statut/@V"/></td>
   <td><xsl:value-of select="Agent/Grade/@V"/></td>
   <td><xsl:value-of select="Agent/Echelon/@V"/></td>
   <td><xsl:value-of select="Agent/Indice/@V"/></td>
   <td class="numeric"><xsl:value-of select="NBI/@V"/></td>
  <td class="numeric"><xsl:value-of select="Agent/NbEnfants/@V"/></td>
  <td class="numeric"><xsl:value-of select="QuotiteTrav/@V"/></td>
</tr>
</xsl:for-each>
</tbody>
</TABLE>
</xsl:template> 

<xsl:template  name="service">
<TABLE class="categorie" >
<thead>
<tr>
<th width="30%">&nbsp;</th><th>Service</th>
</tr>
</thead>
<tbody>
<tr>
<td width="30%">&nbsp;</td>
<td>
 <xsl:value-of select="Service/@V"/>
</td>
</tr>
</tbody>
</TABLE>
</xsl:template> 


<xsl:template  name="tabledetails">
<table class="detail" style="text-align: left; width: 100%;" >
<thead>
<tr>
<th colspan="2" >RUBRIQUE DE PAIE<br/>LIBELLE</th>
<th >NOMBRE<br/>OU BASE</th>
<th >TAUX</th>
<th >GAINS</th>
<th >RETENUES</th>
<th colspan="2">CHARGES PATRONALES</th>
</tr>
<tr>
<th  colspan="2" ></th>
<th ></th>
<th ></th>
<th ></th>
<th ></th>
<th>TAUX</th>
<th>MONTANT</th>
</tr>
</thead>
<tbody>
  <xsl:call-template name="details"/>
</tbody>
</table>
</xsl:template>

<xsl:template  name="details">
<xsl:for-each select="Remuneration/*">
<!-- Trier sur le champ Ordre, puis si meme ordre mettre les commentaires en fin -->
<xsl:sort select="Ordre/@V" data-type="number" order="ascending"  />
<!--<xsl:sort select="name()='Commentaire'"  data-type="boolean" order="ascending"  /> -->
<tr>
<!--<td><xsl:value-of select="Ordre/@V"/>&nbsp;<xsl:value-of select="name()"/>
</td>-->
<td>
<xsl:value-of select="Code/@V"/>
</td>
<td>
<xsl:value-of select="Libelle/@V"/>
</td>
<td class="numeric">
 <xsl:choose>
     <xsl:when test="Base"><xsl:value-of select="Base/@V"/></xsl:when>
     <xsl:when test="NbUnite"><xsl:value-of select="NbUnite/@V"/></xsl:when>
</xsl:choose>
</td>
<td  class="numeric">
<xsl:choose>
     <xsl:when test="name()='Cotisation'">
  </xsl:when>
   <xsl:otherwise>
<xsl:value-of select="Taux/@V"/>
</xsl:otherwise> 
</xsl:choose>
</td>
<td  class="numeric">
<xsl:choose>
     <xsl:when test="name()='Deduction'"></xsl:when>
     <xsl:when test="name()='Retenue'"></xsl:when>
     <xsl:when test="name()='Cotisation'"></xsl:when>
   <xsl:otherwise>
         <xsl:value-of select="format-number(Mt/@V,'### ###.00')"/>
   </xsl:otherwise>
</xsl:choose>
</td>
<td  class="numeric">
<xsl:choose>
      <xsl:when test="name()='Deduction'">
         <xsl:value-of select="format-number(Mt/@V,'### ###.00')"/>
  </xsl:when>
     <xsl:when test="name()='Retenue'">
         <xsl:value-of select="format-number(Mt/@V,'### ###.00')"/>
  </xsl:when>
   <xsl:otherwise></xsl:otherwise> 
</xsl:choose>
</td>
<td class="numeric">
<xsl:choose>
     <xsl:when test="name()='Cotisation'">
         <xsl:value-of select="Taux/@V"/>
 </xsl:when>
   <xsl:otherwise>  </xsl:otherwise>
</xsl:choose>
</td>
<td class="numeric">
<xsl:choose>
     <xsl:when test="name()='Cotisation'">
         <xsl:value-of select="format-number(Mt/@V,'### ###.00')"/>
  </xsl:when>
   <xsl:otherwise></xsl:otherwise>
</xsl:choose>
</td>
</tr>
</xsl:for-each>
</xsl:template> 


<xsl:template  name="table4">
<table class="table4" width="100%">
<tr>
<td>
 <xsl:call-template name="reglement"/>
</td>
<td width="20%">
</td>
</tr>
</table>
</xsl:template>




<xsl:template  name="reglement">
<table class="reglement" width="100%">
<thead>
<tr>
<th>
MODE DE REGLEMENT
</th>
<th>
NET A PAYER
</th>
</tr>
</thead>
<tbody>
<tr>
<td>
<table>
<tr>
<td>
Mise en paiement le <xsl:call-template name="slash-date" >
<xsl:with-param name="datebrute" select="DatePaiement/@V" />
</xsl:call-template>
</td>
</tr>
<tr>
<td>
</td>
</tr>
</table>
</td>
<td>
<table width="100%">
<tr>
<td>
&nbsp;
</td>
</tr>
<tr>
<td class="numeric">
<xsl:value-of select="format-number(MtNetAPayer/@V,'### ###.00')" />
</td>
</tr>
</table>
</td>
</tr>
</tbody>
</table>
</xsl:template>


<xsl:template  name="table5">
<table class="table5" width="100%">
<tr>
<td>
 <xsl:call-template name="netcumul"/>
</td>
<td width="20%">
</td>
</tr>
</table>
</xsl:template>



<xsl:template  name="netcumul">
<table width="100%" class="netcumul">
<thead>
<tr>
<th>
Net
</th>
<th>
NET IMPOSABLE
</th>
<th>
&nbsp;
</th>
</tr>
</thead>
<tbody>
<tr>
<td class="numeric">
<xsl:value-of select="format-number(MtNet/@V,'### ###.00')" />
</td>
<td class="numeric">
<xsl:value-of select="format-number(MtImposable/@V,'### ###.00')" />
</td>
<td>&nbsp;
</td>
</tr>
</tbody>
<thead>
<tr>
<th>
CUMUL BRUT
</th>
<th>
CUMUL NET IMPOSABLE
</th>
<th>
CUMUL BASE S.S.
</th>
</tr>
</thead>
<tbody>
<tr>
<td class="numeric">
<xsl:value-of select="format-number(CumulMtBrut/@V, '### ###.00')" />
</td>
<td class="numeric">
<xsl:value-of select="format-number(CumulMtImposable/@V, '### ###.00')" />
</td>
<td class="numeric">
<xsl:value-of select="format-number(CumulBaseSS/@V, '### ###.00')" />
</td>
</tr>
</tbody>
</table>
</xsl:template>

<xsl:template name="evenements">
<!--
Liste des evenements  
ce n'est sans doute ni l'endroit ni la presentation
voir structure globale pour changer l'emplacement
modifier presentation ici meme
-->

<TABLE class="evenements" >
<thead>
<tr>
<th width="30%">Evenement</th>
<th>Description</th>
</tr>
</thead>
<tbody>
<xsl:for-each select="Evenement">
<tr>
<td>
 <xsl:value-of select="Code/@V"/>
</td>
<td>
<xsl:value-of select="Description/@V"/>
&nbsp;
</td>
</tr>
</xsl:for-each>
</tbody>
</TABLE>

</xsl:template> 



</xsl:transform>	

