<?xml version="1.0" encoding="ISO-8859-1"?>
<!DOCTYPE xsl:stylesheet [
<!ENTITY nbsp "&#160;">
]>
<xsl:transform
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:xs="http://www.w3.org/2001/XMLSchema"
    xmlns:java="xalan://xml.apache.org/xalan/java"
    xmlns:fn="http://projets.admisource.gouv.fr/xemelios/namespaces#functions"
    xmlns:added="http://projets.admisource.gouv.fr/xemelios/namespaces#added"
    xmlns:ano="http://projets.admisource.gouv.fr/xemelios/namespaces#anomally"
    xmlns:n="http://www.minefi.gouv.fr/cp/helios/pes_v2/Rev0/aller"    
    exclude-result-prefixes="fn java" version="2.0">
    
    <xsl:output method="xml" indent="yes" standalone="yes"/>
    
    <!--xsl:output encoding="##output-encoding##"/>
    <xsl:output version="##xml-version##"/-->
    
    <xsl:output encoding="ISO-8859-1"/>
        <xsl:output version="1.0"/>
    
    <xsl:param name="language" select="'fr'"/>
    
    <xsl:variable name="postes">
        <poste code="0800610">TRESORERIE ABBEVILLE ET BANLIEUE</poste>
        <poste code="0800580">TRESORERIE ABBEVILLE MUNICIPALE</poste>
        <poste code="1220000">TRESORERIE AMBASSADE DE FRANCE EN COTE-D'IVOIRE</poste>
        <poste code="0740010">TRESORERIE ABONDANCE</poste>
        <poste code="0800010">TRESORERIE ACHEUX-EN-AMIENOIS</poste>
        <poste code="0340330">TRESORERIE AGDE</poste>
        <poste code="0470000">TRESORERIE GENERALE DE LOT-ET-GARONNE</poste>
        <poste code="0470010">TRESORERIE AGEN</poste>
        <poste code="0470350">TRESORERIE OPAC DE LOT-ET-GARONNE</poste>
        <poste code="0470900">PAIERIE DEPARTEMENTALE DE LOT-ET-GARONNE</poste>
        <poste code="0470020">TRESORERIE AGEN ETABLISSEMENTS HOSPITALIERS</poste>
        <poste code="0470120">TRESORERIE DE PUYMIROL-LAPLUME</poste>
        <poste code="0470140">TRESORERIE D' AGEN MUNICIPALE</poste>
        <poste code="0500200">TRESORERIE SAINT-MALO-DE-LA-LANDE</poste>
        <poste code="0230010">TRESORERIE AHUN</poste>
        <poste code="0160010">TRESORERIE AIGRE</poste>
        <poste code="0170010">TRESORERIE AIGREFEUILLE-D'AUNIS</poste>
        <poste code="0440010">TRESORERIE AIGREFEUILLE-SUR-MAINE</poste>
        <poste code="0730010">TRESORERIE AIGUEBELLE</poste>
        <poste code="0630590">TRESORERIE AIGUEPERSE</poste>
        <poste code="0300010">TRESORERIE AIGUES-MORTES</poste>
        <poste code="0470030">TRESORERIE AIGUILLON</poste>
        <poste code="0890010">TRESORERIE AILLANT-SUR-THOLON-GUERCHY</poste>
        <poste code="0800020">TRESORERIE AILLY-SUR-NOYE</poste>
        <poste code="0730020">TRESORERIE AIME</poste>
        <poste code="0400010">TRESORERIE AIRE-SUR-L'ADOUR</poste>
        <poste code="0622250">TRESORERIE D' AIRE-SUR-LA-LYS</poste>
        <poste code="0790020">TRESORERIE AIRVAULT-VALLEE DU THOUET</poste>
        <poste code="0100010">TRESORERIE D' AIX-EN-OTHE</poste>
        <poste code="0131000">RECETTE DES FINANCES AIX-EN-PROVENCE</poste>
        <poste code="0131010">TRESORERIE AIX-EN-PROVENCE SUD</poste>
        <poste code="0131020">TRESORERIE D' AIX-EN-PROVENCE NORD</poste>
        <poste code="0131030">TRESORERIE D' AIX-EN-PROVENCE MUNICIPALE</poste>
        <poste code="0131040">TRESORERIE AIX-EN-PROVENCE ETS HOSPITALIERS</poste>
        <poste code="0730030">TRESORERIE AIX-LES-BAINS</poste>
        <poste code="0870010">TRESORERIE AIXE-SUR-VIENNE</poste>
        <poste code="02A0000">TRESORERIE GENERALE DE LA CORSE-DU-SUD</poste>
        <poste code="02A0007">CENTRE REGIONAL DES PENSIONS DE LA CORSE-DU-SUD</poste>
        <poste code="02A0009">DEPARTEMENT INFORMATIQUE DE LA CORSE-DU-SUD</poste>
        <poste code="02A0010">TRESORERIE AJACCIO</poste>
        <poste code="02A0020">TRESORERIE AJACCIO MUNICIPALE</poste>
        <poste code="02A0030">TRESORERIE AJACCIO RURAL</poste>
        <poste code="02A0800">PAIERIE REGIONALE DE CORSE</poste>
        <poste code="02A0900">PAIERIE DEPARTEMENTALE DE LA CORSE-DU-SUD</poste>
        <poste code="0810010">TRESORERIE ALBAN</poste>
        <poste code="0730040">TRESORERIE ALBENS</poste>
        <poste code="0800490">TRESORERIE ALBERT</poste>
        <poste code="0730050">TRESORERIE D' ALBERTVILLE</poste>
        <poste code="0570010">TRESORERIE ALBESTROFF</poste>
        <poste code="0810020">TRESORERIE ALBI TRESOR</poste>
        <poste code="0810000">TRESORERIE GENERALE DU TARN</poste>
        <poste code="0810030">TRESORERIE ALBI-VILLE ET PERIPHERIE</poste>
        <poste code="0810900">PAIERIE DEPARTEMENTALE DU TARN</poste>
        <poste code="0690360">TRESORERIE ALBIGNY-SUR-SAONE ETS HOSP. DPTX</poste>
        <poste code="0610000">TRESORERIE GENERALE DE L' ORNE</poste>
        <poste code="0610020">TRESORERIE D' ALENCON VILLE ET CAMPAGNE</poste>
        <poste code="0610040">TRESORERIE ALENCON HOPITAUX</poste>
        <poste code="0610900">PAIERIE DEPARTEMENTALE DE L' ORNE</poste>
        <poste code="02B0120">TRESORERIE MOITA</poste>
        <poste code="0300430">TRESORERIE ALES MUNICIPALE</poste>
        <poste code="0940010">TRESORERIE MALE ALFORTVILLE/MAISONS-ALFORT</poste>
        <poste code="1110000">TRESORERIE AMBASSADE DE FRANCE A ALGER</poste>
        <poste code="0570020">TRESORERIE ALGRANGE</poste>
        <poste code="0560010">TRESORERIE ALLAIRE</poste>
        <poste code="0150010">TRESORERIE ALLANCHE</poste>
        <poste code="0190220">TRESORERIE ALLASSAC</poste>
        <poste code="0130010">TRESORERIE ALLAUCH</poste>
        <poste code="0380020">TRESORERIE ALLEVARD</poste>
        <poste code="0490310">TRESORERIE ALLONNES</poste>
        <poste code="0681010">TRESORERIE ALTKIRCH</poste>
        <poste code="0110030">TRESORERIE ALZONNE</poste>
        <poste code="0700010">TRESORERIE AMANCE-FAVERNEY</poste>
        <poste code="0250010">TRESORERIE D' AMANCEY</poste>
        <poste code="0330010">TRESORERIE AMBARES-ET-LAGRAVE</poste>
        <poste code="0870020">TRESORERIE AMBAZAC</poste>
        <poste code="0010010">TRESORERIE D' AMBERIEU-EN-BUGEY</poste>
        <poste code="0630480">TRESORERIE D' AMBERT</poste>
        <poste code="0370010">TRESORERIE AMBOISE-POCE</poste>
        <poste code="0530010">TRESORERIE AMBRIERES-LES-VALLEES</poste>
        <poste code="0800040">TRESORERIE AMIENS CENTRE</poste>
        <poste code="0800000">TRESORERIE GENERALE DE LA SOMME</poste>
        <poste code="0800007">CENTRE REGIONAL DES PENSIONS DE LA SOMME</poste>
        <poste code="0800008">CENTRE DE FORMATION DEPARTEMENTAL DE LA SOMME</poste>
        <poste code="0800009">DEPARTEMENT INFORMATIQUE DE LA SOMME</poste>
        <poste code="0800060">TRESORERIE AMIENS BANLIEUE ET AMENDES</poste>
        <poste code="0800070">TRESORERIE AMIENS MUNICIPALE</poste>
        <poste code="0800900">PAIERIE DEPARTEMENTALE DE LA SOMME</poste>
        <poste code="0800080">TRESORERIE AMIENS ETS HOSP.</poste>
        <poste code="0800800">PAIERIE REGIONALE DE PICARDIE</poste>
        <poste code="0800001">SERVICE CONTRLE REDEVANCE AUDIOVISUELLE DE LA SOMME</poste>
        <poste code="0400200">TRESORERIE AMOU-POMAREZ</poste>
        <poste code="0690460">TRESORERIE AMPLEPUIS</poste>
        <poste code="0440020">TRESORERIE ANCENIS</poste>
        <poste code="0550010">TRESORERIE D' ANCERVILLE</poste>
        <poste code="0890020">TRESORERIE ANCY-LE-FRANC</poste>
        <poste code="0520010">TRESORERIE ANDELOT-BLANCHEVILLE</poste>
        <poste code="0300440">TRESORERIE ANDUZE</poste>
        <poste code="0280320">TRESORERIE ANET</poste>
        <poste code="0490000">TRESORERIE GENERALE DE MAINE-ET-LOIRE</poste>
        <poste code="0490020">TRESORERIE ANGERS OUEST</poste>
        <poste code="0490030">TRESORERIE ANGERS MUNICIPALE</poste>
        <poste code="0490040">TRESORERIE ANGERS CHU</poste>
        <poste code="0490001">SERVICE CONTRLE REDEVANCE AUDIOVISUELLE DU MAINE ET LOIRE</poste>
        <poste code="0490010">TRESORERIE ANGERS EST ET AMENDES</poste>
        <poste code="0490060">TRESORERIE D' AVRILLE</poste>
        <poste code="0490900">PAIERIE DEPARTEMENTALE DE MAINE-ET-LOIRE</poste>
        <poste code="0850280">TRESORERIE ANGLES</poste>
        <poste code="0640470">TRESORERIE ANGLET-ADOUR-OCEAN</poste>
        <poste code="0510300">TRESORERIE ANGLURE</poste>
        <poste code="0160000">TRESORERIE GENERALE DE LA CHARENTE</poste>
        <poste code="0160001">TRESORERIE GENERALE SERVICE DES AFFAIRES COMMUNALES</poste>
        <poste code="0160002">TRESORERIE GENERALE CONTROLE FINANCIER LOCAL</poste>
        <poste code="0160003">TRESORERIE GENERALE ACTION ECONOMIQUE</poste>
        <poste code="0160020">TRESORERIE ANGOULEME</poste>
        <poste code="0160030">TRESORERIE ANGOULEME MUNICIPALE</poste>
        <poste code="0160150">TRESORERIE ANGOULEME OPHLM</poste>
        <poste code="0160900">PAIERIE DEPARTEMENTALE DE LA CHARENTE</poste>
        <poste code="0593010">TRESORERIE ANICHE</poste>
        <poste code="0020010">TRESORERIE ANIZY-LE-CHATEAU</poste>
        <poste code="0740030">TRESORERIE ANNECY</poste>
        <poste code="0740040">TRESORERIE ANNECY MUNICIPALE</poste>
        <poste code="0740900">PAIERIE DEPARTEMENTALE DE LA HAUTE-SAVOIE</poste>
        <poste code="0740001">SERVICE CONTRLE REDEVANCE AUDIOVISUELLE DE LA HAUTE SAVOIE</poste>
        <poste code="0740320">TRESORERIE ANNECY LE VIEUX</poste>
        <poste code="0740000">TRESORERIE GENERALE DE LA HAUTE-SAVOIE</poste>
        <poste code="0740050">TRESORERIE ANNEMASSE</poste>
        <poste code="0590020">TRESORERIE ANNOEULLIN</poste>
        <poste code="0070020">TRESORERIE ANNONAY</poste>
        <poste code="0040010">TRESORERIE D' ANNOT</poste>
        <poste code="1410000">TRESORERIE AMBASSADE DE FRANCE EN REPUBLIQUE DE MADAGASCAR</poste>
        <poste code="0061010">TRESORERIE ANTIBES</poste>
        <poste code="0061020">TRESORERIE ANTIBES MUNICIPALE</poste>
        <poste code="0921010">TRESORERIE D' ANTONY</poste>
        <poste code="0921000">RECETTE DES FINANCES ANTONY</poste>
        <poste code="0070040">TRESORERIE ANTRAIGUES</poste>
        <poste code="0350010">TRESORERIE D' ANTRAIN-SAINT BRICE</poste>
        <poste code="0595010">TRESORERIE D' ANZIN</poste>
        <poste code="0840010">TRESORERIE APT</poste>
        <poste code="0300030">TRESORERIE ARAMON</poste>
        <poste code="0390020">TRESORERIE ARBOIS</poste>
        <poste code="0520020">TRESORERIE D' ARC-EN-BARROIS</poste>
        <poste code="0330020">TRESORERIE D' ARCACHON</poste>
        <poste code="0100020">TRESORERIE D' ARCIS-SUR-AUBE</poste>
        <poste code="0360020">TRESORERIE ARDENTES</poste>
        <poste code="0630010">TRESORERIE ARDES-SUR-COUZE</poste>
        <poste code="0622260">TRESORERIE ARDRES-EPERLECQUES</poste>
        <poste code="0650020">TRESORERIE ARGELES-GAZOST</poste>
        <poste code="0660010">TRESORERIE ARGELES-SUR-MER</poste>
        <poste code="0610290">TRESORERIE D' ARGENTAN</poste>
        <poste code="0190010">TRESORERIE ARGENTAT</poste>
        <poste code="0950010">TRESORERIE ARGENTEUIL HLM</poste>
        <poste code="0950020">TRESORERIE ARGENTEUIL</poste>
        <poste code="0950030">TRESORERIE ARGENTEUIL MUNICIPALE</poste>
        <poste code="0950040">TRESORERIE ARGENTEUIL CENTRE HOSPITALIER</poste>
        <poste code="0790030">TRESORERIE D' ARGENTON LES VALLES</poste>
        <poste code="0360030">TRESORERIE D' ARGENTON-SUR-CREUSE</poste>
        <poste code="0350020">TRESORERIE ARGENTRE-DU-PLESSIS</poste>
        <poste code="0390040">TRESORERIE D' ARINTHOD</poste>
        <poste code="0630490">TRESORERIE D' ARLANC</poste>
        <poste code="0132000">RECETTE DES FINANCES ARLES</poste>
        <poste code="0132010">TRESORERIE ARLES MUNICIPALE ET CAMARGUE</poste>
        <poste code="0132030">TRESORERIE ARLES CENTRE HOSPITALIER</poste>
        <poste code="0132130">TRESORERIE PAYS D'ARLES</poste>
        <poste code="0660020">TRESORERIE ARLES-SUR-TECH</poste>
        <poste code="0593020">TRESORERIE ARLEUX</poste>
        <poste code="0590030">TRESORERIE D' ARMENTIERES</poste>
        <poste code="0590040">TRESORERIE ARMENTIERES MUNICIPALE</poste>
        <poste code="0210490">TRESORERIE ARNAY-LE-DUC</poste>
        <poste code="0911010">TRESORERIE ARPAJON</poste>
        <poste code="0622270">TRESORERIE D' ARQUES</poste>
        <poste code="0620490">TRESORERIE ARRAS CENTRE HOSPITALIER</poste>
        <poste code="0620000">TRESORERIE GENERALE DU PAS-DE-CALAIS</poste>
        <poste code="0620030">TRESORERIE D' ARRAS</poste>
        <poste code="0620040">TRESORERIE ARRAS MUNICIPALE</poste>
        <poste code="0620420">TRESORERIE D' ARRAS BANLIEUE</poste>
        <poste code="0620900">PAIERIE DEPARTEMENTALE DU PAS-DE-CALAIS</poste>
        <poste code="0650030">TRESORERIE D' ARREAU-BORDERES-LOURON</poste>
        <poste code="0570030">TRESORERIE ARS-SUR-MOSELLE</poste>
        <poste code="0010440">TRESORERIE D' ARTEMARE</poste>
        <poste code="0450010">TRESORERIE ARTENAY</poste>
        <poste code="0640040">TRESORERIE ARUDY</poste>
        <poste code="0640050">TRESORERIE ARZACQ-MORLANNE</poste>
        <poste code="0080010">TRESORERIE ASFELD</poste>
        <poste code="0920020">TRESORERIE ASNIERES-SUR-SEINE</poste>
        <poste code="0920030">TRESORERIE D' ASNIERES-SUR-SEINE MUNICIPALE</poste>
        <poste code="0310450">TRESORERIE ASPET</poste>
        <poste code="0610300">TRESORERIE ATHIS-DE-L'ORNE</poste>
        <poste code="0911020">TRESORERIE ATHIS-MONS</poste>
        <poste code="0600450">TRESORERIE ATTICHY</poste>
        <poste code="0080020">TRESORERIE ATTIGNY-TOURTERON</poste>
        <poste code="0130020">TRESORERIE AUBAGNE</poste>
        <poste code="0070050">TRESORERIE AUBENAS</poste>
        <poste code="0931010">TRESORERIE D' AUBERVILLIERS</poste>
        <poste code="0931020">TRESORERIE AUBERVILLIERS MUNICIPALE</poste>
        <poste code="0160050">TRESORERIE AUBETERRE-SUR-DRONNE</poste>
        <poste code="0620050">TRESORERIE AUBIGNY-EN-ARTOIS</poste>
        <poste code="0180030">TRESORERIE D' AUBIGNY-SUR-NERE</poste>
        <poste code="0120250">TRESORERIE AUBIN</poste>
        <poste code="0230190">TRESORERIE D' AUBUSSON - ST SULPICE LES CHAMPS</poste>
        <poste code="0310420">TRESORERIE AUCAMVILLE</poste>
        <poste code="0320000">TRESORERIE GENERALE DU GERS</poste>
        <poste code="0320900">PAIERIE DEPARTEMENTALE DU GERS</poste>
        <poste code="0320020">TRESORERIE AUCH VILLE</poste>
        <poste code="0320030">TRESORERIE AUCH BANLIEUE</poste>
        <poste code="0620590">TRESORERIE AUCHEL</poste>
        <poste code="0330030">TRESORERIE AUDENGE</poste>
        <poste code="0250340">TRESORERIE AUDINCOURT</poste>
        <poste code="0622280">TRESORERIE AUDRUICQ</poste>
        <poste code="0540390">TRESORERIE D' AUDUN-LE-ROMAN - PIENNES</poste>
        <poste code="0570040">TRESORERIE AUDUN-LE-TICHE</poste>
        <poste code="0170020">TRESORERIE AULNAY-DE-SAINTONGE-NERE</poste>
        <poste code="0930030">TRESORERIE D' AULNAY-SOUS-BOIS</poste>
        <poste code="0800590">TRESORERIE AULT</poste>
        <poste code="0760670">TRESORERIE D' AUMALE</poste>
        <poste code="0140030">TRESORERIE AUNAY-SUR-ODON</poste>
        <poste code="0280010">TRESORERIE AUNEAU</poste>
        <poste code="0600020">TRESORERIE AUNEUIL</poste>
        <poste code="0831020">TRESORERIE AUPS</poste>
        <poste code="0560250">TRESORERIE AURAY</poste>
        <poste code="0310460">TRESORERIE AURIGNAC</poste>
        <poste code="0150030">TRESORERIE AURILLAC BANLIEUE</poste>
        <poste code="0150000">TRESORERIE GENERALE DU CANTAL</poste>
        <poste code="0150020">TRESORERIE D' AURILLAC</poste>
        <poste code="0150900">PAIERIE DEPARTEMENTALE DU CANTAL</poste>
        <poste code="0310550">TRESORERIE D' AUTERIVE</poste>
        <poste code="0280020">TRESORERIE AUTHON/PERCHE-LA-BAZOCHE-GOUET</poste>
        <poste code="0710580">TRESORERIE D' AUTUN</poste>
        <poste code="0890000">TRESORERIE GENERALE DE L' YONNE</poste>
        <poste code="0890030">TRESORERIE D' AUXERRE</poste>
        <poste code="0890040">TRESORERIE AUXERRE ETS HOSP.</poste>
        <poste code="0890900">PAIERIE DEPARTEMENTALE DE L' YONNE</poste>
        <poste code="0210040">TRESORERIE AUXONNE</poste>
        <poste code="0230200">TRESORERIE D' AUZANCES</poste>
        <poste code="0860010">TRESORERIE D' AVAILLES-LIMOUZINE</poste>
        <poste code="0890060">TRESORERIE D' AVALLON</poste>
        <poste code="0620070">TRESORERIE D' AVESNES LE COMTE</poste>
        <poste code="0593110">TRESORERIE AVESNES-LEZ-AUBERT</poste>
        <poste code="0595170">TRESORERIE D' AVESNES-SUR-HELPE</poste>
        <poste code="0840000">TRESORERIE GENERALE DE VAUCLUSE</poste>
        <poste code="0840030">TRESORERIE D' AVIGNON</poste>
        <poste code="0840050">TRESORERIE AVIGNON MUNICIPALE</poste>
        <poste code="0840060">TRESORERIE AVIGNON CENTRE HOSPITALIER</poste>
        <poste code="0840900">PAIERIE DEPARTEMENTALE DE VAUCLUSE</poste>
        <poste code="0840001">SERVICE CONTRLE REDEVANCE AUDIOVISUELLE DU VAUCLUSE</poste>
        <poste code="0620080">TRESORERIE AVION</poste>
        <poste code="0510310">TRESORERIE D' AVIZE</poste>
        <poste code="0770330">TRESORERIE AVON</poste>
        <poste code="0500240">TRESORERIE AVRANCHES</poste>
        <poste code="0090020">TRESORERIE AX-LES-THERMES</poste>
        <poste code="0110040">TRESORERIE AXAT</poste>
        <poste code="0510320">TRESORERIE D' AY</poste>
        <poste code="0370020">TRESORERIE AZAY-LE-RIDEAU</poste>
        <poste code="0540300">TRESORERIE DE BACCARAT-BADONVILLER</poste>
        <poste code="0760530">TRESORERIE BACQUEVILLE-EN-CAUX</poste>
        <poste code="0650050">TRESORERIE BAGNERES-DE-BIGORRE-CAMPAN</poste>
        <poste code="0310470">TRESORERIE BAGNERES-DE-LUCHON</poste>
        <poste code="0921020">TRESORERIE BAGNEUX</poste>
        <poste code="0930040">TRESORERIE BAGNOLET</poste>
        <poste code="0300040">TRESORERIE BAGNOLS-SUR-CEZE</poste>
        <poste code="1010080">TRESORERIE PETIT-BOURG</poste>
        <poste code="0160070">TRESORERIE BAIGNES-SAINTE-RADEGONDE</poste>
        <poste code="0594170">TRESORERIE BAILLEUL</poste>
        <poste code="0350030">TRESORERIE BAIN-DE-BRETAGNE</poste>
        <poste code="0880010">TRESORERIE BAINS-LES-BAINS</poste>
        <poste code="0422050">TRESORERIE BALBIGNY</poste>
        <poste code="0720020">TRESORERIE DE BALLON-MONTBIZOT</poste>
        <poste code="0310310">TRESORERIE BALMA</poste>
        <poste code="0310001">SERVICE CONTRLE REDEVANCE AUDIOVISUELLE DE HAUTE GARONNE</poste>
        <poste code="0310002">ANNEXE PLE INTERRGIONAL APUREMENT SPL</poste>
        <poste code="1280000">TRESORERIE AMBASSADE DE FRANCE AU MALI</poste>
        <poste code="0292020">TRESORERIE BANNALEC</poste>
        <poste code="0040020">TRESORERIE BANON ET SAINT-ETIENNE</poste>
        <poste code="0620090">TRESORERIE DE BAPAUME</poste>
        <poste code="0550000">TRESORERIE GENERALE DE LA MEUSE</poste>
        <poste code="0550030">TRESORERIE DE BAR-LE-DUC VILLE</poste>
        <poste code="0550210">TRESORERIE DU PAYS DE REVIGNY-OPAC DE LA MEUSE</poste>
        <poste code="0550900">PAIERIE DEPARTEMENTALE DE LA MEUSE</poste>
        <poste code="0100040">TRESORERIE DE BAR-SUR-AUBE</poste>
        <poste code="0100060">TRESORERIE DE BAR-SUR-SEINE</poste>
        <poste code="0120240">TRESORERIE DE BARAQUEVILLE</poste>
        <poste code="0132040">TRESORERIE BARBENTANE</poste>
        <poste code="0160080">TRESORERIE BARBEZIEUX-SAINT-HILAIRE</poste>
        <poste code="0040030">TRESORERIE DE BARCELONNETTE</poste>
        <poste code="0760020">TRESORERIE DE BARENTIN</poste>
        <poste code="0500250">TRESORERIE BARENTON-LE TEILLEUL</poste>
        <poste code="0300450">TRESORERIE DE BARJAC</poste>
        <poste code="0831030">TRESORERIE BARJOLS-TAVERNES</poste>
        <poste code="0500380">TRESORERIE DE BARNEVILLE-PORTBAIL</poste>
        <poste code="0670010">TRESORERIE BARR</poste>
        <poste code="0430030">TRESORERIE BAS-EN-BASSET</poste>
        <poste code="1030010">TRESORERIE BASSE-POINTE</poste>
        <poste code="1010000">TRESORERIE GENERALE DE LA GUADELOUPE</poste>
        <poste code="1010020">TRESORERIE DE BASSE-TERRE</poste>
        <poste code="1010800">PAIERIE REGIONALE DE LA GUADELOUPE</poste>
        <poste code="1010900">PAIERIE DEPARTEMENTALE DE LA GUADELOUPE</poste>
        <poste code="1010130">TRESORERIE DE BASSE-TERRE MUNCIPALE ET HOSPIT.</poste>
        <poste code="02B0000">TRESORERIE GENERALE DE LA HAUTE-CORSE</poste>
        <poste code="02B0010">TRESORERIE BASTIA</poste>
        <poste code="02B0020">TRESORERIE DE BASTIA MUNICIPALE</poste>
        <poste code="02B0900">PAIERIE DEPARTEMENTALE DE LA HAUTE-CORSE</poste>
        <poste code="0560200">TRESORERIE BAUD</poste>
        <poste code="0490320">TRESORERIE BAUGE</poste>
        <poste code="0180040">TRESORERIE BAUGY-SAVIGNY-EN-SEPTAINE</poste>
        <poste code="0250020">TRESORERIE BAUME-LES-DAMES</poste>
        <poste code="0595180">TRESORERIE BAVAY</poste>
        <poste code="0140050">TRESORERIE BAYEUX-MONCEAUX-EN-BESSIN</poste>
        <poste code="0640350">TRESORERIE BAYONNE</poste>
        <poste code="0640360">TRESORERIE BAYONNE MUNICIPALE</poste>
        <poste code="0640480">TRESORERIE BAYONNE CENTRE HOSPITALIER</poste>
        <poste code="0330050">TRESORERIE BAZAS</poste>
        <poste code="0310030">TRESORERIE MONTGISCARD-BAZIEGE</poste>
        <poste code="0300050">TRESORERIE BEAUCAIRE</poste>
        <poste code="0950240">TRESORERIE DE BEAUCHAMP-TAVERNY</poste>
        <poste code="0390050">TRESORERIE DE BEAUFORT</poste>
        <poste code="0490070">TRESORERIE BEAUFORT-EN-VALLEE</poste>
        <poste code="0730060">TRESORERIE BEAUFORT</poste>
        <poste code="0450030">TRESORERIE BEAUGENCY</poste>
        <poste code="0690470">TRESORERIE BEAUJEU</poste>
        <poste code="0190230">TRESORERIE BEAULIEU-SUR-DORDOGNE</poste>
        <poste code="0820020">TRESORERIE BEAUMONT-LAVIT-DE-LOMAGNE</poste>
        <poste code="0500390">TRESORERIE BEAUMONT-HAGUE</poste>
        <poste code="0270180">TRESORERIE BEAUMONT-LE-ROGER</poste>
        <poste code="0950050">TRESORERIE BEAUMONT-SUR-OISE</poste>
        <poste code="0720040">TRESORERIE BEAUMONT-SUR-SARTHE</poste>
        <poste code="0210510">TRESORERIE BEAUNE</poste>
        <poste code="0450310">TRESORERIE DE BEAUNE-LA-ROLANDE</poste>
        <poste code="0490420">TRESORERIE BEAUPREAU</poste>
        <poste code="0381010">TRESORERIE BEAUREPAIRE</poste>
        <poste code="0020320">TRESORERIE BEAURIEUX-ROUCY-CORBENY</poste>
        <poste code="0550050">TRESORERIE DE BEAUSITE</poste>
        <poste code="0060010">TRESORERIE BEAUSOLEIL</poste>
        <poste code="0600000">TRESORERIE GENERALE DE L' OISE</poste>
        <poste code="0600040">TRESORERIE DE BEAUVAIS VILLE</poste>
        <poste code="0600050">TRESORERIE DE BEAUVAIS BANLIEUE</poste>
        <poste code="0600070">TRESORERIE DE BEAUVAIS MUNICIPALE</poste>
        <poste code="0600900">PAIERIE DEPARTEMENTALE DE L' OISE</poste>
        <poste code="0600580">TRESORERIE DE BEAUVAIS AMENDES</poste>
        <poste code="0600001">SERVICE CONTRLE REDEVANCE AUDIOVISUELLE DE L' OISE</poste>
        <poste code="0850290">TRESORERIE BEAUVOIR-SUR-MER</poste>
        <poste code="0790050">TRESORERIE BEAUVOIR-SUR-NIORT</poste>
        <poste code="0350050">TRESORERIE BECHEREL</poste>
        <poste code="0340340">TRESORERIE DE BEDARIEUX</poste>
        <poste code="0640060">TRESORERIE BEDOUS</poste>
        <poste code="0220320">TRESORERIE BEGARD</poste>
        <poste code="0330060">TRESORERIE BEGLES</poste>
        <poste code="0110060">TRESORERIE BELCAIRE-RODOME</poste>
        <poste code="0900000">TRESORERIE GENERALE DU TERRITOIRE-DE-BELFORT</poste>
        <poste code="0900040">TRESORERIE BELFORT VILLE</poste>
        <poste code="0900110">TRESORERIE BELFORT TERRITOIRE HABITAT</poste>
        <poste code="0900120">TRESORERIE DE BELFORT ETS. HOSPITALIERS</poste>
        <poste code="0900900">PAIERIE DEPARTEMENTALE DU TERRITOIRE-DE-BELFORT</poste>
        <poste code="0900020">TRESORERIE DE BELFORT</poste>
        <poste code="0330070">TRESORERIE DE BELIN-BELIET</poste>
        <poste code="0870030">TRESORERIE DE BELLAC</poste>
        <poste code="0230210">TRESORERIE DE BELLEGARDE-EN-MARCHE</poste>
        <poste code="0010020">TRESORERIE BELLEGARDE-SUR-VALSERINE</poste>
        <poste code="0610070">TRESORERIE BELLEME</poste>
        <poste code="0760540">TRESORERIE BELLENCOMBRE</poste>
        <poste code="0030140">TRESORERIE BELLERIVE-SUR-ALLIER</poste>
        <poste code="0020470">TRESORERIE DE BELLEU-SOISSONS BANLIEUE</poste>
        <poste code="0690480">TRESORERIE BELLEVILLE</poste>
        <poste code="0010030">TRESORERIE BELLEY</poste>
        <poste code="0422010">TRESORERIE BELMONT-DE-LA-LOIRE</poste>
        <poste code="0120260">TRESORERIE DE RANCE ET ROUGIERS</poste>
        <poste code="0110070">TRESORERIE BELPECH</poste>
        <poste code="0240020">TRESORERIE BELVES</poste>
        <poste code="0110080">TRESORERIE BELVEZE-DU-RAZES</poste>
        <poste code="0230020">TRESORERIE DE BENEVENT L'ABBAYE-LE GRAND BOURG</poste>
        <poste code="0670030">TRESORERIE BENFELD</poste>
        <poste code="0622170">TRESORERIE DE BERCK</poste>
        <poste code="0240470">TRESORERIE BERGERAC MUNICIPALE ET BANLIEUE</poste>
        <poste code="0240590">TRESORERIE DE BERGERAC</poste>
        <poste code="0594010">TRESORERIE BERGUES</poste>
        <poste code="0595190">TRESORERIE BERLAIMONT</poste>
        <poste code="1830000">TRESORERIE AMBASSADE DE FRANCE EN ALLEMAGNE</poste>
        <poste code="0800670">TRESORERIE BERNAVILLE</poste>
        <poste code="0270190">TRESORERIE DE BERNAY</poste>
        <poste code="0131050">TRESORERIE BERRE-L'ETANG</poste>
        <poste code="0250000">TRESORERIE GENERALE DU DOUBS</poste>
        <poste code="0250007">CENTRE REGIONAL DES PENSIONS DU DOUBS</poste>
        <poste code="0250008">CENTRE DE FORMATION DEPARTEMENTAL DU DOUBS</poste>
        <poste code="0250009">DEPARTEMENT INFORMATIQUE DU DOUBS</poste>
        <poste code="0250030">TRESORERIE BESANCON</poste>
        <poste code="0250050">TRESORERIE DU GRAND BESANCON</poste>
        <poste code="0250060">TRESORERIE BESANCON CHRU</poste>
        <poste code="0250130">TRESORERIE MORRE-ROULANS</poste>
        <poste code="0250280">TRESORERIE BESANCON ETS HOSP. DPTAUX</poste>
        <poste code="0250800">PAIERIE REGIONALE DE FRANCHE-COMTE</poste>
        <poste code="0250900">PAIERIE DEPARTEMENTALE DOUBS</poste>
        <poste code="0250001">SERVICE CONTRLE REDEVANCE AUDIOVISUELLE DU DOUBS</poste>
        <poste code="0250006">PLE NATIONAL DE SOUTIEN AU RESEAU DE BESANCON - RJC</poste>
        <poste code="0250490">TRESORERIE DE L' OPDHLM DU DOUBS-HABITAT 25</poste>
        <poste code="0630020">TRESORERIE BESSE-ET-SAINT-ANASTAISE</poste>
        <poste code="0830020">TRESORERIE BESSE-SUR-ISSOLE</poste>
        <poste code="0300460">TRESORERIE BESSEGES</poste>
        <poste code="0870040">TRESORERIE DE BESSINES-SUR-GARTEMPE</poste>
        <poste code="0620600">TRESORERIE BETHUNE</poste>
        <poste code="0620610">TRESORERIE BETHUNE MUNICIPALE</poste>
        <poste code="0620620">TRESORERIE BEUVRY</poste>
        <poste code="0270200">TRESORERIE BEUZEVILLE</poste>
        <poste code="0190240">TRESORERIE BEYNAT</poste>
        <poste code="0340350">TRESORERIE BEZIERS</poste>
        <poste code="0340360">TRESORERIE BEZIERS MUNICIPALE</poste>
        <poste code="0340370">TRESORERIE DE BEZIERS ETS HOSP</poste>
        <poste code="0950300">TRESORERIE BEZONS</poste>
        <poste code="0640370">TRESORERIE BIARRITZ</poste>
        <poste code="0911030">TRESORERIE BIEVRES</poste>
        <poste code="0760040">TRESORERIE BIHOREL</poste>
        <poste code="0630030">TRESORERIE BILLOM-SAINT-DIER-D'AUVERGNE</poste>
        <poste code="0671010">TRESORERIE BISCHWILLER</poste>
        <poste code="0571010">TRESORERIE BITCHE</poste>
        <poste code="0310430">TRESORERIE BLAGNAC</poste>
        <poste code="0440350">TRESORERIE BLAIN</poste>
        <poste code="0760030">TRESORERIE BLAINVILLE-CREVON</poste>
        <poste code="0540330">TRESORERIE DE BAYON-BLAINVILLE-SUR-L'EAU</poste>
        <poste code="0540340">TRESORERIE DE BLAMONT - CIREY-SUR-VEZOUZE</poste>
        <poste code="0760550">TRESORERIE DE BLANGY-SUR-BRESLE</poste>
        <poste code="0330080">TRESORERIE BLANQUEFORT</poste>
        <poste code="0160090">TRESORERIE BLANZAC-PORCHERESSE</poste>
        <poste code="0330700">TRESORERIE BLAYE</poste>
        <poste code="0890070">TRESORERIE BLENEAU-SAINT-FARGEAU</poste>
        <poste code="0370030">TRESORERIE BLERE</poste>
        <poste code="0390060">TRESORERIE BLETTERANS</poste>
        <poste code="0210520">TRESORERIE BLIGNY-SUR-OUCHE</poste>
        <poste code="0680010">TRESORERIE BLODELSHEIM</poste>
        <poste code="0410000">TRESORERIE GENERALE DE LOIR-ET-CHER</poste>
        <poste code="0410030">TRESORERIE BLOIS MUNICIPALE</poste>
        <poste code="0410360">TRESORERIE OPAC.DE.LOIR.ET.CHER</poste>
        <poste code="0410900">PAIERIE DEPARTEMENTALE DE LOIR-ET-CHER</poste>
        <poste code="0410010">TRESORERIE BLOIS VILLE</poste>
        <poste code="0930000">TRESORERIE GENERALE DE LA SEINE-SAINT-DENIS</poste>
        <poste code="0930009">DEPARTEMENT INFORMATIQUE DE LA SEINE-SAINT-DENIS</poste>
        <poste code="0930320">TRESORERIE DE BOBIGNY MUNICIPALE</poste>
        <poste code="0930900">PAIERIE DEPARTEMENTALE DE LA SEINE-SAINT-DENIS</poste>
        <poste code="0930001">SERVICE CONTRLE REDEVANCE AUDIOVISUELLE DE LA SEINE SAINT DENIS</poste>
        <poste code="0740080">TRESORERIE BOEGE</poste>
        <poste code="0422180">TRESORERIE DE BOEN SUR LIGNON</poste>
        <poste code="0020520">TRESORERIE BOHAIN-EN-VERMANDOIS</poste>
        <poste code="0920050">TRESORERIE DE BOIS-COLOMBES</poste>
        <poste code="0940020">TRESORERIE DE BOISSY-SAINT-LEGER</poste>
        <poste code="0762020">TRESORERIE BOLBEC</poste>
        <poste code="0840200">TRESORERIE BOLLENE-MONDRAGON</poste>
        <poste code="0930060">TRESORERIE DE BONDY</poste>
        <poste code="0930400">TRESORERIE DE BONDY MUNICIPALE</poste>
        <poste code="02A0040">TRESORERIE BONIFACIO</poste>
        <poste code="0230030">TRESORERIE BONNAT-LOURDOUEIX-SAINT-PIERRE</poste>
        <poste code="0860390">TRESORERIE VOUNEUIL-SUR-VIENNE</poste>
        <poste code="0280080">TRESORERIE BONNEVAL</poste>
        <poste code="0740090">TRESORERIE BONNEVILLE</poste>
        <poste code="0781010">TRESORERIE BONNIERES-SUR-SEINE</poste>
        <poste code="0330000">TRESORERIE GENERALE DE LA GIRONDE</poste>
        <poste code="0330007">CENTRE REGIONAL DES PENSIONS DE LA GIRONDE</poste>
        <poste code="0330008">CENTRE DE FORMATION DEPARTEMENTAL DE LA GIRONDE</poste>
        <poste code="0330009">DEPARTEMENT INFORMATIQUE DE LA GIRONDE</poste>
        <poste code="0330170">RECETTE DES FINANCES BORDEAUX MUNICIPALE</poste>
        <poste code="0330181">TRESORERIE DE BORDEAUX CHU ANNEXE CH PERRENS</poste>
        <poste code="0330800">PAIERIE REGIONALE D'AQUITAINE</poste>
        <poste code="0330900">PAIERIE DEPARTEMENTALE DE LA GIRONDE</poste>
        <poste code="0330001">SERVICE CONTRLE REDEVANCE AUDIOVISUELLE DE LA GIRONDE</poste>
        <poste code="0330006">PLE NATIONAL DE SOUTIEN AU RESEAU DE BORDEAUX</poste>
        <poste code="0330120">TRESORERIE BORDEAUX AMENDES</poste>
        <poste code="0330140">TRESORERIE DE BORDEAUX RIVE GAUCHE</poste>
        <poste code="0330160">TRESORERIE BORDEAUX EST</poste>
        <poste code="0330171">RECETTE DES FINANCES SERVICE DE LA COMMUNAUTE URBAINE</poste>
        <poste code="02B0040">TRESORERIE BORGO-CAMPILE</poste>
        <poste code="0190020">TRESORERIE BORT-LES-ORGUES</poste>
        <poste code="0440030">TRESORERIE DE BOUAYE</poste>
        <poste code="0595020">TRESORERIE BOUCHAIN</poste>
        <poste code="0100070">TRESORERIE DE BOUILLY</poste>
        <poste code="0571020">TRESORERIE BOULAY</poste>
        <poste code="0920060">TRESORERIE BOULOGNE-BILLANCOURT</poste>
        <poste code="0920070">TRESORERIE BOULOGNE-BILLANCOURT MUNICIPALE</poste>
        <poste code="0310480">TRESORERIE BOULOGNE-SUR-GESSE-BLAJAN</poste>
        <poste code="0622000">RECETTE DES FINANCES BOULOGNE-SUR-MER</poste>
        <poste code="0622020">TRESORERIE DE BOULOGNE-SUR-MER</poste>
        <poste code="0622030">TRESORERIE BOULOGNE-SUR-MER MUNICIPALE</poste>
        <poste code="0622040">TRESORERIE BOULOGNE-SUR-MER CTRE HOSP</poste>
        <poste code="0720070">TRESORERIE BOULOIRE-PARIGNE</poste>
        <poste code="0030010">TRESORERIE DE BOURBON-L'ARCHAMBAULT</poste>
        <poste code="0710020">TRESORERIE BOURBON-LANCY</poste>
        <poste code="0520300">TRESORERIE BOURBONNE-LES-BAINS</poste>
        <poste code="0594030">TRESORERIE BOURBOURG</poste>
        <poste code="0270370">TRESORERIE DE ROUTOT-BOURG-ACHARD</poste>
        <poste code="0420010">TRESORERIE DE BOURG-ARGENTAL</poste>
        <poste code="0010000">TRESORERIE GENERALE DE L' AIN</poste>
        <poste code="0010050">TRESORERIE DE BOURG-EN-BRESSE</poste>
        <poste code="0010060">TRESORERIE BOURG-EN-BRESSE MUNICIPALE</poste>
        <poste code="0010900">PAIERIE DEPARTEMENTALE DE L' AIN</poste>
        <poste code="0010001">CELLULE CONTRLE REDEVANCE AUDIOVISUELLE DE L' AIN</poste>
        <poste code="0630040">TRESORERIE DE BOURG-LASTIC-HERMENT</poste>
        <poste code="0660050">TRESORERIE BOURG-MADAME</poste>
        <poste code="0070080">TRESORERIE BOURG-SAINT-ANDEOL</poste>
        <poste code="0730070">TRESORERIE DE BOURG-SAINT-MAURICE</poste>
        <poste code="0330710">TRESORERIE BOURG SUR GIRONDE</poste>
        <poste code="0230040">TRESORERIE DE BOURGANEUF - PONTARION</poste>
        <poste code="0180050">TRESORERIE BOURGES</poste>
        <poste code="0180900">PAIERIE DEPARTEMENTALE DU CHER</poste>
        <poste code="0180060">TRESORERIE BOURGES MUNICIPALE</poste>
        <poste code="0180070">TRESORERIE DE BOURGES CH JACQUES COEUR</poste>
        <poste code="0180410">TRESORERIE BOURGES H.L.M</poste>
        <poste code="0180420">TRESORERIE DE BOURGES ETS SPECIALISES</poste>
        <poste code="0180000">TRESORERIE GENERALE DU CHER</poste>
        <poste code="0381100">TRESORERIE BOURGOIN-JALLIEU COLLECTIVITES</poste>
        <poste code="0381110">TRESORERIE BOURGOIN-JALLIEU</poste>
        <poste code="0270210">TRESORERIE DE BOURGTHEROULDE-INFREVILLE</poste>
        <poste code="0370050">TRESORERIE BOURGUEIL</poste>
        <poste code="0520040">TRESORERIE BOURMONT</poste>
        <poste code="0230050">TRESORERIE BOUSSAC</poste>
        <poste code="0671020">TRESORERIE BOUXWILLER</poste>
        <poste code="0571030">TRESORERIE BOUZONVILLE</poste>
        <poste code="0730080">TRESORERIE BOZEL</poste>
        <poste code="0120020">TRESORERIE BOZOULS</poste>
        <poste code="0410040">TRESORERIE BRACIEUX</poste>
        <poste code="0110400">TRESORERIE DE VILLASAVARY</poste>
        <poste code="0240030">TRESORERIE BRANTOME</poste>
        <poste code="0810190">TRESORERIE BRASSAC</poste>
        <poste code="0770300">TRESORERIE BRAY-SUR-SEINE</poste>
        <poste code="0800510">TRESORERIE BRAY-SUR-SOMME</poste>
        <poste code="0500260">TRESORERIE BRECEY-SAINT-POIS</poste>
        <poste code="0500010">TRESORERIE BREHAL-GAVRAY</poste>
        <poste code="0060020">TRESORERIE DE BREIL-SUR-ROYA</poste>
        <poste code="0600080">TRESORERIE BRESLES</poste>
        <poste code="0790070">TRESORERIE BRESSUIRE</poste>
        <poste code="0290200">TRESORERIE BREST BELLEVUE</poste>
        <poste code="0290000">TRESORERIE GENERALE DU FINISTERE</poste>
        <poste code="0290030">TRESORERIE DE BREST QUATRE-MOULINS</poste>
        <poste code="0290040">TRESORERIE BREST MUNICIPALE ET COM.URB</poste>
        <poste code="0290041">TRESORERIE ANNEXE OPAC</poste>
        <poste code="0290050">TRESORERIE BREST CHU</poste>
        <poste code="0290900">PAIERIE DEPARTEMENTALE D' FINISTERE</poste>
        <poste code="0290001">SERVICE CONTRLE REDEVANCE AUDIOVISUELLE DU FINISTERE</poste>
        <poste code="0460020">TRESORERIE DE BRETENOUX-VAYRAC</poste>
        <poste code="0600090">TRESORERIE DE BRETEUIL-CREVECOEUR-LE-GRAND</poste>
        <poste code="0270010">TRESORERIE BRETEUIL-SUR-ITON</poste>
        <poste code="0140090">TRESORERIE BRETTEVILLE-SUR-LAIZE</poste>
        <poste code="0280330">TRESORERIE BREZOLLES</poste>
        <poste code="0050030">TRESORERIE BRIANCON</poste>
        <poste code="0450320">TRESORERIE DE BRIARE</poste>
        <poste code="0500400">TRESORERIE BRICQUEBEC</poste>
        <poste code="0770010">TRESORERIE BRIE-COMTE-ROBERT</poste>
        <poste code="0100080">TRESORERIE DE BRIENNE-LE-CHATEAU</poste>
        <poste code="0890080">TRESORERIE DE BRIENON-SUR-ARMANCON</poste>
        <poste code="0540400">TRESORERIE DE BRIEY</poste>
        <poste code="0830030">TRESORERIE BRIGNOLES</poste>
        <poste code="0270220">TRESORERIE BRIONNE</poste>
        <poste code="0430050">TRESORERIE BRIOUDE</poste>
        <poste code="0790080">TRESORERIE BRIOUX-SUR-BOUTONNE</poste>
        <poste code="0490080">TRESORERIE BRISSAC-QUINCE</poste>
        <poste code="0190260">TRESORERIE BRIVE MUNICIPALE</poste>
        <poste code="0190330">TRESORERIE BRIVE VILLE</poste>
        <poste code="0690210">TRESORERIE LE VINATIER CTRE HOSP. SPEC</poste>
        <poste code="0690430">TRESORERIE DE BRON</poste>
        <poste code="0220230">TRESORERIE BROONS</poste>
        <poste code="0280100">TRESORERIE BROU</poste>
        <poste code="0620630">TRESORERIE BRUAY-LA BUISSIERE</poste>
        <poste code="0670060">TRESORERIE DE BRUMATH</poste>
        <poste code="0910050">TRESORERIE BRUNOY</poste>
        <poste code="0880040">TRESORERIE DE BRUYERES</poste>
        <poste code="0760060">TRESORERIE BUCHY</poste>
        <poste code="0190030">TRESORERIE BUGEAT</poste>
        <poste code="0260310">TRESORERIE DE BUIS-LES-BARONNIES</poste>
        <poste code="0880050">TRESORERIE BULGNEVILLE</poste>
        <poste code="0620640">TRESORERIE BULLY-LES-MINES</poste>
        <poste code="0170260">TRESORERIE BURIE</poste>
        <poste code="0860290">TRESORERIE POITIERS OPAC</poste>
        <poste code="0710470">TRESORERIE BUXY-SAINT-GENGOUX-LE-NATIONAL</poste>
        <poste code="0360060">TRESORERIE BUZANCAIS</poste>
        <poste code="0080070">TRESORERIE BUZANCY</poste>
        <poste code="0540300">TRESORERIE DE BACCARAT-BADONVILLER</poste>
        <poste code="0760530">TRESORERIE BACQUEVILLE-EN-CAUX</poste>
        <poste code="0650050">TRESORERIE BAGNERES-DE-BIGORRE-CAMPAN</poste>
        <poste code="0310470">TRESORERIE BAGNERES-DE-LUCHON</poste>
        <poste code="0921020">TRESORERIE BAGNEUX</poste>
        <poste code="0930040">TRESORERIE BAGNOLET</poste>
        <poste code="0300040">TRESORERIE BAGNOLS-SUR-CEZE</poste>
        <poste code="1010080">TRESORERIE PETIT-BOURG</poste>
        <poste code="0160070">TRESORERIE BAIGNES-SAINTE-RADEGONDE</poste>
        <poste code="0594170">TRESORERIE BAILLEUL</poste>
        <poste code="0350030">TRESORERIE BAIN-DE-BRETAGNE</poste>
        <poste code="0880010">TRESORERIE BAINS-LES-BAINS</poste>
        <poste code="0422050">TRESORERIE BALBIGNY</poste>
        <poste code="0720020">TRESORERIE DE BALLON-MONTBIZOT</poste>
        <poste code="0310310">TRESORERIE BALMA</poste>
        <poste code="0310001">SERVICE CONTRLE REDEVANCE AUDIOVISUELLE DE HAUTE GARONNE</poste>
        <poste code="0310002">ANNEXE PLE INTERRGIONAL APUREMENT SPL</poste>
        <poste code="1280000">TRESORERIE AMBASSADE DE FRANCE AU MALI</poste>
        <poste code="0292020">TRESORERIE BANNALEC</poste>
        <poste code="0040020">TRESORERIE BANON ET SAINT-ETIENNE</poste>
        <poste code="0620090">TRESORERIE DE BAPAUME</poste>
        <poste code="0550000">TRESORERIE GENERALE DE LA MEUSE</poste>
        <poste code="0550030">TRESORERIE DE BAR-LE-DUC VILLE</poste>
        <poste code="0550210">TRESORERIE DU PAYS DE REVIGNY-OPAC DE LA MEUSE</poste>
        <poste code="0550900">PAIERIE DEPARTEMENTALE DE LA MEUSE</poste>
        <poste code="0100040">TRESORERIE DE BAR-SUR-AUBE</poste>
        <poste code="0100060">TRESORERIE DE BAR-SUR-SEINE</poste>
        <poste code="0120240">TRESORERIE DE BARAQUEVILLE</poste>
        <poste code="0132040">TRESORERIE BARBENTANE</poste>
        <poste code="0160080">TRESORERIE BARBEZIEUX-SAINT-HILAIRE</poste>
        <poste code="0040030">TRESORERIE DE BARCELONNETTE</poste>
        <poste code="0760020">TRESORERIE DE BARENTIN</poste>
        <poste code="0500250">TRESORERIE BARENTON-LE TEILLEUL</poste>
        <poste code="0300450">TRESORERIE DE BARJAC</poste>
        <poste code="0831030">TRESORERIE BARJOLS-TAVERNES</poste>
        <poste code="0500380">TRESORERIE DE BARNEVILLE-PORTBAIL</poste>
        <poste code="0670010">TRESORERIE BARR</poste>
        <poste code="0430030">TRESORERIE BAS-EN-BASSET</poste>
        <poste code="1030010">TRESORERIE BASSE-POINTE</poste>
        <poste code="1010000">TRESORERIE GENERALE DE LA GUADELOUPE</poste>
        <poste code="1010020">TRESORERIE DE BASSE-TERRE</poste>
        <poste code="1010800">PAIERIE REGIONALE DE LA GUADELOUPE</poste>
        <poste code="1010900">PAIERIE DEPARTEMENTALE DE LA GUADELOUPE</poste>
        <poste code="1010130">TRESORERIE DE BASSE-TERRE MUNCIPALE ET HOSPIT.</poste>
        <poste code="02B0000">TRESORERIE GENERALE DE LA HAUTE-CORSE</poste>
        <poste code="02B0010">TRESORERIE BASTIA</poste>
        <poste code="02B0020">TRESORERIE DE BASTIA MUNICIPALE</poste>
        <poste code="02B0900">PAIERIE DEPARTEMENTALE DE LA HAUTE-CORSE</poste>
        <poste code="0560200">TRESORERIE BAUD</poste>
        <poste code="0490320">TRESORERIE BAUGE</poste>
        <poste code="0180040">TRESORERIE BAUGY-SAVIGNY-EN-SEPTAINE</poste>
        <poste code="0250020">TRESORERIE BAUME-LES-DAMES</poste>
        <poste code="0595180">TRESORERIE BAVAY</poste>
        <poste code="0140050">TRESORERIE BAYEUX-MONCEAUX-EN-BESSIN</poste>
        <poste code="0640350">TRESORERIE BAYONNE</poste>
        <poste code="0640360">TRESORERIE BAYONNE MUNICIPALE</poste>
        <poste code="0640480">TRESORERIE BAYONNE CENTRE HOSPITALIER</poste>
        <poste code="0330050">TRESORERIE BAZAS</poste>
        <poste code="0310030">TRESORERIE MONTGISCARD-BAZIEGE</poste>
        <poste code="0300050">TRESORERIE BEAUCAIRE</poste>
        <poste code="0950240">TRESORERIE DE BEAUCHAMP-TAVERNY</poste>
        <poste code="0390050">TRESORERIE DE BEAUFORT</poste>
        <poste code="0490070">TRESORERIE BEAUFORT-EN-VALLEE</poste>
        <poste code="0730060">TRESORERIE BEAUFORT</poste>
        <poste code="0450030">TRESORERIE BEAUGENCY</poste>
        <poste code="0690470">TRESORERIE BEAUJEU</poste>
        <poste code="0190230">TRESORERIE BEAULIEU-SUR-DORDOGNE</poste>
        <poste code="0820020">TRESORERIE BEAUMONT-LAVIT-DE-LOMAGNE</poste>
        <poste code="0500390">TRESORERIE BEAUMONT-HAGUE</poste>
        <poste code="0270180">TRESORERIE BEAUMONT-LE-ROGER</poste>
        <poste code="0950050">TRESORERIE BEAUMONT-SUR-OISE</poste>
        <poste code="0720040">TRESORERIE BEAUMONT-SUR-SARTHE</poste>
        <poste code="0210510">TRESORERIE BEAUNE</poste>
        <poste code="0450310">TRESORERIE DE BEAUNE-LA-ROLANDE</poste>
        <poste code="0490420">TRESORERIE BEAUPREAU</poste>
        <poste code="0381010">TRESORERIE BEAUREPAIRE</poste>
        <poste code="0020320">TRESORERIE BEAURIEUX-ROUCY-CORBENY</poste>
        <poste code="0550050">TRESORERIE DE BEAUSITE</poste>
        <poste code="0060010">TRESORERIE BEAUSOLEIL</poste>
        <poste code="0600000">TRESORERIE GENERALE DE L' OISE</poste>
        <poste code="0600040">TRESORERIE DE BEAUVAIS VILLE</poste>
        <poste code="0600050">TRESORERIE DE BEAUVAIS BANLIEUE</poste>
        <poste code="0600070">TRESORERIE DE BEAUVAIS MUNICIPALE</poste>
        <poste code="0600900">PAIERIE DEPARTEMENTALE DE L' OISE</poste>
        <poste code="0600580">TRESORERIE DE BEAUVAIS AMENDES</poste>
        <poste code="0600001">SERVICE CONTRLE REDEVANCE AUDIOVISUELLE DE L' OISE</poste>
        <poste code="0850290">TRESORERIE BEAUVOIR-SUR-MER</poste>
        <poste code="0790050">TRESORERIE BEAUVOIR-SUR-NIORT</poste>
        <poste code="0350050">TRESORERIE BECHEREL</poste>
        <poste code="0340340">TRESORERIE DE BEDARIEUX</poste>
        <poste code="0640060">TRESORERIE BEDOUS</poste>
        <poste code="0220320">TRESORERIE BEGARD</poste>
        <poste code="0330060">TRESORERIE BEGLES</poste>
        <poste code="0110060">TRESORERIE BELCAIRE-RODOME</poste>
        <poste code="0900000">TRESORERIE GENERALE DU TERRITOIRE-DE-BELFORT</poste>
        <poste code="0900040">TRESORERIE BELFORT VILLE</poste>
        <poste code="0900110">TRESORERIE BELFORT TERRITOIRE HABITAT</poste>
        <poste code="0900120">TRESORERIE DE BELFORT ETS. HOSPITALIERS</poste>
        <poste code="0900900">PAIERIE DEPARTEMENTALE DU TERRITOIRE-DE-BELFORT</poste>
        <poste code="0900020">TRESORERIE DE BELFORT</poste>
        <poste code="0330070">TRESORERIE DE BELIN-BELIET</poste>
        <poste code="0870030">TRESORERIE DE BELLAC</poste>
        <poste code="0230210">TRESORERIE DE BELLEGARDE-EN-MARCHE</poste>
        <poste code="0010020">TRESORERIE BELLEGARDE-SUR-VALSERINE</poste>
        <poste code="0610070">TRESORERIE BELLEME</poste>
        <poste code="0760540">TRESORERIE BELLENCOMBRE</poste>
        <poste code="0030140">TRESORERIE BELLERIVE-SUR-ALLIER</poste>
        <poste code="0020470">TRESORERIE DE BELLEU-SOISSONS BANLIEUE</poste>
        <poste code="0690480">TRESORERIE BELLEVILLE</poste>
        <poste code="0010030">TRESORERIE BELLEY</poste>
        <poste code="0422010">TRESORERIE BELMONT-DE-LA-LOIRE</poste>
        <poste code="0120260">TRESORERIE DE RANCE ET ROUGIERS</poste>
        <poste code="0110070">TRESORERIE BELPECH</poste>
        <poste code="0240020">TRESORERIE BELVES</poste>
        <poste code="0110080">TRESORERIE BELVEZE-DU-RAZES</poste>
        <poste code="0230020">TRESORERIE DE BENEVENT L'ABBAYE-LE GRAND BOURG</poste>
        <poste code="0670030">TRESORERIE BENFELD</poste>
        <poste code="0622170">TRESORERIE DE BERCK</poste>
        <poste code="0240470">TRESORERIE BERGERAC MUNICIPALE ET BANLIEUE</poste>
        <poste code="0240590">TRESORERIE DE BERGERAC</poste>
        <poste code="0594010">TRESORERIE BERGUES</poste>
        <poste code="0595190">TRESORERIE BERLAIMONT</poste>
        <poste code="1830000">TRESORERIE AMBASSADE DE FRANCE EN ALLEMAGNE</poste>
        <poste code="0800670">TRESORERIE BERNAVILLE</poste>
        <poste code="0270190">TRESORERIE DE BERNAY</poste>
        <poste code="0131050">TRESORERIE BERRE-L'ETANG</poste>
        <poste code="0250000">TRESORERIE GENERALE DU DOUBS</poste>
        <poste code="0250007">CENTRE REGIONAL DES PENSIONS DU DOUBS</poste>
        <poste code="0250008">CENTRE DE FORMATION DEPARTEMENTAL DU DOUBS</poste>
        <poste code="0250009">DEPARTEMENT INFORMATIQUE DU DOUBS</poste>
        <poste code="0250030">TRESORERIE BESANCON</poste>
        <poste code="0250050">TRESORERIE DU GRAND BESANCON</poste>
        <poste code="0250060">TRESORERIE BESANCON CHRU</poste>
        <poste code="0250130">TRESORERIE MORRE-ROULANS</poste>
        <poste code="0250280">TRESORERIE BESANCON ETS HOSP. DPTAUX</poste>
        <poste code="0250800">PAIERIE REGIONALE DE FRANCHE-COMTE</poste>
        <poste code="0250900">PAIERIE DEPARTEMENTALE DOUBS</poste>
        <poste code="0250001">SERVICE CONTRLE REDEVANCE AUDIOVISUELLE DU DOUBS</poste>
        <poste code="0250006">PLE NATIONAL DE SOUTIEN AU RESEAU DE BESANCON - RJC</poste>
        <poste code="0250490">TRESORERIE DE L' OPDHLM DU DOUBS-HABITAT 25</poste>
        <poste code="0630020">TRESORERIE BESSE-ET-SAINT-ANASTAISE</poste>
        <poste code="0830020">TRESORERIE BESSE-SUR-ISSOLE</poste>
        <poste code="0300460">TRESORERIE BESSEGES</poste>
        <poste code="0870040">TRESORERIE DE BESSINES-SUR-GARTEMPE</poste>
        <poste code="0620600">TRESORERIE BETHUNE</poste>
        <poste code="0620610">TRESORERIE BETHUNE MUNICIPALE</poste>
        <poste code="0620620">TRESORERIE BEUVRY</poste>
        <poste code="0270200">TRESORERIE BEUZEVILLE</poste>
        <poste code="0190240">TRESORERIE BEYNAT</poste>
        <poste code="0340350">TRESORERIE BEZIERS</poste>
        <poste code="0340360">TRESORERIE BEZIERS MUNICIPALE</poste>
        <poste code="0340370">TRESORERIE DE BEZIERS ETS HOSP</poste>
        <poste code="0950300">TRESORERIE BEZONS</poste>
        <poste code="0640370">TRESORERIE BIARRITZ</poste>
        <poste code="0911030">TRESORERIE BIEVRES</poste>
        <poste code="0760040">TRESORERIE BIHOREL</poste>
        <poste code="0630030">TRESORERIE BILLOM-SAINT-DIER-D'AUVERGNE</poste>
        <poste code="0671010">TRESORERIE BISCHWILLER</poste>
        <poste code="0571010">TRESORERIE BITCHE</poste>
        <poste code="0310430">TRESORERIE BLAGNAC</poste>
        <poste code="0440350">TRESORERIE BLAIN</poste>
        <poste code="0760030">TRESORERIE BLAINVILLE-CREVON</poste>
        <poste code="0540330">TRESORERIE DE BAYON-BLAINVILLE-SUR-L'EAU</poste>
        <poste code="0540340">TRESORERIE DE BLAMONT - CIREY-SUR-VEZOUZE</poste>
        <poste code="0760550">TRESORERIE DE BLANGY-SUR-BRESLE</poste>
        <poste code="0330080">TRESORERIE BLANQUEFORT</poste>
        <poste code="0160090">TRESORERIE BLANZAC-PORCHERESSE</poste>
        <poste code="0330700">TRESORERIE BLAYE</poste>
        <poste code="0890070">TRESORERIE BLENEAU-SAINT-FARGEAU</poste>
        <poste code="0370030">TRESORERIE BLERE</poste>
        <poste code="0390060">TRESORERIE BLETTERANS</poste>
        <poste code="0210520">TRESORERIE BLIGNY-SUR-OUCHE</poste>
        <poste code="0680010">TRESORERIE BLODELSHEIM</poste>
        <poste code="0410000">TRESORERIE GENERALE DE LOIR-ET-CHER</poste>
        <poste code="0410030">TRESORERIE BLOIS MUNICIPALE</poste>
        <poste code="0410360">TRESORERIE OPAC.DE.LOIR.ET.CHER</poste>
        <poste code="0410900">PAIERIE DEPARTEMENTALE DE LOIR-ET-CHER</poste>
        <poste code="0410010">TRESORERIE BLOIS VILLE</poste>
        <poste code="0930000">TRESORERIE GENERALE DE LA SEINE-SAINT-DENIS</poste>
        <poste code="0930009">DEPARTEMENT INFORMATIQUE DE LA SEINE-SAINT-DENIS</poste>
        <poste code="0930320">TRESORERIE DE BOBIGNY MUNICIPALE</poste>
        <poste code="0930900">PAIERIE DEPARTEMENTALE DE LA SEINE-SAINT-DENIS</poste>
        <poste code="0930001">SERVICE CONTRLE REDEVANCE AUDIOVISUELLE DE LA SEINE SAINT DENIS</poste>
        <poste code="0740080">TRESORERIE BOEGE</poste>
        <poste code="0422180">TRESORERIE DE BOEN SUR LIGNON</poste>
        <poste code="0020520">TRESORERIE BOHAIN-EN-VERMANDOIS</poste>
        <poste code="0920050">TRESORERIE DE BOIS-COLOMBES</poste>
        <poste code="0940020">TRESORERIE DE BOISSY-SAINT-LEGER</poste>
        <poste code="0762020">TRESORERIE BOLBEC</poste>
        <poste code="0840200">TRESORERIE BOLLENE-MONDRAGON</poste>
        <poste code="0930060">TRESORERIE DE BONDY</poste>
        <poste code="0930400">TRESORERIE DE BONDY MUNICIPALE</poste>
        <poste code="02A0040">TRESORERIE BONIFACIO</poste>
        <poste code="0230030">TRESORERIE BONNAT-LOURDOUEIX-SAINT-PIERRE</poste>
        <poste code="0860390">TRESORERIE VOUNEUIL-SUR-VIENNE</poste>
        <poste code="0280080">TRESORERIE BONNEVAL</poste>
        <poste code="0740090">TRESORERIE BONNEVILLE</poste>
        <poste code="0781010">TRESORERIE BONNIERES-SUR-SEINE</poste>
        <poste code="0330000">TRESORERIE GENERALE DE LA GIRONDE</poste>
        <poste code="0330007">CENTRE REGIONAL DES PENSIONS DE LA GIRONDE</poste>
        <poste code="0330008">CENTRE DE FORMATION DEPARTEMENTAL DE LA GIRONDE</poste>
        <poste code="0330009">DEPARTEMENT INFORMATIQUE DE LA GIRONDE</poste>
        <poste code="0330170">RECETTE DES FINANCES BORDEAUX MUNICIPALE</poste>
        <poste code="0330181">TRESORERIE DE BORDEAUX CHU ANNEXE CH PERRENS</poste>
        <poste code="0330800">PAIERIE REGIONALE D'AQUITAINE</poste>
        <poste code="0330900">PAIERIE DEPARTEMENTALE DE LA GIRONDE</poste>
        <poste code="0330001">SERVICE CONTRLE REDEVANCE AUDIOVISUELLE DE LA GIRONDE</poste>
        <poste code="0330006">PLE NATIONAL DE SOUTIEN AU RESEAU DE BORDEAUX</poste>
        <poste code="0330120">TRESORERIE BORDEAUX AMENDES</poste>
        <poste code="0330140">TRESORERIE DE BORDEAUX RIVE GAUCHE</poste>
        <poste code="0330160">TRESORERIE BORDEAUX EST</poste>
        <poste code="0330171">RECETTE DES FINANCES SERVICE DE LA COMMUNAUTE URBAINE</poste>
        <poste code="02B0040">TRESORERIE BORGO-CAMPILE</poste>
        <poste code="0190020">TRESORERIE BORT-LES-ORGUES</poste>
        <poste code="0440030">TRESORERIE DE BOUAYE</poste>
        <poste code="0595020">TRESORERIE BOUCHAIN</poste>
        <poste code="0100070">TRESORERIE DE BOUILLY</poste>
        <poste code="0571020">TRESORERIE BOULAY</poste>
        <poste code="0920060">TRESORERIE BOULOGNE-BILLANCOURT</poste>
        <poste code="0920070">TRESORERIE BOULOGNE-BILLANCOURT MUNICIPALE</poste>
        <poste code="0310480">TRESORERIE BOULOGNE-SUR-GESSE-BLAJAN</poste>
        <poste code="0622000">RECETTE DES FINANCES BOULOGNE-SUR-MER</poste>
        <poste code="0622020">TRESORERIE DE BOULOGNE-SUR-MER</poste>
        <poste code="0622030">TRESORERIE BOULOGNE-SUR-MER MUNICIPALE</poste>
        <poste code="0622040">TRESORERIE BOULOGNE-SUR-MER CTRE HOSP</poste>
        <poste code="0720070">TRESORERIE BOULOIRE-PARIGNE</poste>
        <poste code="0030010">TRESORERIE DE BOURBON-L'ARCHAMBAULT</poste>
        <poste code="0710020">TRESORERIE BOURBON-LANCY</poste>
        <poste code="0520300">TRESORERIE BOURBONNE-LES-BAINS</poste>
        <poste code="0594030">TRESORERIE BOURBOURG</poste>
        <poste code="0270370">TRESORERIE DE ROUTOT-BOURG-ACHARD</poste>
        <poste code="0420010">TRESORERIE DE BOURG-ARGENTAL</poste>
        <poste code="0010000">TRESORERIE GENERALE DE L' AIN</poste>
        <poste code="0010050">TRESORERIE DE BOURG-EN-BRESSE</poste>
        <poste code="0010060">TRESORERIE BOURG-EN-BRESSE MUNICIPALE</poste>
        <poste code="0010900">PAIERIE DEPARTEMENTALE DE L' AIN</poste>
        <poste code="0010001">CELLULE CONTRLE REDEVANCE AUDIOVISUELLE DE L' AIN</poste>
        <poste code="0630040">TRESORERIE DE BOURG-LASTIC-HERMENT</poste>
        <poste code="0660050">TRESORERIE BOURG-MADAME</poste>
        <poste code="0070080">TRESORERIE BOURG-SAINT-ANDEOL</poste>
        <poste code="0730070">TRESORERIE DE BOURG-SAINT-MAURICE</poste>
        <poste code="0330710">TRESORERIE BOURG SUR GIRONDE</poste>
        <poste code="0230040">TRESORERIE DE BOURGANEUF - PONTARION</poste>
        <poste code="0180050">TRESORERIE BOURGES</poste>
        <poste code="0180900">PAIERIE DEPARTEMENTALE DU CHER</poste>
        <poste code="0180060">TRESORERIE BOURGES MUNICIPALE</poste>
        <poste code="0180070">TRESORERIE DE BOURGES CH JACQUES COEUR</poste>
        <poste code="0180410">TRESORERIE BOURGES H.L.M</poste>
        <poste code="0180420">TRESORERIE DE BOURGES ETS SPECIALISES</poste>
        <poste code="0180000">TRESORERIE GENERALE DU CHER</poste>
        <poste code="0381100">TRESORERIE BOURGOIN-JALLIEU COLLECTIVITES</poste>
        <poste code="0381110">TRESORERIE BOURGOIN-JALLIEU</poste>
        <poste code="0270210">TRESORERIE DE BOURGTHEROULDE-INFREVILLE</poste>
        <poste code="0370050">TRESORERIE BOURGUEIL</poste>
        <poste code="0520040">TRESORERIE BOURMONT</poste>
        <poste code="0230050">TRESORERIE BOUSSAC</poste>
        <poste code="0671020">TRESORERIE BOUXWILLER</poste>
        <poste code="0571030">TRESORERIE BOUZONVILLE</poste>
        <poste code="0730080">TRESORERIE BOZEL</poste>
        <poste code="0120020">TRESORERIE BOZOULS</poste>
        <poste code="0410040">TRESORERIE BRACIEUX</poste>
        <poste code="0110400">TRESORERIE DE VILLASAVARY</poste>
        <poste code="0240030">TRESORERIE BRANTOME</poste>
        <poste code="0810190">TRESORERIE BRASSAC</poste>
        <poste code="0770300">TRESORERIE BRAY-SUR-SEINE</poste>
        <poste code="0800510">TRESORERIE BRAY-SUR-SOMME</poste>
        <poste code="0500260">TRESORERIE BRECEY-SAINT-POIS</poste>
        <poste code="0500010">TRESORERIE BREHAL-GAVRAY</poste>
        <poste code="0060020">TRESORERIE DE BREIL-SUR-ROYA</poste>
        <poste code="0600080">TRESORERIE BRESLES</poste>
        <poste code="0790070">TRESORERIE BRESSUIRE</poste>
        <poste code="0290200">TRESORERIE BREST BELLEVUE</poste>
        <poste code="0290000">TRESORERIE GENERALE DU FINISTERE</poste>
        <poste code="0290030">TRESORERIE DE BREST QUATRE-MOULINS</poste>
        <poste code="0290040">TRESORERIE BREST MUNICIPALE ET COM.URB</poste>
        <poste code="0290041">TRESORERIE ANNEXE OPAC</poste>
        <poste code="0290050">TRESORERIE BREST CHU</poste>
        <poste code="0290900">PAIERIE DEPARTEMENTALE D' FINISTERE</poste>
        <poste code="0290001">SERVICE CONTRLE REDEVANCE AUDIOVISUELLE DU FINISTERE</poste>
        <poste code="0460020">TRESORERIE DE BRETENOUX-VAYRAC</poste>
        <poste code="0600090">TRESORERIE DE BRETEUIL-CREVECOEUR-LE-GRAND</poste>
        <poste code="0270010">TRESORERIE BRETEUIL-SUR-ITON</poste>
        <poste code="0140090">TRESORERIE BRETTEVILLE-SUR-LAIZE</poste>
        <poste code="0280330">TRESORERIE BREZOLLES</poste>
        <poste code="0050030">TRESORERIE BRIANCON</poste>
        <poste code="0450320">TRESORERIE DE BRIARE</poste>
        <poste code="0500400">TRESORERIE BRICQUEBEC</poste>
        <poste code="0770010">TRESORERIE BRIE-COMTE-ROBERT</poste>
        <poste code="0100080">TRESORERIE DE BRIENNE-LE-CHATEAU</poste>
        <poste code="0890080">TRESORERIE DE BRIENON-SUR-ARMANCON</poste>
        <poste code="0540400">TRESORERIE DE BRIEY</poste>
        <poste code="0830030">TRESORERIE BRIGNOLES</poste>
        <poste code="0270220">TRESORERIE BRIONNE</poste>
        <poste code="0430050">TRESORERIE BRIOUDE</poste>
        <poste code="0790080">TRESORERIE BRIOUX-SUR-BOUTONNE</poste>
        <poste code="0490080">TRESORERIE BRISSAC-QUINCE</poste>
        <poste code="0190260">TRESORERIE BRIVE MUNICIPALE</poste>
        <poste code="0190330">TRESORERIE BRIVE VILLE</poste>
        <poste code="0690210">TRESORERIE LE VINATIER CTRE HOSP. SPEC</poste>
        <poste code="0690430">TRESORERIE DE BRON</poste>
        <poste code="0220230">TRESORERIE BROONS</poste>
        <poste code="0280100">TRESORERIE BROU</poste>
        <poste code="0620630">TRESORERIE BRUAY-LA BUISSIERE</poste>
        <poste code="0670060">TRESORERIE DE BRUMATH</poste>
        <poste code="0910050">TRESORERIE BRUNOY</poste>
        <poste code="0880040">TRESORERIE DE BRUYERES</poste>
        <poste code="0760060">TRESORERIE BUCHY</poste>
        <poste code="0190030">TRESORERIE BUGEAT</poste>
        <poste code="0260310">TRESORERIE DE BUIS-LES-BARONNIES</poste>
        <poste code="0880050">TRESORERIE BULGNEVILLE</poste>
        <poste code="0620640">TRESORERIE BULLY-LES-MINES</poste>
        <poste code="0170260">TRESORERIE BURIE</poste>
        <poste code="0860290">TRESORERIE POITIERS OPAC</poste>
        <poste code="0710470">TRESORERIE BUXY-SAINT-GENGOUX-LE-NATIONAL</poste>
        <poste code="0360060">TRESORERIE BUZANCAIS</poste>
        <poste code="0080070">TRESORERIE BUZANCY</poste>
        <poste code="0660250">TRESORERIE DE CABESTANY</poste>
        <poste code="0660900">PAIERIE DEPARTEMENTALE DES PYRENEES-ORIENTALES</poste>
        <poste code="0140110">TRESORERIE CABOURG</poste>
        <poste code="0940030">TRESORERIE CACHAN</poste>
        <poste code="0840090">TRESORERIE CADENET</poste>
        <poste code="0330220">TRESORERIE DE CADILLAC</poste>
        <poste code="0140000">TRESORERIE GENERALE DU CALVADOS</poste>
        <poste code="0140007">CENTRE REGIONAL DES PENSIONS DU CALVADOS</poste>
        <poste code="0140008">CENTRE DE FORMATION DEPARTEMENTAL DU CALVADOS</poste>
        <poste code="0140009">DEPARTEMENT INFORMATIQUE DU CALVADOS</poste>
        <poste code="0140120">TRESORERIE DE CAEN BASSIN SAINT-PIERRE</poste>
        <poste code="0140130">TRESORERIE CAEN MUNICIPALE</poste>
        <poste code="0140140">TRESORERIE CAEN CHU</poste>
        <poste code="0140440">TRESORERIE DU CALVADOS</poste>
        <poste code="0140450">TRESORERIE CAEN AMENDES</poste>
        <poste code="0140900">PAIERIE DEPARTEMENTALE DU CALVADOS</poste>
        <poste code="0140001">SERVICE CONTRLE REDEVANCE AUDIOVISUELLE DU CALVADOS</poste>
        <poste code="0140100">TRESORERIE CAEN BANLIEUE OUEST</poste>
        <poste code="0140800">PAIERIE REGIONALE DE BASSE-NORMANDIE</poste>
        <poste code="0061040">TRESORERIE CAGNES-SUR-MER</poste>
        <poste code="0460000">TRESORERIE GENERALE DU LOT</poste>
        <poste code="0460900">PAIERIE DEPARTEMENTALE DU LOT</poste>
        <poste code="0460030">TRESORERIE DE CAHORS</poste>
        <poste code="02B0060">TRESORERIE CALACUCCIA</poste>
        <poste code="0622080">TRESORERIE CALAIS MUNICIPALE</poste>
        <poste code="0622160">TRESORERIE CALAIS CTRE. HOSPIT. ET BANLIEUE</poste>
        <poste code="0622050">TRESORERIE DE CALAIS</poste>
        <poste code="0220330">TRESORERIE CALLAC</poste>
        <poste code="0690020">TRESORERIE DE CALUIRE-ET-CUIRE</poste>
        <poste code="02B0070">TRESORERIE CALVI</poste>
        <poste code="0330230">TRESORERIE CAMBES</poste>
        <poste code="0640380">TRESORERIE CAMBO-LES-BAINS</poste>
        <poste code="0593120">TRESORERIE CAMBRAI MUNICIPALE ET HOSP</poste>
        <poste code="0593170">TRESORERIE CAMBRAI BANLIEUE EST</poste>
        <poste code="0140480">TRESORERIE DE CAMBREMER</poste>
        <poste code="0622180">TRESORERIE CAMPAGNE-LES-HESDIN</poste>
        <poste code="0350410">TRESORERIE CANCALE</poste>
        <poste code="0490090">TRESORERIE CANDE</poste>
        <poste code="0061050">TRESORERIE CANNES</poste>
        <poste code="0061070">TRESORERIE CANNES MUNICIPALE</poste>
        <poste code="0061080">TRESORERIE CANNES CENTRE HOSPITALIER</poste>
        <poste code="0760680">TRESORERIE CANY-BARVILLE</poste>
        <poste code="0120300">TRESORERIE CAPDENAC-GARE</poste>
        <poste code="0110100">TRESORERIE CAPENDU</poste>
        <poste code="0340380">TRESORERIE DE CAPESTANG</poste>
        <poste code="1010030">TRESORERIE DE CAPESTERRE</poste>
        <poste code="0310050">TRESORERIE CARAMAN-LANTA</poste>
        <poste code="0310560">TRESORERIE DU VOLVESTRE</poste>
        <poste code="0110000">TRESORERIE GENERALE DE L' AUDE</poste>
        <poste code="0110410">TRESORERIE CARCASSONNE ETAB HOSPITALIERS</poste>
        <poste code="0110110">TRESORERIE DE CARCASSONNE VILLE</poste>
        <poste code="0110130">TRESORERIE CARCASSONNE AGGLOMERATION</poste>
        <poste code="0110900">PAIERIE DEPARTEMENTALE DE L' AUDE</poste>
        <poste code="0831040">TRESORERIE COTIGNAC-CARCES</poste>
        <poste code="0500030">TRESORERIE CARENTAN</poste>
        <poste code="0290210">TRESORERIE DE CARHAIX-PLOUGUER</poste>
        <poste code="0080080">TRESORERIE DE CARIGNAN</poste>
        <poste code="0810050">TRESORERIE CARMAUX-PAMPELONNE</poste>
        <poste code="0560270">TRESORERIE CARNAC</poste>
        <poste code="0840210">TRESORERIE DE CARPENTRAS</poste>
        <poste code="0840290">TRESORERIE DE CARPENTRAS ETS. HOSPITALIERS</poste>
        <poste code="0440340">TRESORERIE DE CARQUEFOU</poste>
        <poste code="0610090">TRESORERIE CARROUGES</poste>
        <poste code="0620660">TRESORERIE CARVIN</poste>
        <poste code="0594050">TRESORERIE DE CASSEL</poste>
        <poste code="0310070">TRESORERIE CASTANET-TOLOSAN</poste>
        <poste code="0470160">TRESORERIE CASTELJALOUX</poste>
        <poste code="0040050">TRESORERIE DE CASTELLANE</poste>
        <poste code="0470170">TRESORERIE CASTELMORON-SUR-LOT</poste>
        <poste code="0330240">TRESORERIE DE CASTELNAU-DE-MEDOC</poste>
        <poste code="0340020">TRESORERIE DE CASTELNAU-LE-LEZ</poste>
        <poste code="0650110">TRESORERIE DE CASTELNAU-GALAN</poste>
        <poste code="0460050">TRESORERIE CASTELNAU-MONTRATIER</poste>
        <poste code="0110140">TRESORERIE CASTELNAUDARY</poste>
        <poste code="0820040">TRESORERIE CASTELSARRASIN</poste>
        <poste code="0400210">TRESORERIE CASTETS</poste>
        <poste code="0090060">TRESORERIE CASTILLON-EN-COUSERANS</poste>
        <poste code="0330630">TRESORERIE CASTILLON-LA-BATAILLE</poste>
        <poste code="0470180">TRESORERIE DE CASTILLONNES</poste>
        <poste code="0810200">TRESORERIE CASTRES</poste>
        <poste code="0810210">TRESORERIE CASTRES VILLE</poste>
        <poste code="0330250">TRESORERIE CASTRES-GIRONDE</poste>
        <poste code="0340030">TRESORERIE DE CASTRIES</poste>
        <poste code="0460060">TRESORERIE CATUS</poste>
        <poste code="0760080">TRESORERIE CAUDEBEC-EN-CAUX</poste>
        <poste code="0593140">TRESORERIE DE CAUDRY</poste>
        <poste code="0220240">TRESORERIE CAULNES</poste>
        <poste code="0820050">TRESORERIE CAUSSADE-CAYLUS</poste>
        <poste code="0840100">TRESORERIE CAVAILLON</poste>
        <poste code="1020000">TRESORERIE GENERALE DE LA GUYANE</poste>
        <poste code="1020020">TRESORERIE CAYENNE AMANDIERS</poste>
        <poste code="1020800">PAIERIE REGIONALE DE LA GUYANE</poste>
        <poste code="1020900">PAIERIE DEPARTEMENTALE DE LA GUYANE</poste>
        <poste code="1020010">TRESORERIE DE CAYENNE ILE</poste>
        <poste code="0430060">TRESORERIE CAYRES</poste>
        <poste code="0460070">TRESORERIE CAZALS-SALVIAC</poste>
        <poste code="0320060">TRESORERIE CAZAUBON</poste>
        <poste code="0310570">TRESORERIE CAZERES-MARTRES-TOLOSANE</poste>
        <poste code="0790090">TRESORERIE CELLES-SUR-BELLE</poste>
        <poste code="0330290">TRESORERIE CENON</poste>
        <poste code="0720100">TRESORERIE DE CERANS-MANSIGNE</poste>
        <poste code="0660060">TRESORERIE CERET</poste>
        <poste code="0950000">TRESORERIE GENERALE DU VAL-D'OISE</poste>
        <poste code="0950008">CENTRE DE FORMATION DEPARTEMENTAL DU VAL-D'OISE</poste>
        <poste code="0950200">TRESORERIE DE CERGY</poste>
        <poste code="0950900">PAIERIE DEPARTEMENTALE DU VAL-D'OISE</poste>
        <poste code="0950330">TRESORERIE DE CERGY COLLECTIVITES</poste>
        <poste code="0950350">TRESORERIE VAL D'OISE AMENDES</poste>
        <poste code="0950001">SERVICE CONTRLE REDEVANCE AUDIOVISUELLE DU VAL D'OISE</poste>
        <poste code="0030150">TRESORERIE CERILLY-AINAY-LE-CHATEAU</poste>
        <poste code="0790100">TRESORERIE CERIZAY</poste>
        <poste code="0680250">TRESORERIE CERNAY</poste>
        <poste code="02B0210">TRESORERIE SAN-NICOLAO</poste>
        <poste code="0350060">TRESORERIE DE RENNES BANLIEUE EST</poste>
        <poste code="0160110">TRESORERIE CHABANAIS</poste>
        <poste code="0260050">TRESORERIE CHABEUIL</poste>
        <poste code="0890090">TRESORERIE CHABLIS</poste>
        <poste code="0710480">TRESORERIE CHAGNY-SAINT-LEGER-SUR-DHEUNE</poste>
        <poste code="0530060">TRESORERIE CHAILLAND-JUVIGNE</poste>
        <poste code="0850190">TRESORERIE DE CHAILLE-LES-MARAIS</poste>
        <poste code="0110160">TRESORERIE CHALABRE</poste>
        <poste code="0160120">TRESORERIE CHALAIS</poste>
        <poste code="0520310">TRESORERIE DE CHALINDREY</poste>
        <poste code="0850300">TRESORERIE CHALLANS-PALLUAU</poste>
        <poste code="0730310">TRESORERIE DE CHALLES-LES-EAUX</poste>
        <poste code="0710500">TRESORERIE CHALON-SUR-SAONE MUNICIPALE</poste>
        <poste code="0710570">TRESORERIE CHALON-SUR-SAONE VILLE</poste>
        <poste code="0490100">TRESORERIE CHALONNES-SUR-LOIRE</poste>
        <poste code="0510040">TRESORERIE DE CHALONS-EN-CHAMPAGNE MUNICIPALE</poste>
        <poste code="0510800">PAIERIE REGIONALE DE CHAMPAGNE-ARDENNE</poste>
        <poste code="0510000">TRESORERIE GENERALE DE LA MARNE</poste>
        <poste code="0510007">CENTRE REGIONAL DES PENSIONS DE LA MARNE</poste>
        <poste code="0510008">CENTRE DE FORMATION DEPARTEMENTAL DE LA MARNE</poste>
        <poste code="0510009">DEPARTEMENT INFORMATIQUE DE LA MARNE</poste>
        <poste code="0510030">TRESORERIE DE CHALONS-EN-CHAMPAGNE</poste>
        <poste code="0510060">TRESORERIE DE CHALONS-EN-CHAMPAGNE ETS HOSP</poste>
        <poste code="0510080">TRESORERIE CHALONS - BANLIEUE SUD</poste>
        <poste code="0510140">TRESORERIE CHALONS - BANLIEUE NORD</poste>
        <poste code="0510290">TRESORERIE CHALONS-EN-CHAMPAGNE HLM</poste>
        <poste code="0510900">PAIERIE DEPARTEMENTALE DE LA MARNE</poste>
        <poste code="0870050">TRESORERIE CHALUS-DOURNAZAC</poste>
        <poste code="0630800">PAIERIE REGIONALE D'AUVERGNE</poste>
        <poste code="0190040">TRESORERIE CHAMBERET</poste>
        <poste code="0730000">TRESORERIE GENERALE DE LA SAVOIE</poste>
        <poste code="0730090">TRESORERIE CHAMBERY</poste>
        <poste code="0730100">TRESORERIE DE CHAMBERY MUNICIPALE</poste>
        <poste code="0730370">TRESORERIE CHAMBERY ETS HOSP.</poste>
        <poste code="0730380">TRESORERIE DE L' OPAC DE LA SAVOIE</poste>
        <poste code="0730900">PAIERIE DEPARTEMENTALE DE LA SAVOIE</poste>
        <poste code="0600330">TRESORERIE CHAMBLY</poste>
        <poste code="0230220">TRESORERIE DE CHAMBON-SUR-VOUEIZE</poste>
        <poste code="0740120">TRESORERIE CHAMONIX-MONT-BLANC</poste>
        <poste code="0730120">TRESORERIE DE CHAMOUX-SUR-GELON</poste>
        <poste code="0160130">TRESORERIE CHAMPAGNE-MOUTON</poste>
        <poste code="0700040">TRESORERIE CHAMPAGNEY</poste>
        <poste code="0390080">TRESORERIE CHAMPAGNOLE</poste>
        <poste code="0630060">TRESORERIE CHAMPEIX</poste>
        <poste code="0941010">TRESORERIE DE CHAMPIGNY-SUR-MARNE</poste>
        <poste code="0490430">TRESORERIE CHAMPTOCEAUX</poste>
        <poste code="0600340">TRESORERIE CHANTILLY</poste>
        <poste code="0850050">TRESORERIE CHANTONNAY</poste>
        <poste code="0100090">TRESORERIE DE CHAOURCE</poste>
        <poste code="0690800">PAIERIE REGIONALE DE RHONE-ALPES</poste>
        <poste code="0940350">TRESORERIE VAL-DE-MARNE AMENDES</poste>
        <poste code="0940050">TRESORERIE CHARENTON-LE-PONT</poste>
        <poste code="0080000">TRESORERIE GENERALE DES ARDENNES</poste>
        <poste code="0080090">TRESORERIE DE CHARLEVILLE COURS BRIAND</poste>
        <poste code="0080100">TRESORERIE DE CHARLEVILLE-MEZIERES BOURBON</poste>
        <poste code="0080110">TRESORERIE CHARLEVILLE-MEZIERES ETS HOSP</poste>
        <poste code="0080900">PAIERIE DEPARTEMENTALE DES ARDENNES</poste>
        <poste code="0422020">TRESORERIE CHARLIEU-POUILLY</poste>
        <poste code="0020390">TRESORERIE DE CHARLY-SUR-MARNE</poste>
        <poste code="0880060">TRESORERIE CHARMES-BRANTIGNY</poste>
        <poste code="0890110">TRESORERIE CHARNY</poste>
        <poste code="0710040">TRESORERIE CHAROLLES-ST-BONNET-DE-JOUX</poste>
        <poste code="0280000">TRESORERIE GENERALE D'EURE-ET-LOIR</poste>
        <poste code="0280120">TRESORERIE CHARTRES-VILLE</poste>
        <poste code="0280140">TRESORERIE CHARTRES MUNICIPALE</poste>
        <poste code="0280001">SERVICE CONTRLE REDEVANCE AUDIOVISUELLE DE L' EURE ET LOIR</poste>
        <poste code="0350070">TRESORERIE DE CHARTRES-DE-BRETAGNE</poste>
        <poste code="0160140">TRESORERIE DE CHASSENEUIL-SUR-BONNIEURE</poste>
        <poste code="0580030">TRESORERIE CHATEAU-CHINON</poste>
        <poste code="0720120">TRESORERIE CHATEAU-DU-LOIR</poste>
        <poste code="0530070">TRESORERIE CHATEAU-GONTIER</poste>
        <poste code="0370080">TRESORERIE CHATEAU-LA-VALLIERE</poste>
        <poste code="0770320">TRESORERIE CHATEAU-LANDON-BEAUMONT-DU-GAT</poste>
        <poste code="0450330">TRESORERIE CHATEAU-RENARD</poste>
        <poste code="0370090">TRESORERIE CHATEAU-RENAULT</poste>
        <poste code="0570100">TRESORERIE CHATEAU-SALINS</poste>
        <poste code="0020400">TRESORERIE DE CHATEAU-THIERRY-ET-BANLIEUE</poste>
        <poste code="0050040">TRESORERIE CHATEAU-VILLE-VIEILLE</poste>
        <poste code="0440050">TRESORERIE DE CHATEAUBRIANT</poste>
        <poste code="0280150">TRESORERIE CHATEAUDUN</poste>
        <poste code="0350090">TRESORERIE CHATEAUGIRON</poste>
        <poste code="0290060">TRESORERIE CHATEAULIN</poste>
        <poste code="0180110">TRESORERIE CHATEAUMEILLANT-CULAN</poste>
        <poste code="0290070">TRESORERIE CHATEAUNEUF-DU-FAOU</poste>
        <poste code="0280340">TRESORERIE CHATEAUNEUF-EN-THYMERAIS</poste>
        <poste code="0350420">TRESORERIE CHATEAUNEUF-D'ILLE-ET-VILAINE</poste>
        <poste code="0870060">TRESORERIE CHATEAUNEUF-LA-FORET</poste>
        <poste code="0160160">TRESORERIE CHATEAUNEUF-SUR-CHARENTE</poste>
        <poste code="0180120">TRESORERIE DE CHATEAUNEUF-SUR-CHER</poste>
        <poste code="0450060">TRESORERIE CHATEAUNEUF-SUR-LOIRE</poste>
        <poste code="0490110">TRESORERIE CHATEAUNEUF-SUR-SARTHE</poste>
        <poste code="0132050">TRESORERIE CHATEAURENARD</poste>
        <poste code="0360000">TRESORERIE GENERALE DE L' INDRE</poste>
        <poste code="0360100">TRESORERIE CHATEAUROUX MUNICIPALE</poste>
        <poste code="0360900">PAIERIE DEPARTEMENTALE DE L'INDRE</poste>
        <poste code="0360080">TRESORERIE CHATEAUROUX VILLE</poste>
        <poste code="0520070">TRESORERIE CHATEAUVILLAIN</poste>
        <poste code="0880080">TRESORERIE CHATEL-SUR-MOSELLE</poste>
        <poste code="0220440">TRESORERIE CHATELAUDREN</poste>
        <poste code="0860300">TRESORERIE DES COLLECTIVITES DU CHATELLERAUDAIS</poste>
        <poste code="0860370">TRESORERIE DE CHATELLERAULT</poste>
        <poste code="9800000">TRESORERIE GENERALE DES CREANCES SPECIALES DU TRESOR</poste>
        <poste code="9800006">PLE NATIONAL D' ASSISTANCE RECOUVT CONTENTIEUX</poste>
        <poste code="0230060">TRESORERIE CHATELUS-MALVALEIX</poste>
        <poste code="0921030">TRESORERIE CHATENAY-MALABRY</poste>
        <poste code="0880090">TRESORERIE DE CHATENOIS</poste>
        <poste code="0921040">TRESORERIE CHATILLON</poste>
        <poste code="0450340">TRESORERIE CHATILLON-COLIGNY</poste>
        <poste code="0580050">TRESORERIE CHATILLON-EN-BAZOIS</poste>
        <poste code="0260080">TRESORERIE CHATILLON-LUS-LA-CROIX-HAUTE</poste>
        <poste code="0010100">TRESORERIE CHATILLON-SUR-CHALARONNE</poste>
        <poste code="0360110">TRESORERIE CHATILLON-SUR-INDRE-CLION</poste>
        <poste code="0210090">TRESORERIE CHATILLON-SUR-SEINE</poste>
        <poste code="0780040">TRESORERIE CHATOU</poste>
        <poste code="0150070">TRESORERIE CHAUDES-AIGUES-PIERREFORT</poste>
        <poste code="0710050">TRESORERIE CHAUFFAILLES</poste>
        <poste code="0800520">TRESORERIE CHAULNES</poste>
        <poste code="0520000">TRESORERIE GENERALE DE LA HAUTE-MARNE</poste>
        <poste code="0520080">TRESORERIE CHAUMONT</poste>
        <poste code="0520900">PAIERIE DEPARTEMENTALE DE LA HAUTE-MARNE</poste>
        <poste code="0600110">TRESORERIE DE CHAUMONT-EN-VEXIN</poste>
        <poste code="0020330">TRESORERIE CHAUNY</poste>
        <poste code="0390290">TRESORERIE CHAUSSIN-LE DESCHAUX</poste>
        <poste code="0860040">TRESORERIE CHAUVIGNY</poste>
        <poste code="0690500">TRESORERIE DE CHAZAY-D'AZERGUES</poste>
        <poste code="0420210">TRESORERIE CHAZELLES-SUR-LYON</poste>
        <poste code="0790140">TRESORERIE CHEF-BOUTONNE</poste>
        <poste code="0772030">TRESORERIE DE CHELLES</poste>
        <poste code="0490440">TRESORERIE CHEMILLE</poste>
        <poste code="0230230">TRESORERIE CHENERAILLES</poste>
        <poste code="0941030">TRESORERIE DE CHENNEVIERES-SUR-MARNE</poste>
        <poste code="0210480">TRESORERIE CHENOVE</poste>
        <poste code="0500410">TRESORERIE CHERBOURG</poste>
        <poste code="0500420">TRESORERIE CHERBOURG MUNICIPALE</poste>
        <poste code="0890480">TRESORERIE CHEROY-DOMATS</poste>
        <poste code="0520110">TRESORERIE CHEVILLON</poste>
        <poste code="0780050">TRESORERIE CHEVREUSE</poste>
        <poste code="0911040">TRESORERIE CHILLY-MAZARIN</poste>
        <poste code="0370110">TRESORERIE CHINON</poste>
        <poste code="0940060">TRESORERIE DE CHOISY-LE-ROI</poste>
        <poste code="0490450">TRESORERIE CHOLET MUNICIPALE ET VEZINS</poste>
        <poste code="0490500">TRESORERIE DE CHOLET</poste>
        <poste code="0860050">TRESORERIE CIVRAY</poste>
        <poste code="0390090">TRESORERIE CLAIRVAUX-LES-LACS</poste>
        <poste code="0921050">TRESORERIE DE CLAMART</poste>
        <poste code="0580060">TRESORERIE CLAMECY</poste>
        <poste code="0593150">TRESORERIE DE CLARY</poste>
        <poste code="0772040">TRESORERIE CLAYE-SOUILLY</poste>
        <poste code="0760100">TRESORERIE CLERES</poste>
        <poste code="0600120">TRESORERIE CLERMONT</poste>
        <poste code="0600130">TRESORERIE CLERMONT CHSI</poste>
        <poste code="0550320">TRESORERIE CLERMONT-EN-ARGONNE</poste>
        <poste code="0630100">TRESORERIE DE CLERMONT-FERRAND BANLIEUE</poste>
        <poste code="0630110">TRESORERIE DE CLERMONT-FERRAND MUNICIPALE</poste>
        <poste code="0630000">TRESORERIE GENERALE DU PUY-DE-DOME</poste>
        <poste code="0630007">CENTRE REGIONAL DES PENSIONS DU PUY-DE-DOME</poste>
        <poste code="0630008">CENTRE DE FORMATION DEPARTEMENTAL DU PUY-DE-DOME</poste>
        <poste code="0630009">DEPARTEMENT INFORMATIQUE DU PUY-DE-DOME</poste>
        <poste code="0630070">TRESORERIE DE CLERMONT-FERRAND 1ERE DIVISION</poste>
        <poste code="0630120">TRESORERIE CLERMONT-FERRAND CHU</poste>
        <poste code="0630340">TRESORERIE CLERMONT-FERRAND OPAC</poste>
        <poste code="0630900">PAIERIE DEPARTEMENTALE DU PUY-DE-DOME</poste>
        <poste code="0630001">SERVICE CONTRLE REDEVANCE AUDIOVISUELLE DU PUY DE DME</poste>
        <poste code="0630080">TRESORERIE CLERMONT-FERRAND 2EME DIVISION</poste>
        <poste code="0340070">TRESORERIE CLERMONT-L'HERAULT</poste>
        <poste code="0250360">TRESORERIE DE CLERVAL</poste>
        <poste code="0920110">TRESORERIE CLICHY</poste>
        <poste code="0920120">TRESORERIE CLICHY MUNICIPALE</poste>
        <poste code="0440060">TRESORERIE CLISSON</poste>
        <poste code="0280160">TRESORERIE CLOYES-COURTALAIN</poste>
        <poste code="0710070">TRESORERIE CLUNY-SALORNAY</poste>
        <poste code="0740130">TRESORERIE CLUSES</poste>
        <poste code="0160170">TRESORERIE COGNAC</poste>
        <poste code="0160180">TRESORERIE COGNAC MUNICIPALE</poste>
        <poste code="0010110">TRESORERIE COLIGNY</poste>
        <poste code="0220030">TRESORERIE COLLINEE</poste>
        <poste code="0680230">TRESORERIE WINTZENHEIM</poste>
        <poste code="0680900">PAIERIE DEPARTEMENTALE DU HAUT-RHIN</poste>
        <poste code="0680000">TRESORERIE GENERALE DU HAUT-RHIN</poste>
        <poste code="0680020">TRESORERIE DE COLMAR</poste>
        <poste code="0680040">TRESORERIE COLMAR MUNICIPALE</poste>
        <poste code="0680050">TRESORERIE ETS HOSP. PUBLICS DE COLMAR</poste>
        <poste code="0680300">TRESORERIE HAUT RHIN AMENDES</poste>
        <poste code="0040060">TRESORERIE COLMARS</poste>
        <poste code="0920140">TRESORERIE DE COLOMBES MUNICIPALE</poste>
        <poste code="0920130">TRESORERIE COLOMBES</poste>
        <poste code="0540020">TRESORERIE DE COLOMBEY-LES-BELLES</poste>
        <poste code="0310410">TRESORERIE COLOMIERS-LEGUEVIN</poste>
        <poste code="0700080">TRESORERIE COMBEAUFONTAINE</poste>
        <poste code="0350430">TRESORERIE COMBOURG</poste>
        <poste code="0630360">TRESORERIE COMBRONDE</poste>
        <poste code="0590080">TRESORERIE COMINES</poste>
        <poste code="0030160">TRESORERIE DE COMMENTRY</poste>
        <poste code="0550060">TRESORERIE COMMERCY</poste>
        <poste code="0600570">TRESORERIE COMPIEGNE</poste>
        <poste code="0600470">TRESORERIE COMPIEGNE MUNICIPALE</poste>
        <poste code="0831050">TRESORERIE COMPS-SUR-ARTUBY</poste>
        <poste code="0292030">TRESORERIE CONCARNEAU</poste>
        <poste code="0270030">TRESORERIE CONCHES-EN-OUCHE</poste>
        <poste code="0150080">TRESORERIE CONDAT</poste>
        <poste code="0020420">TRESORERIE CONDE-EN-BRIE</poste>
        <poste code="0595030">TRESORERIE CONDE-SUR-L'ESCAUT</poste>
        <poste code="0140170">TRESORERIE CONDE-SUR-NOIREAU</poste>
        <poste code="0320080">TRESORERIE CONDOM</poste>
        <poste code="0690040">TRESORERIE CONDRIEU</poste>
        <poste code="0781020">TRESORERIE CONFLANS-SAINTE-HONORINE</poste>
        <poste code="0160190">TRESORERIE CONFOLENS</poste>
        <poste code="0720130">TRESORERIE DE CONLIE</poste>
        <poste code="0720140">TRESORERIE DE CONNERRE-MONTFORT</poste>
        <poste code="0060030">TRESORERIE CONTES</poste>
        <poste code="0410060">TRESORERIE CONTRES</poste>
        <poste code="0800140">TRESORERIE CONTY</poste>
        <poste code="0910060">TRESORERIE CORBEIL-VILLABE</poste>
        <poste code="0910080">TRESORERIE CORBEIL-VILLABE MUNICIPALE</poste>
        <poste code="0910350">TRESORERIE ESSONNE AMENDES</poste>
        <poste code="0800150">TRESORERIE CORBIE</poste>
        <poste code="0580070">TRESORERIE CORBIGNY</poste>
        <poste code="0880520">TRESORERIE CORCIEUX</poste>
        <poste code="0810080">TRESORERIE CORDES-VAOUR</poste>
        <poste code="0220040">TRESORERIE CORLAY</poste>
        <poste code="0950060">TRESORERIE CORMEILLES-EN-PARISIS</poste>
        <poste code="0880100">TRESORERIE CORNIMONT</poste>
        <poste code="0380100">TRESORERIE CORPS</poste>
        <poste code="0190060">TRESORERIE CORREZE</poste>
        <poste code="02B0090">TRESORERIE CORTE-OMESSA</poste>
        <poste code="0580080">TRESORERIE COSNE-COURS-SUR-LOIRE</poste>
        <poste code="0530090">TRESORERIE DE COSSE-LE-VIVIEN</poste>
        <poste code="0710590">TRESORERIE DE COUCHES-PARIS-L'HOPITAL</poste>
        <poste code="0070120">TRESORERIE COUCOURON</poste>
        <poste code="0020090">TRESORERIE COUCY-LE-CHATEAU</poste>
        <poste code="0594060">TRESORERIE COUDEKERQUE-BRANCHE</poste>
        <poste code="0860060">TRESORERIE COUHE</poste>
        <poste code="0110180">TRESORERIE COUIZA</poste>
        <poste code="0770080">TRESORERIE DE COULOMMIERS</poste>
        <poste code="0790160">TRESORERIE DE COULONGES - VAL D'EGRAY</poste>
        <poste code="0920150">TRESORERIE COURBEVOIE</poste>
        <poste code="0920160">TRESORERIE COURBEVOIE MUNICIPALE</poste>
        <poste code="0570110">TRESORERIE COURCELLES-CHAUSSY</poste>
        <poste code="0170030">TRESORERIE COURCON-NUAILLE-D'AUNIS</poste>
        <poste code="0910070">TRESORERIE EVRY MUNICIPALE</poste>
        <poste code="0340090">TRESORERIE DE COURNONTERRAL</poste>
        <poste code="0630510">TRESORERIE COURPIERE</poste>
        <poste code="0140180">TRESORERIE COURSEULLES-SUR-MER</poste>
        <poste code="0890150">TRESORERIE DE COURSON-LES-CARRIERES-OUANNE</poste>
        <poste code="0450350">TRESORERIE COURTENAY</poste>
        <poste code="0280180">TRESORERIE COURVILLE-SUR-EURE</poste>
        <poste code="0500060">TRESORERIE COUTANCES</poste>
        <poste code="0330640">TRESORERIE COUTRAS</poste>
        <poste code="0170270">TRESORERIE COZES-MORTAGNE-SUR-GIRONDE</poste>
        <poste code="0530110">TRESORERIE DE CRAON</poste>
        <poste code="0430090">TRESORERIE CRAPONNE-SUR-ARZON</poste>
        <poste code="0800620">TRESORERIE DE CRECY-EN-PONTHIEU</poste>
        <poste code="0600350">TRESORERIE DE CREIL</poste>
        <poste code="0600440">TRESORERIE CREIL MUNICIPALE</poste>
        <poste code="0381050">TRESORERIE CREMIEU-TREPT</poste>
        <poste code="0330300">TRESORERIE DE CREON</poste>
        <poste code="0600360">TRESORERIE CREPY-EN-VALOIS</poste>
        <poste code="0260090">TRESORERIE CREST</poste>
        <poste code="0940080">TRESORERIE CRETEIL CENTRE HOSPITALIER</poste>
        <poste code="0940004">CE CENTRE ENCAISSEMENT CRETEIL</poste>
        <poste code="0940000">TRESORERIE GENERALE DU VAL-DE-MARNE</poste>
        <poste code="0940007">CENTRE REGIONAL DES PENSIONS DU VAL-DE-MARNE</poste>
        <poste code="0940008">CENTRE DE FORMATION DEPARTEMENTAL DU VAL-DE-MARNE</poste>
        <poste code="0940009">DEPARTEMENT INFORMATIQUE DU VAL-DE-MARNE</poste>
        <poste code="0940070">TRESORERIE CRETEIL</poste>
        <poste code="0940360">TRESORERIE DE CRETEIL MUNICIPALE</poste>
        <poste code="0940900">PAIERIE DEPARTEMENTALE DU VAL-DE-MARNE</poste>
        <poste code="0940001">SERVICE CONTRLE REDEVANCE AUDIOVISUELLE DU VAL DE MARNE</poste>
        <poste code="0571040">TRESORERIE CREUTZWALD</poste>
        <poste code="0762030">TRESORERIE CRIQUETOT-L'ESNEVAL</poste>
        <poste code="0230250">TRESORERIE DE CROCQ - LA COURTINE</poste>
        <poste code="0620200">TRESORERIE CROISILLES</poste>
        <poste code="0290090">TRESORERIE CROZON</poste>
        <poste code="0740140">TRESORERIE CRUSEILLES</poste>
        <poste code="0830050">TRESORERIE CUERS</poste>
        <poste code="0310440">TRESORERIE CUGNAUX</poste>
        <poste code="0593030">TRESORERIE DE CUINCY</poste>
        <poste code="0710090">TRESORERIE CUISEAUX</poste>
        <poste code="0710100">TRESORERIE CUISERY-MONTPONT-MONTRET</poste>
        <poste code="0630520">TRESORERIE CUNLHAT</poste>
        <poste code="0870210">TRESORERIE D' ORADOUR-SUR-VAYRES</poste>
        <poste code="0030180">TRESORERIE CUSSET</poste>
        <poste code="0110190">TRESORERIE CUXAC-CABARDES</poste>
        <poste code="1210000">TRESORERIE AMBASSADE DE FRANCE AU SENEGAL</poste>
        <poste code="0470190">TRESORERIE DAMAZAN</poste>
        <poste code="0670070">TRESORERIE DAMBACH-LA-VILLE</poste>
        <poste code="0772070">TRESORERIE DAMMARTIN-EN-GOELE-ST-SOUPPLETS</poste>
        <poste code="0390300">TRESORERIE DAMPIERRE</poste>
        <poste code="0700120">TRESORERIE DE DAMPIERRE-SUR-SALON-LAVONCOURT</poste>
        <poste code="0270040">TRESORERIE DAMVILLE</poste>
        <poste code="0550340">TRESORERIE DE DAMVILLERS</poste>
        <poste code="0860310">TRESORERIE DANGE-SAINT-ROMAIN</poste>
        <poste code="0681050">TRESORERIE DANNEMARIE</poste>
        <poste code="0290100">TRESORERIE DAOULAS</poste>
        <poste code="0880130">TRESORERIE DE DARNEY</poste>
        <poste code="0400230">TRESORERIE DAX</poste>
        <poste code="0400320">TRESORERIE DAX CENTRE HOSPITALIER</poste>
        <poste code="0140591">TRESORERIE ANNEXE DE DEAUVILLE</poste>
        <poste code="0120320">TRESORERIE DECAZEVILLE</poste>
        <poste code="0580090">TRESORERIE DECIZE</poste>
        <poste code="0900050">TRESORERIE DE DELLE</poste>
        <poste code="0570130">TRESORERIE DELME</poste>
        <poste code="0595040">TRESORERIE DE DENAIN IMPTS</poste>
        <poste code="0595050">TRESORERIE DENAIN MUNICIPALE</poste>
        <poste code="0360090">TRESORERIE CHATEAUROUX BANLIEUE</poste>
        <poste code="0440070">TRESORERIE DERVAL</poste>
        <poste code="0370140">TRESORERIE DESCARTES</poste>
        <poste code="0622100">TRESORERIE DESVRES</poste>
        <poste code="0760120">TRESORERIE DEVILLE-LES-ROUEN</poste>
        <poste code="0260100">TRESORERIE DIE</poste>
        <poste code="0760560">TRESORERIE DIEPPE CENTRE ET EST</poste>
        <poste code="0760570">TRESORERIE DIEPPE MUNICIPALE</poste>
        <poste code="0550350">TRESORERIE DE DIEUE-SUR-MEUSE</poste>
        <poste code="0260320">TRESORERIE DIEULEFIT-LA BEGUDE-DE-MAZENC</poste>
        <poste code="0570140">TRESORERIE DIEUZE</poste>
        <poste code="0040000">TRESORERIE GENERALE DES ALPES-DE-HAUTE-PROVENCE</poste>
        <poste code="0040080">TRESORERIE DIGNE-LES-BAINS</poste>
        <poste code="0040900">PAIERIE DEPARTEMENTALE DES ALPES-DE-HAUTE-PROVENCE</poste>
        <poste code="0710110">TRESORERIE DIGOIN</poste>
        <poste code="0210000">TRESORERIE GENERALE DE LA COTE-D'OR</poste>
        <poste code="0210007">CENTRE REGIONAL DES PENSIONS DE LA COTE-D'OR</poste>
        <poste code="0210008">CENTRE DE FORMATION DEPARTEMENTAL DE LA COTE-D'OR</poste>
        <poste code="0210009">DEPARTEMENT INFORMATIQUE DE LA COTE-D'OR</poste>
        <poste code="0210030">TRESORERIE DE DIJON BANLIEUE</poste>
        <poste code="0210110">TRESORERIE DIJON NORD</poste>
        <poste code="0210120">TRESORERIE DIJON SUD ET AMENDES</poste>
        <poste code="0210130">TRESORERIE DIJON MUNICIPALE</poste>
        <poste code="0210140">TRESORERIE DIJON CHU</poste>
        <poste code="0210800">PAIERIE REGIONALE DE BOURGOGNE</poste>
        <poste code="0210900">PAIERIE DEPARTEMENTALE DE LA COTE-D'OR</poste>
        <poste code="0210001">SERVICE CONTRLE REDEVANCE AUDIOVISUELLE DE LA CTE D'OR</poste>
        <poste code="0210080">TRESORERIE DIJON OPAC ET OPDHLM</poste>
        <poste code="0220250">TRESORERIE DE DINAN VILLE ET BANLIEUE</poste>
        <poste code="0350440">TRESORERIE DE DINARD</poste>
        <poste code="0140490">TRESORERIE DIVES-SUR-MER</poste>
        <poste code="1710000">TRESORERIE AMBASSADE DE FRANCE EN REPUBLIQUE DE DJIBOUTI</poste>
        <poste code="0880150">TRESORERIE DOCELLES</poste>
        <poste code="0350450">TRESORERIE DE DOL-DE-BRETAGNE</poste>
        <poste code="0390310">TRESORERIE DOLE COLLEGIALE</poste>
        <poste code="0390320">TRESORERIE DOLE MUNICIPALE</poste>
        <poste code="0380120">TRESORERIE DOMENE</poste>
        <poste code="0610120">TRESORERIE DE DOMFRONT</poste>
        <poste code="0240090">TRESORERIE DOMME</poste>
        <poste code="0880170">TRESORERIE DOMPAIRE-VAUBEXY</poste>
        <poste code="0710190">TRESORERIE DE MATOUR</poste>
        <poste code="0030050">TRESORERIE DOMPIERRE-SUR-BESBRE</poste>
        <poste code="0770090">TRESORERIE DONNEMARIE-DONTILLY</poste>
        <poste code="0580100">TRESORERIE DONZY-CHATEAUNEUF-VAL-DE-BARGIS</poste>
        <poste code="0510340">TRESORERIE DE DORMANS</poste>
        <poste code="0580110">TRESORERIE DORNES</poste>
        <poste code="0593000">RECETTE DES FINANCES DOUAI</poste>
        <poste code="0593040">TRESORERIE DE DOUAI</poste>
        <poste code="0593050">TRESORERIE DOUAI MUNICIPALE</poste>
        <poste code="0292040">TRESORERIE DOUARNENEZ</poste>
        <poste code="0595060">TRESORERIE DOUCHY-LES-MINES</poste>
        <poste code="0760130">TRESORERIE DOUDEVILLE</poste>
        <poste code="0490510">TRESORERIE DOUE-LA-FONTAINE</poste>
        <poste code="0520150">TRESORERIE DOULAINCOURT-SAUCOURT</poste>
        <poste code="0550360">TRESORERIE DE DUN-SUR-MEUSE</poste>
        <poste code="0520160">TRESORERIE DOULEVANT-LE-CHATEAU</poste>
        <poste code="0800680">TRESORERIE DOULLENS</poste>
        <poste code="0910090">TRESORERIE DOURDAN</poste>
        <poste code="0810220">TRESORERIE DOURGNE</poste>
        <poste code="0740150">TRESORERIE DOUVAINE-BONS-EN-CHABLAIS</poste>
        <poste code="0140200">TRESORERIE DOUVRES-LA-DELIVRANDE</poste>
        <poste code="0620650">TRESORERIE DOUVRIN</poste>
        <poste code="0140500">TRESORERIE DOZULE</poste>
        <poste code="0831070">TRESORERIE DE DRAGUIGNAN IMPOTS</poste>
        <poste code="0831000">RECETTE DES FINANCES DRAGUIGNAN</poste>
        <poste code="0831080">TRESORERIE DRAGUIGNAN MUNICIPALE</poste>
        <poste code="0930080">TRESORERIE DRANCY</poste>
        <poste code="0930090">TRESORERIE DRANCY MUNICIPALE</poste>
        <poste code="0910100">TRESORERIE DRAVEIL</poste>
        <poste code="0280360">TRESORERIE DE DREUX MUNICIPALE</poste>
        <poste code="0280350">TRESORERIE DE DREUX ET PAYS DROUAIS</poste>
        <poste code="0410240">TRESORERIE DE DROUE</poste>
        <poste code="0671040">TRESORERIE DRULINGEN</poste>
        <poste code="0671050">TRESORERIE DRUSENHEIM</poste>
        <poste code="0500270">TRESORERIE DUCEY</poste>
        <poste code="0760140">TRESORERIE DUCLAIR</poste>
        <poste code="0230070">TRESORERIE DUN-LE-PALESTEL</poste>
        <poste code="0180150">TRESORERIE DUN-SUR-AURON</poste>
        <poste code="0594000">RECETTE DES FINANCES DUNKERQUE</poste>
        <poste code="0594080">TRESORERIE DUNKERQUE MUNICIPALE ET COM.URB</poste>
        <poste code="0594160">TRESORERIE DUNKERQUE ET. HOSP.</poste>
        <poste code="0594070">TRESORERIE DE DUNKERQUE</poste>
        <poste code="0470200">TRESORERIE DURAS</poste>
        <poste code="0110420">TRESORERIE DURBAN-CORBIERES</poste>
        <poste code="0490130">TRESORERIE DURTAL</poste>
        <poste code="0950070">TRESORERIE EAUBONNE</poste>
        <poste code="0320250">TRESORERIE MONTREAL</poste>
        <poste code="0320090">TRESORERIE EAUZE</poste>
        <poste code="0030200">TRESORERIE EBREUIL-BELLENAVES</poste>
        <poste code="0700130">TRESORERIE ECHENOZ-LA-MELINE-ET-COLOMBIER</poste>
        <poste code="0380130">TRESORERIE ECHIROLLES</poste>
        <poste code="0720160">TRESORERIE ECOMMOY</poste>
        <poste code="0270250">TRESORERIE ECOS ET TOURNY</poste>
        <poste code="0610320">TRESORERIE D' ECOUCHE</poste>
        <poste code="0951010">TRESORERIE ECOUEN</poste>
        <poste code="0690050">TRESORERIE D' ECULLY</poste>
        <poste code="0190070">TRESORERIE EGLETONS</poste>
        <poste code="0540360">TRESORERIE EINVILLE-AU-JARD</poste>
        <poste code="0760150">TRESORERIE D' ELBEUF</poste>
        <poste code="0660070">TRESORERIE ELNE</poste>
        <poste code="0560020">TRESORERIE ELVEN</poste>
        <poste code="0050050">TRESORERIE D' EMBRUN-SAVINES</poste>
        <poste code="0951020">TRESORERIE D' ENGHIEN-LES-BAINS</poste>
        <poste code="0630600">TRESORERIE ENNEZAT</poste>
        <poste code="0680070">TRESORERIE ENSISHEIM</poste>
        <poste code="0120060">TRESORERIE D' ENTRAYGUES-SAINT-AMANS</poste>
        <poste code="0760580">TRESORERIE ENVERMEU</poste>
        <poste code="0710600">TRESORERIE D' EPINAC</poste>
        <poste code="0880220">TRESORERIE D' HADOL-DARNIEULLES</poste>
        <poste code="0880000">TRESORERIE GENERALE DES VOSGES</poste>
        <poste code="0880190">TRESORERIE D' EPINAL-POINCARE</poste>
        <poste code="0880490">TRESORERIE DES VOSGES-OPHLM VILLE D'EPINAL</poste>
        <poste code="0880900">PAIERIE DEPARTEMENTALE DES VOSGES</poste>
        <poste code="0880180">TRESORERIE D' EPINAL AUBERT</poste>
        <poste code="0931050">TRESORERIE EPINAY-SUR-SEINE</poste>
        <poste code="0781030">TRESORERIE EPONE</poste>
        <poste code="0500430">TRESORERIE EQUEURDREVILLE-HAINNEVILLE</poste>
        <poste code="0950100">TRESORERIE ERMONT</poste>
        <poste code="0530120">TRESORERIE D' ERNEE</poste>
        <poste code="0670120">TRESORERIE ERSTEIN</poste>
        <poste code="0120070">TRESORERIE ESPALION</poste>
        <poste code="0540030">TRESORERIE ESSEY-LES-NANCY</poste>
        <poste code="0120080">TRESORERIE ESTAING</poste>
        <poste code="0100150">TRESORERIE D' ESTISSAC</poste>
        <poste code="0600480">TRESORERIE ESTREES-SAINT-DENIS</poste>
        <poste code="0220050">TRESORERIE ETABLES-SUR-MER</poste>
        <poste code="0550370">TRESORERIE ETAIN</poste>
        <poste code="0910370">TRESORERIE D' ETAMPES</poste>
        <poste code="0910380">TRESORERIE D' ETAMPES COLLECTIVITES</poste>
        <poste code="0710620">TRESORERIE DE SAINT-LEGER-SOUS-BEUVRAY</poste>
        <poste code="0622190">TRESORERIE ETAPLES</poste>
        <poste code="0330720">TRESORERIE ETAULIERS</poste>
        <poste code="0560260">TRESORERIE BELZ</poste>
        <poste code="0270260">TRESORERIE ETREPAGNY</poste>
        <poste code="0760590">TRESORERIE EU</poste>
        <poste code="0230260">TRESORERIE D' EVAUX-LES-BAINS</poste>
        <poste code="0740160">TRESORERIE EVIAN-LES-BAINS</poste>
        <poste code="0270000">TRESORERIE GENERALE DE L' EURE</poste>
        <poste code="0270060">TRESORERIE EVREUX MUNICIPALE</poste>
        <poste code="0270420">TRESORERIE D' EVREUX ETABLIS HOSPITALIERS</poste>
        <poste code="0270900">PAIERIE DEPARTEMENTALE DE L' EURE</poste>
        <poste code="0270050">TRESORERIE EVREUX</poste>
        <poste code="0270001">SERVICE CONTRLE REDEVANCE AUDIOVISUELLE DE L' EURE</poste>
        <poste code="0530130">TRESORERIE D' EVRON</poste>
        <poste code="0910000">TRESORERIE GENERALE DE L' ESSONNE</poste>
        <poste code="0910360">TRESORERIE EVRY</poste>
        <poste code="0910900">PAIERIE DEPARTEMENTALE DE L' ESSONNE</poste>
        <poste code="9500000">PAIERIE GENERALE AUX ARMEES</poste>
        <poste code="0910001">SERVICE CONTRLE REDEVANCE AUDIOVISUELLE DE L' ESSONNE</poste>
        <poste code="0240120">TRESORERIE HAUTEFORT</poste>
        <poste code="0240100">TRESORERIE D' EXCIDEUIL</poste>
        <poste code="0132070">TRESORERIE MALLEMORT</poste>
        <poste code="0132060">TRESORERIE EYGUIERES</poste>
        <poste code="0190080">TRESORERIE EYGURANDE</poste>
        <poste code="0240490">TRESORERIE EYMET</poste>
        <poste code="0870100">TRESORERIE EYMOUTIERS</poste>
        <poste code="0951060">TRESORERIE EZANVILLE</poste>
        <poste code="0140230">TRESORERIE FALAISE</poste>
        <poste code="0571050">TRESORERIE FAULQUEMONT</poste>
        <poste code="0622290">TRESORERIE FAUQUEMBERGUES</poste>
        <poste code="0762120">TRESORERIE FAUVILLE-EN-CAUX</poste>
        <poste code="0740170">TRESORERIE FAVERGES</poste>
        <poste code="0430100">TRESORERIE FAY-SUR-LIGNON</poste>
        <poste code="0831090">TRESORERIE FAYENCE</poste>
        <poste code="0762050">TRESORERIE FECAMP</poste>
        <poste code="0762060">TRESORERIE FECAMP MUNICIPALE</poste>
        <poste code="0230270">TRESORERIE DE FELLETIN - GENTIOUX PIGEROLLES</poste>
        <poste code="0570170">TRESORERIE FENETRANGE</poste>
        <poste code="0010130">TRESORERIE FERNEY-VOLTAIRE</poste>
        <poste code="0681080">TRESORERIE FERRETTE</poste>
        <poste code="0450360">TRESORERIE FERRIERES-EN GATINAIS</poste>
        <poste code="0422190">TRESORERIE DE FEURS</poste>
        <poste code="0460090">TRESORERIE FIGEAC</poste>
        <poste code="0420030">TRESORERIE FIRMINY</poste>
        <poste code="0512030">TRESORERIE DE FISMES</poste>
        <poste code="0610340">TRESORERIE DE FLERS ET MESSEI</poste>
        <poste code="0320110">TRESORERIE FLEURANCE</poste>
        <poste code="0270270">TRESORERIE FLEURY-SUR-ANDELLE</poste>
        <poste code="0800690">TRESORERIE FLIXECOURT</poste>
        <poste code="0480070">TRESORERIE FLORAC-BARRE-DES-CEVENNES</poste>
        <poste code="0570630">TRESORERIE FLORANGE</poste>
        <poste code="0090000">TRESORERIE GENERALE DE L' ARIEGE</poste>
        <poste code="0090070">TRESORERIE FOIX</poste>
        <poste code="0090080">TRESORERIE FOIX BANLIEUE</poste>
        <poste code="0090900">PAIERIE DEPARTEMENTALE DE L' ARIEGE</poste>
        <poste code="0380410">TRESORERIE DE FONTAINE</poste>
        <poste code="0210170">TRESORERIE FONTAINE-FRANCAISE</poste>
        <poste code="0760700">TRESORERIE FONTAINE-LE-DUN</poste>
        <poste code="0770340">TRESORERIE FONTAINEBLEAU MUNICIPALE</poste>
        <poste code="0850210">TRESORERIE DE FONTENAY-LE-COMTE</poste>
        <poste code="0941040">TRESORERIE DE FONTENAY-SOUS-BOIS</poste>
        <poste code="0570180">TRESORERIE FONTOY</poste>
        <poste code="0571070">TRESORERIE DE FORBACH PORTE DE FRANCE</poste>
        <poste code="0040100">TRESORERIE FORCALQUIER</poste>
        <poste code="0760710">TRESORERIE FORGES-LES-EAUX</poste>
        <poste code="0600180">TRESORERIE DE FORMERIE-SONGEONS</poste>
        <poste code="1030007">CENTRE REGIONAL DES PENSIONS DE LA MARTINIQUE</poste>
        <poste code="1030008">CENTRE DE FORMATION DEPARTEMENTAL DE LA MARTINIQUE</poste>
        <poste code="1030009">DEPARTEMENT INFORMATIQUE DE LA MARTINIQUE</poste>
        <poste code="1030040">TRESORERIE FORT-DE-FRANCE CTRE HOSP.</poste>
        <poste code="1030000">TRESORERIE GENERALE DE LA MARTINIQUE</poste>
        <poste code="1030020">TRESORERIE FORT-DE-FRANCE EST-AMENDES</poste>
        <poste code="1030030">TRESORERIE DE FORT-DE-FRANCE MUNICIPALE</poste>
        <poste code="1030120">TRESORERIE DE FORT-DE-FRANCE OUEST ET BANLIEUE</poste>
        <poste code="1030800">PAIERIE REGIONALE DE LA MARTINIQUE</poste>
        <poste code="1030900">PAIERIE DEPARTEMENTALE DE LA MARTINIQUE</poste>
        <poste code="0292050">TRESORERIE FOUESNANT</poste>
        <poste code="0350110">TRESORERIE DE FOUGERES</poste>
        <poste code="0350120">TRESORERIE DE FOUGERES COLLECTIVITS</poste>
        <poste code="0700160">TRESORERIE FOUGEROLLES</poste>
        <poste code="0595200">TRESORERIE FOURMIES</poste>
        <poste code="0780290">TRESORERIE FOURQUEUX</poste>
        <poste code="0880530">TRESORERIE FRAIZE</poste>
        <poste code="0950290">TRESORERIE SAINT-LEU-FRANCONVILLE</poste>
        <poste code="0740180">TRESORERIE FRANGY</poste>
        <poste code="0831100">TRESORERIE FREJUS</poste>
        <poste code="0720200">TRESORERIE FRESNAY-SUR-SARTHE</poste>
        <poste code="0700170">TRESORERIE FRESNE-SAINT-MAMES-FRETIGNEY</poste>
        <poste code="0940280">TRESORERIE DE FRESNES</poste>
        <poste code="0550380">TRESORERIE FRESNES-EN-WOEVRE</poste>
        <poste code="0620240">TRESORERIE D' AUXI-LE-CHATEAU-FREVENT</poste>
        <poste code="0571080">TRESORERIE FREYMING-MERLEBACH</poste>
        <poste code="0800600">TRESORERIE FRIVILLE-ESCARBOTIN</poste>
        <poste code="0600190">TRESORERIE FROISSY</poste>
        <poste code="0790200">TRESORERIE FRONTENAY-ROHAN-ROHAN</poste>
        <poste code="0730160">TRESORERIE GRESY-SUR-ISERE</poste>
        <poste code="0340100">TRESORERIE FRONTIGNAN</poste>
        <poste code="0310110">TRESORERIE FRONTON</poste>
        <poste code="0622200">TRESORERIE FRUGES</poste>
        <poste code="0080190">TRESORERIE FUMAY</poste>
        <poste code="0470210">TRESORERIE FUMEL</poste>
        <poste code="0400020">TRESORERIE GABARRET</poste>
        <poste code="0610350">TRESORERIE DE GACE</poste>
        <poste code="0930110">TRESORERIE DE GAGNY</poste>
        <poste code="0810090">TRESORERIE DE GAILLAC-CADALEN</poste>
        <poste code="0270280">TRESORERIE GAILLON</poste>
        <poste code="0800630">TRESORERIE GAMACHES</poste>
        <poste code="0340110">TRESORERIE GANGES</poste>
        <poste code="0030220">TRESORERIE GANNAT</poste>
        <poste code="0050000">TRESORERIE GENERALE DES HAUTES-ALPES</poste>
        <poste code="0050060">TRESORERIE DE GAP</poste>
        <poste code="0050900">PAIERIE DEPARTEMENTALE DES HAUTES-ALPES</poste>
        <poste code="0780080">TRESORERIE GARANCIERES</poste>
        <poste code="0131060">TRESORERIE GARDANNE</poste>
        <poste code="0781040">TRESORERIE GARGENVILLE</poste>
        <poste code="0951100">TRESORERIE GARGES-LES-GONESSE</poste>
        <poste code="0640090">TRESORERIE GARLIN</poste>
        <poste code="0400030">TRESORERIE GEAUNE</poste>
        <poste code="0170280">TRESORERIE GEMOZAC-TESSON</poste>
        <poste code="0860070">TRESORERIE GENCAY</poste>
        <poste code="0210180">TRESORERIE GENLIS</poste>
        <poste code="0490340">TRESORERIE GENNES</poste>
        <poste code="0920180">TRESORERIE GENNEVILLIERS</poste>
        <poste code="0300470">TRESORERIE GENOLHAC</poste>
        <poste code="0880540">TRESORERIE GERARDMER</poste>
        <poste code="0210190">TRESORERIE GEVREY-CHAMBERTIN</poste>
        <poste code="0010140">TRESORERIE GEX</poste>
        <poste code="02B0190">TRESORERIE PRUNELLI-DI-FIUMORBO</poste>
        <poste code="0450370">TRESORERIE GIEN</poste>
        <poste code="0340120">TRESORERIE GIGNAC</poste>
        <poste code="0320120">TRESORERIE GIMONT</poste>
        <poste code="0110440">TRESORERIE GINESTAS</poste>
        <poste code="0900060">TRESORERIE GIROMAGNY</poste>
        <poste code="0270290">TRESORERIE GISORS</poste>
        <poste code="0080200">TRESORERIE GIVET</poste>
        <poste code="0690070">TRESORERIE DE GIVORS</poste>
        <poste code="0710510">TRESORERIE GIVRY-MERCUREY</poste>
        <poste code="0762070">TRESORERIE GODERVILLE</poste>
        <poste code="0380140">TRESORERIE GONCELIN</poste>
        <poste code="0160220">TRESORERIE GOND-PONTOUVRE</poste>
        <poste code="0550120">TRESORERIE DE GONDRECOURT-LE-CHATEAU</poste>
        <poste code="0951030">TRESORERIE GONESSE</poste>
        <poste code="0840120">TRESORERIE GORDES</poste>
        <poste code="0530150">TRESORERIE DE GORRON</poste>
        <poste code="0310490">TRESORERIE DE GOURDAN-POLIGNAN</poste>
        <poste code="0460100">TRESORERIE GOURDON</poste>
        <poste code="0560220">TRESORERIE DE GOURIN-LE FAOUET</poste>
        <poste code="0760720">TRESORERIE GOURNAY-EN-BRAY</poste>
        <poste code="0230090">TRESORERIE GOUZON</poste>
        <poste code="0180170">TRESORERIE DE GRACAY</poste>
        <poste code="0460110">TRESORERIE GRAMAT</poste>
        <poste code="1010050">TRESORERIE MARIE-GALANTE</poste>
        <poste code="0760230">TRESORERIE GRAND-COURONNE</poste>
        <poste code="0080210">TRESORERIE GRANDPRE</poste>
        <poste code="0600200">TRESORERIE GRANDVILLIERS</poste>
        <poste code="0880550">TRESORERIE GRANGES-SUR-VOLOGNE</poste>
        <poste code="0500080">TRESORERIE GRANVILLE</poste>
        <poste code="0061180">TRESORERIE GRASSE LA PAOUTE</poste>
        <poste code="0061090">TRESORERIE GRASSE MUNICIPALE ET BANLIEUE</poste>
        <poste code="0061000">RECETTE DES FINANCES GRASSE</poste>
        <poste code="0810230">TRESORERIE GRAULHET</poste>
        <poste code="0594090">TRESORERIE GRAVELINES</poste>
        <poste code="0700190">TRESORERIE GRAY-AUTREY</poste>
        <poste code="0310120">TRESORERIE GRENADE</poste>
        <poste code="0400040">TRESORERIE GRENADE-SUR-L'ADOUR</poste>
        <poste code="0380007">CENTRE REGIONAL DES PENSIONS DE L' ISERE</poste>
        <poste code="0380008">CENTRE DE FORMATION DEPARTEMENTAL DE L' ISERE</poste>
        <poste code="0380009">DEPARTEMENT INFORMATIQUE DE L' ISERE</poste>
        <poste code="0380180">TRESORERIE DE GRENOBLE AMENDES &amp; PROD DIVERS</poste>
        <poste code="0380190">TRESORERIE GRENOBLE MUNICIPALE</poste>
        <poste code="0380191">TRESORERIE DE GRENOBLE MUNICIPALE SERV. EAUX</poste>
        <poste code="0380540">TRESORERIE DE L' OPAC GRENOBLOIS-ACTIS</poste>
        <poste code="0380900">PAIERIE DEPARTEMENTALE DE L' ISERE</poste>
        <poste code="0380001">SERVICE CONTRLE REDEVANCE AUDIOVISUELLE DE L' ISERE</poste>
        <poste code="0380000">TRESORERIE GENERALE DE L' ISERE</poste>
        <poste code="0380170">TRESORERIE DE GRENOBLE</poste>
        <poste code="0260330">TRESORERIE GRIGNAN-TAULIGNAN</poste>
        <poste code="0910340">TRESORERIE GRIGNY</poste>
        <poste code="0831110">TRESORERIE GRIMAUD</poste>
        <poste code="0820070">TRESORERIE GRISOLLES</poste>
        <poste code="0571090">TRESORERIE GROSTENQUIN-MORHANGE</poste>
        <poste code="0680080">TRESORERIE DE GUEBWILLER</poste>
        <poste code="0440360">TRESORERIE DE GUEMENE-PENFAO</poste>
        <poste code="0560230">TRESORERIE GUEMENE-SUR-SCORFF</poste>
        <poste code="0560040">TRESORERIE GUER</poste>
        <poste code="0441060">TRESORERIE GUERANDE</poste>
        <poste code="0230000">TRESORERIE GENERALE DE LA CREUSE</poste>
        <poste code="0230110">TRESORERIE GUERET</poste>
        <poste code="0230180">TRESORERIE GUERET PIQUERELLE</poste>
        <poste code="0230900">PAIERIE DEPARTEMENTALE DE LA CREUSE</poste>
        <poste code="0580130">TRESORERIE GUERIGNY</poste>
        <poste code="0710120">TRESORERIE GUEUGNON-ISSY-L'EVEQUE</poste>
        <poste code="0350150">TRESORERIE GUICHEN</poste>
        <poste code="0770130">TRESORERIE GUIGNES</poste>
        <poste code="0020210">TRESORERIE GUIGNICOURT-NEUFCHATEL</poste>
        <poste code="0060050">TRESORERIE DE GUILLAUMES</poste>
        <poste code="0050080">TRESORERIE GUILLESTRE</poste>
        <poste code="0622110">TRESORERIE GUINES</poste>
        <poste code="0220340">TRESORERIE GUINGAMP</poste>
        <poste code="0290120">TRESORERIE DE BREST BANLIEUE</poste>
        <poste code="0020540">TRESORERIE GUISE</poste>
        <poste code="0330660">TRESORERIE GUITRES-SAINT-DENIS-DE-PILE</poste>
        <poste code="0700210">TRESORERIE GY</poste>
        <poste code="0400050">TRESORERIE HAGETMAU</poste>
        <poste code="0671060">TRESORERIE D' HAGUENAU</poste>
        <poste code="0671070">TRESORERIE HAGUENAU MUNICIPALE</poste>
        <poste code="0671000">RECETTE DES FINANCES D' HAGUENAU</poste>
        <poste code="0800640">TRESORERIE HALLENCOURT-AIRAINES</poste>
        <poste code="0590120">TRESORERIE HALLUIN</poste>
        <poste code="0800540">TRESORERIE HAM-NESLE</poste>
        <poste code="0762080">TRESORERIE HARFLEUR</poste>
        <poste code="0540080">TRESORERIE D' HAROUE-VEZELISE</poste>
        <poste code="0640400">TRESORERIE D' HASPARREN</poste>
        <poste code="0671080">TRESORERIE HATTEN</poste>
        <poste code="0590130">TRESORERIE DE LOOS-LES-WEPPES</poste>
        <poste code="0260110">TRESORERIE LE GRAND-SERRE-MORAS</poste>
        <poste code="0010150">TRESORERIE HAUTEVILLE-LOMPNES</poste>
        <poste code="0595210">TRESORERIE HAUTMONT</poste>
        <poste code="0570220">TRESORERIE HAYANGE</poste>
        <poste code="0594180">TRESORERIE HAZEBROUCK</poste>
        <poste code="0640390">TRESORERIE HENDAYE</poste>
        <poste code="0620670">TRESORERIE D' HENIN-BEAUMONT</poste>
        <poste code="0620680">TRESORERIE HENIN-BEAUMONT MUNICIPALE</poste>
        <poste code="0560280">TRESORERIE HENNEBONT</poste>
        <poste code="0441070">TRESORERIE HERBIGNAC</poste>
        <poste code="0700220">TRESORERIE HERICOURT-ET-CHAMPEY</poste>
        <poste code="0250390">TRESORERIE HERIMONCOURT</poste>
        <poste code="0030230">TRESORERIE HERISSON</poste>
        <poste code="0512050">TRESORERIE D' HERMONVILLE</poste>
        <poste code="0140470">TRESORERIE HEROUVILLE-SAINT-CLAIR</poste>
        <poste code="0620690">TRESORERIE HERSIN-COUPIGNY</poste>
        <poste code="0622210">TRESORERIE D' HESDIN-LE-PARCQ</poste>
        <poste code="0381040">TRESORERIE HEYRIEUX</poste>
        <poste code="0681100">TRESORERIE HIRSINGUE</poste>
        <poste code="0020670">TRESORERIE D' HIRSON</poste>
        <poste code="0670180">TRESORERIE HOCHFELDEN</poste>
        <poste code="0670200">TRESORERIE HOERDT</poste>
        <poste code="0594100">TRESORERIE HONDSCHOOTE</poste>
        <poste code="0140510">TRESORERIE HONFLEUR</poste>
        <poste code="0800700">TRESORERIE HORNOY-LE-BOURG</poste>
        <poste code="0620700">TRESORERIE HOUDAIN</poste>
        <poste code="0781050">TRESORERIE DE HOUILLES</poste>
        <poste code="0622220">TRESORERIE HUCQUELIERS</poste>
        <poste code="0030240">TRESORERIE HURIEL-COURCAIS</poste>
        <poste code="0830070">TRESORERIE HYERES MUNICIPALE</poste>
        <poste code="0830060">TRESORERIE HYERES</poste>
        <poste code="0640410">TRESORERIE IHOLDY</poste>
        <poste code="0660090">TRESORERIE ILLE-SUR-TET</poste>
        <poste code="0280220">TRESORERIE ILLIERS-COMBRAY</poste>
        <poste code="0670220">TRESORERIE ILLKIRCH-GRAFFENSTADEN</poste>
        <poste code="0671090">TRESORERIE INGWILLER</poste>
        <poste code="0210210">TRESORERIE IS-SUR-TILLE</poste>
        <poste code="0620710">TRESORERIE ISBERGUES</poste>
        <poste code="0140270">TRESORERIE ISIGNY-SUR-MER</poste>
        <poste code="0870350">TRESORERIE OPDHLM DE LA HAUTE-VIENNE</poste>
        <poste code="0630140">TRESORERIE ISSOIRE</poste>
        <poste code="0360170">TRESORERIE D' ISSOUDUN</poste>
        <poste code="0920190">TRESORERIE D' ISSY-LES-MOULINEAUX</poste>
        <poste code="0132140">TRESORERIE D' ISTRES</poste>
        <poste code="0270080">TRESORERIE IVRY-LA-BATAILLE</poste>
        <poste code="0940130">TRESORERIE IVRY-SUR-SEINE</poste>
        <poste code="0940140">TRESORERIE IVRY-SUR-SEINE MUNICIPALE</poste>
        <poste code="0280230">TRESORERIE JANVILLE</poste>
        <poste code="0350170">TRESORERIE JANZE</poste>
        <poste code="0450120">TRESORERIE JARGEAU</poste>
        <poste code="0160240">TRESORERIE JARNAC</poste>
        <poste code="0540420">TRESORERIE DE JARNY-CHAMBLEY</poste>
        <poste code="0540410">TRESORERIE DE CONFLANS-EN-JARNISY</poste>
        <poste code="0320150">TRESORERIE JEGUN</poste>
        <poste code="0595220">TRESORERIE JEUMONT</poste>
        <poste code="0540430">TRESORERIE DE JOEUF</poste>
        <poste code="0890230">TRESORERIE JOIGNY</poste>
        <poste code="0520180">TRESORERIE JOINVILLE ET POISSONS</poste>
        <poste code="0170290">TRESORERIE JONZAC</poste>
        <poste code="0560050">TRESORERIE JOSSELIN</poste>
        <poste code="0370390">TRESORERIE DE TOURS BANLIEUE OUEST</poste>
        <poste code="0070140">TRESORERIE JOYEUSE</poste>
        <poste code="0220280">TRESORERIE JUGON-LES-LACS</poste>
        <poste code="0190270">TRESORERIE DE JUILLAC</poste>
        <poste code="0630160">TRESORERIE JUMEAUX</poste>
        <poste code="0080220">TRESORERIE JUNIVILLE</poste>
        <poste code="0700230">TRESORERIE DE JUSSEY-VITREY</poste>
        <poste code="0911050">TRESORERIE JUVISY-SUR-ORGE</poste>
        <poste code="0680090">TRESORERIE KAYSERSBERG</poste>
        <poste code="1620020">TRESORERIE DE LA PROVINCE NORD</poste>
        <poste code="1020040">TRESORERIE KOUROU</poste>
        <poste code="0610160">TRESORERIE DE L'AIGLE</poste>
        <poste code="0690010">TRESORERIE L'ARBRESLE</poste>
        <poste code="0050010">TRESORERIE L'ARGENTIERE-LA-BESSEE</poste>
        <poste code="0060040">TRESORERIE L'ESCARENE</poste>
        <poste code="0940120">TRESORERIE L'HAY-LES-ROSES</poste>
        <poste code="0370150">TRESORERIE L'ILE-BOUCHARD</poste>
        <poste code="0850310">TRESORERIE DE L'ILE-D'YEU</poste>
        <poste code="02B0100">TRESORERIE L'ILE-ROUSSE</poste>
        <poste code="0950120">TRESORERIE L'ISLE-ADAM</poste>
        <poste code="0310500">TRESORERIE L'ISLE-EN-DODON</poste>
        <poste code="0860080">TRESORERIE L'ISLE JOURDAIN</poste>
        <poste code="0320140">TRESORERIE L'ISLE-JOURDAIN</poste>
        <poste code="0840130">TRESORERIE DE L'ISLE-SUR-LA-SORGUE</poste>
        <poste code="0250400">TRESORERIE DE L'ISLE-SUR-LE-DOUBS</poste>
        <poste code="0890220">TRESORERIE L'ISLE-SUR-SEREIN</poste>
        <poste code="0310320">TRESORERIE DE L'UNION</poste>
        <poste code="0650060">TRESORERIE LA BARTHE-DE-NESTE</poste>
        <poste code="0590070">TRESORERIE DE LA BASSEE</poste>
        <poste code="0090030">TRESORERIE LA BASTIDE-DE-SEROU</poste>
        <poste code="0441040">TRESORERIE DE LA BAULE-ESCOUBLAC</poste>
        <poste code="0480040">TRESORERIE LA CANOURGUE-ST-GERMAIN-DU-TEIL</poste>
        <poste code="0020660">TRESORERIE LA CAPELLE</poste>
        <poste code="0780410">TRESORERIE LA CELLE-SAINT-CLOUD</poste>
        <poste code="0430070">TRESORERIE LA CHAISE-DIEU</poste>
        <poste code="0730110">TRESORERIE LA CHAMBRE</poste>
        <poste code="0710030">TRESORERIE LA CHAPELLE-DE-GUINCHAY</poste>
        <poste code="0260060">TRESORERIE LA CHAPELLE-EN-VERCORS</poste>
        <poste code="0770310">TRESORERIE LA CHAPELLE-LA REINE-LARCHANT</poste>
        <poste code="0580020">TRESORERIE LA CHARITE-SUR-LOIRE</poste>
        <poste code="0850200">TRESORERIE DU PAYS DE LA CHATAIGNERAIE</poste>
        <poste code="0360120">TRESORERIE DE LA CHATRE</poste>
        <poste code="0220020">TRESORERIE LA CHEZE</poste>
        <poste code="0130030">TRESORERIE LA CIOTAT</poste>
        <poste code="0710060">TRESORERIE LA CLAYETTE</poste>
        <poste code="0381020">TRESORERIE LA COTE-SAINT-ANDRE</poste>
        <poste code="0931040">TRESORERIE LA COURNEUVE MUNICIPALE</poste>
        <poste code="0160200">TRESORERIE LA COURONNE</poste>
        <poste code="0790060">TRESORERIE LA CRECHE</poste>
        <poste code="0020130">TRESORERIE LA FERE</poste>
        <poste code="0910120">TRESORERIE LA FERTE-ALAIS</poste>
        <poste code="0720170">TRESORERIE LA FERTE-BERNARD</poste>
        <poste code="0610330">TRESORERIE DE LA FERTE-FRENEL</poste>
        <poste code="0770100">TRESORERIE LA-FERTE-GAUCHER-CHOISY-EN-BRIE</poste>
        <poste code="0772100">TRESORERIE LA FERTE-SOUS-JOUARRE</poste>
        <poste code="0610130">TRESORERIE LA FERTE-MACE</poste>
        <poste code="0450090">TRESORERIE LA FERTE-SAINT-AUBIN</poste>
        <poste code="0760690">TRESORERIE LA FEUILLIE</poste>
        <poste code="0720180">TRESORERIE DE LA FLECHE</poste>
        <poste code="1620070">TRESORERIE DE LA FOA</poste>
        <poste code="0240510">TRESORERIE DE LA FORCE</poste>
        <poste code="0560030">TRESORERIE LA GACILLY</poste>
        <poste code="0920170">TRESORERIE LA GARENNE-COLOMBES</poste>
        <poste code="0300480">TRESORERIE DE LA GRAND-COMBE</poste>
        <poste code="0350140">TRESORERIE LA GUERCHE-DE-BRETAGNE</poste>
        <poste code="0180180">TRESORERIE LA GUERCHE-SUR-L'AUBOIS</poste>
        <poste code="0710130">TRESORERIE DE LA GUICHE</poste>
        <poste code="0500090">TRESORERIE LA HAYE-DU-PUITS</poste>
        <poste code="0500280">TRESORERIE LA HAYE-PESNEL</poste>
        <poste code="0170040">TRESORERIE LA JARRIE</poste>
        <poste code="0280240">TRESORERIE LA LOUPE</poste>
        <poste code="0580160">TRESORERIE LA MACHINE</poste>
        <poste code="0590270">TRESORERIE LA MADELEINE</poste>
        <poste code="0850320">TRESORERIE LA MOTHE-ACHARD</poste>
        <poste code="0790270">TRESORERIE LA MOTHE-SAINT-HERAY</poste>
        <poste code="0040160">TRESORERIE LA MOTTE.TURRIERS</poste>
        <poste code="0730390">TRESORERIE DE LA MOTTE SERVOLEX</poste>
        <poste code="0380290">TRESORERIE LA MURE</poste>
        <poste code="0671140">TRESORERIE LA PETITE-PIERRE</poste>
        <poste code="02B0180">TRESORERIE LA PORTA</poste>
        <poste code="0330730">TRESORERIE LA REOLE</poste>
        <poste code="0560120">TRESORERIE DE LA ROCHE-MUZILLAC</poste>
        <poste code="0190120">TRESORERIE LA ROCHE-CANILLAC</poste>
        <poste code="0740210">TRESORERIE LA ROCHE-SUR-FORON</poste>
        <poste code="0850010">TRESORERIE LA ROCHE CARDIJN</poste>
        <poste code="0850000">TRESORERIE GENERALE DE LA VENDEE</poste>
        <poste code="0850140">TRESORERIE PAYS YONNAIS ET ESSART MUNICIPAL</poste>
        <poste code="0850180">TRESORERIE OPDHLM DE LA VENDEE</poste>
        <poste code="0850900">PAIERIE DEPARTEMENTALE DE LA VENDEE</poste>
        <poste code="0850170">TRESORERIE LA ROCHE-SUR-YON HOPITAUX</poste>
        <poste code="0710270">TRESORERIE DE LA ROCHE-VINEUSE</poste>
        <poste code="0160350">TRESORERIE LA ROCHEFOUCAULD</poste>
        <poste code="0170000">TRESORERIE GENERALE DE LA CHARENTE-MARITIME</poste>
        <poste code="0170090">TRESORERIE LA ROCHELLE</poste>
        <poste code="0170110">TRESORERIE LA ROCHELLE MUNICIPALE</poste>
        <poste code="0170160">TRESORERIE LA ROCHELLE ETS HOSP.</poste>
        <poste code="0170900">PAIERIE DEPARTEMENTALE DE LA CHARENTE-MARITIME</poste>
        <poste code="0730260">TRESORERIE LA ROCHETTE</poste>
        <poste code="0490480">TRESORERIE LA ROMAGNE-MONTFAUCON</poste>
        <poste code="0131130">TRESORERIE LA ROQUE-D'ANTHERON</poste>
        <poste code="0830120">TRESORERIE LA ROQUEBRUSSANNE</poste>
        <poste code="0340440">TRESORERIE LA SALVETAT-SUR-AGOUT</poste>
        <poste code="0270390">TRESORERIE LA SAUSSAYE</poste>
        <poste code="0830140">TRESORERIE LA SEYNE-SUR-MER</poste>
        <poste code="0830150">TRESORERIE LA SEYNE-SUR-MER MUNICIPALE</poste>
        <poste code="0230170">TRESORERIE LA SOUTERRAINE</poste>
        <poste code="0720500">TRESORERIE DE LA SUZE-SUR-SARTHE</poste>
        <poste code="0381230">TRESORERIE LA TOUR-DU-PIN</poste>
        <poste code="0170390">TRESORERIE LA TREMBLADE</poste>
        <poste code="0860220">TRESORERIE LA TRIMOUILLE</poste>
        <poste code="1030100">TRESORERIE TRINITE</poste>
        <poste code="0380200">TRESORERIE GRENOBLE CHU</poste>
        <poste code="0830210">TRESORERIE TOULON-LA SEYNE-SUR-MER CHI</poste>
        <poste code="0830220">TRESORERIE LA VALETTE-DU-VAR</poste>
        <poste code="0381120">TRESORERIE LA VERPILLIERE</poste>
        <poste code="0070410">TRESORERIE DE LA VOULTE-SUR-RHONE</poste>
        <poste code="0460120">TRESORERIE DE LABASTIDE-MURAT</poste>
        <poste code="0820080">TRESORERIE LABASTIDE-SAINT-PIERRE</poste>
        <poste code="0400060">TRESORERIE LABRIT</poste>
        <poste code="0810240">TRESORERIE LABRUGUIERE</poste>
        <poste code="0460130">TRESORERIE DE LACAPELLE ET LIVERNON</poste>
        <poste code="0810250">TRESORERIE LACAUNE</poste>
        <poste code="0900080">TRESORERIE LACHAPELLE-SOUS-ROUGEMONT</poste>
        <poste code="0600510">TRESORERIE LA CROIX-SAINT-OUEN</poste>
        <poste code="0820090">TRESORERIE LAFRANCAISE-MOLIERES</poste>
        <poste code="0010170">TRESORERIE LAGNIEU</poste>
        <poste code="0772110">TRESORERIE LAGNY-SUR-MARNE</poste>
        <poste code="0110220">TRESORERIE LAGRASSE</poste>
        <poste code="0190140">TRESORERIE DE TULLE MONTANA</poste>
        <poste code="0120090">TRESORERIE LAGUIOLE</poste>
        <poste code="0210220">TRESORERIE LAIGNES</poste>
        <poste code="0460140">TRESORERIE LALBENQUE</poste>
        <poste code="0240520">TRESORERIE DE LALINDE</poste>
        <poste code="0340420">TRESORERIE DE LAMALOU-BAINS-ST-GERVAIS-S-MARE</poste>
        <poste code="0880250">TRESORERIE LAMARCHE-MARTIGNY-LES-BAINS</poste>
        <poste code="0070150">TRESORERIE DE LAMASTRE</poste>
        <poste code="0220070">TRESORERIE LAMBALLE</poste>
        <poste code="0590520">TRESORERIE LAMBERSART</poste>
        <poste code="0131080">TRESORERIE LAMBESC</poste>
        <poste code="0410090">TRESORERIE LAMOTTE-BEUVRON</poste>
        <poste code="0690510">TRESORERIE LAMURE-SUR-AZERGUES</poste>
        <poste code="0290130">TRESORERIE LANDERNEAU</poste>
        <poste code="0290230">TRESORERIE DE LANDIVISIAU</poste>
        <poste code="0595230">TRESORERIE LANDRECIES</poste>
        <poste code="0430120">TRESORERIE LANGEAC</poste>
        <poste code="0370170">TRESORERIE LANGEAIS</poste>
        <poste code="0480100">TRESORERIE LANGOGNE</poste>
        <poste code="0330350">TRESORERIE LANGON-SAINT-MACAIRE</poste>
        <poste code="0520340">TRESORERIE LANGRES</poste>
        <poste code="0290240">TRESORERIE LANMEUR</poste>
        <poste code="0650140">TRESORERIE LANNEMEZAN</poste>
        <poste code="0650150">TRESORERIE LANNEMEZAN CTRE HOSP. SPEC.</poste>
        <poste code="0290140">TRESORERIE LANNILIS</poste>
        <poste code="0220350">TRESORERIE LANNION</poste>
        <poste code="0240140">TRESORERIE DE LANOUAILLE</poste>
        <poste code="0730170">TRESORERIE LANSLEBOURG-MONT-CENIS</poste>
        <poste code="0220450">TRESORERIE DE LANVOLLON-PLOUHA</poste>
        <poste code="0020000">TRESORERIE GENERALE DE L' AISNE</poste>
        <poste code="0020150">TRESORERIE DE LAON</poste>
        <poste code="0020160">TRESORERIE DE LAON MUNICIPALE ET BANLIEUE</poste>
        <poste code="0020170">TRESORERIE LAON CENTRE HOSPITALIER</poste>
        <poste code="0020900">PAIERIE DEPARTEMENTALE DE L' AISNE</poste>
        <poste code="0020001">SERVICE CONTRLE REDEVANCE AUDIOVISUELLE DE L' AISNE</poste>
        <poste code="0030260">TRESORERIE LAPALISSE</poste>
        <poste code="0190090">TRESORERIE LAPLEAU</poste>
        <poste code="0680100">TRESORERIE LAPOUTROIE</poste>
        <poste code="0050090">TRESORERIE LARAGNE-ORPIERRE</poste>
        <poste code="0190280">TRESORERIE LARCHE</poste>
        <poste code="0070160">TRESORERIE LARGENTIERE</poste>
        <poste code="0090230">TRESORERIE LAROQUE-D'OLMES</poste>
        <poste code="0470060">TRESORERIE LAROQUE-TIMBAUT-BEAUVILLE</poste>
        <poste code="0150100">TRESORERIE LAROQUEBROU</poste>
        <poste code="0640100">TRESORERIE LARUNS</poste>
        <poste code="0300110">TRESORERIE LASALLE</poste>
        <poste code="0530190">TRESORERIE LASSAY-LES-CHATEAUX</poste>
        <poste code="0600490">TRESORERIE LASSIGNY</poste>
        <poste code="0460150">TRESORERIE LATRONQUIERE-SOUSCEYRAC</poste>
        <poste code="0671100">TRESORERIE LAUTERBOURG</poste>
        <poste code="0810260">TRESORERIE LAUTREC</poste>
        <poste code="0820100">TRESORERIE LAUZERTE</poste>
        <poste code="0530000">TRESORERIE GENERALE DE LA MAYENNE</poste>
        <poste code="0530200">TRESORERIE DE LAVAL MURAT</poste>
        <poste code="0530210">TRESORERIE LAVAL CENTRE HOSPITALIER</poste>
        <poste code="0530220">TRESORERIE PAYS DE LAVAL</poste>
        <poste code="0530900">PAIERIE DEPARTEMENTALE DE LA MAYENNE</poste>
        <poste code="0470070">TRESORERIE LAVARDAC</poste>
        <poste code="0810270">TRESORERIE LAVAUR</poste>
        <poste code="0090090">TRESORERIE LAVELANET-BELESTA</poste>
        <poste code="0620720">TRESORERIE LAVENTIE</poste>
        <poste code="0540160">TRESORERIE NANCY CTRE PSYCHO. DPTAL</poste>
        <poste code="0061030">TRESORERIE LE BAR-SUR-LOUP</poste>
        <poste code="0830010">TRESORERIE LE BEAUSSET</poste>
        <poste code="0140060">TRESORERIE LE BENY-BOCAGE</poste>
        <poste code="0360050">TRESORERIE DE LE BLANC</poste>
        <poste code="0930050">TRESORERIE LE BLANC-MESNIL</poste>
        <poste code="0480030">TRESORERIE LE BLEYMARD</poste>
        <poste code="0690490">TRESORERIE LE BOIS-D'OINGT</poste>
        <poste code="0660040">TRESORERIE LE BOULOU</poste>
        <poste code="0380050">TRESORERIE LE BOURG-D'OISANS</poste>
        <poste code="0530050">TRESORERIE DE LE BOURGNEUF-LA-FORET</poste>
        <poste code="0330210">TRESORERIE LE BOUSCAT</poste>
        <poste code="0240040">TRESORERIE LE BUGUE</poste>
        <poste code="0061140">TRESORERIE LE CANNET</poste>
        <poste code="0593130">TRESORERIE LE CATEAU-CATILLON</poste>
        <poste code="0020530">TRESORERIE LE CATELET</poste>
        <poste code="0420020">TRESORERIE DU CHAMBON FEUGEROLLES</poste>
        <poste code="0170170">TRESORERIE LE CHATEAU-D'OLERON</poste>
        <poste code="0730130">TRESORERIE LE CHATELARD</poste>
        <poste code="0770040">TRESORERIE LE CHATELET-EN-BRIE</poste>
        <poste code="0780380">TRESORERIE VERSAILLES CENTRE HOSPITALIER</poste>
        <poste code="0780420">TRESORERIE LE CHESNAY</poste>
        <poste code="0080140">TRESORERIE LE CHESNE</poste>
        <poste code="0070100">TRESORERIE LE CHEYLARD</poste>
        <poste code="0480060">TRESORERIE LE COLLET-DE-DEZE</poste>
        <poste code="0422030">TRESORERIE LE COTEAU</poste>
        <poste code="0710390">TRESORERIE LE CREUSOT</poste>
        <poste code="0030190">TRESORERIE LE DONJON</poste>
        <poste code="0870080">TRESORERIE LE DORAT</poste>
        <poste code="0290110">TRESORERIE LE FAOU</poste>
        <poste code="0560210">TRESORERIE DE LE FAOUET</poste>
        <poste code="0090220">TRESORERIE LE FOSSAT</poste>
        <poste code="1030050">TRESORERIE FRANCOIS</poste>
        <poste code="0381180">TRESORERIE LE GRAND-LEMPS ET BIOL</poste>
        <poste code="0720230">TRESORERIE LE GRAND-LUCE-LA CHARTRE</poste>
        <poste code="0760500">TRESORERIE LE GRAND-QUEVILLY</poste>
        <poste code="0762000">RECETTE DES FINANCES LE HAVRE</poste>
        <poste code="0762090">TRESORERIE LE HAVRE IMPTS</poste>
        <poste code="0762130">TRESORERIE LE HAVRE MUNICIPALE</poste>
        <poste code="0762140">TRESORERIE LE HAVRE CENTRE HOSPITALIER</poste>
        <poste code="0940100">TRESORERIE DU NORD VAL-DE-BIEVRE</poste>
        <poste code="1030060">TRESORERIE LAMENTIN</poste>
        <poste code="0830090">TRESORERIE LE LAVANDOU</poste>
        <poste code="0490160">TRESORERIE LE LION-D'ANGERS</poste>
        <poste code="0440100">TRESORERIE LE LOROUX-BOTTEREAU</poste>
        <poste code="0490170">TRESORERIE LE LOUROUX-BECONNAIS</poste>
        <poste code="0831130">TRESORERIE LE LUC</poste>
        <poste code="0720260">TRESORERIE LE LUDE</poste>
        <poste code="0720000">TRESORERIE GENERALE DE LA SARTHE</poste>
        <poste code="0720290">TRESORERIE LE MANS FLORE</poste>
        <poste code="0720310">TRESORERIE LE MANS PRIPHRIE ET AMENDES</poste>
        <poste code="0720320">TRESORERIE AGGLOMRATION MANCELLE ET CHS</poste>
        <poste code="0720340">TRESORERIE LE MANS CENTRE HOSPITALIER</poste>
        <poste code="0720900">PAIERIE DEPARTEMENTALE DE LA SARTHE</poste>
        <poste code="0720330">TRESORERIE LE MANS VILLE</poste>
        <poste code="1030070">TRESORERIE MARIN</poste>
        <poste code="0090240">TRESORERIE LE MAS-D'AZIL</poste>
        <poste code="0030280">TRESORERIE LE-MAYET-DE-MONTAGNE</poste>
        <poste code="0610360">TRESORERIE LE MERLERAULT</poste>
        <poste code="0760280">TRESORERIE LE MESNIL-ESNARD</poste>
        <poste code="0140290">TRESORERIE LE MOLAY-LITTRY</poste>
        <poste code="0430150">TRESORERIE LE MONASTIER-SUR-GAZEILLE</poste>
        <poste code="0050100">TRESORERIE MONETIER-LES-BAINS ET LA GRAVE</poste>
        <poste code="0630190">TRESORERIE LE MONT-DORE LA TOUR D' AUVERGNE</poste>
        <poste code="0030070">TRESORERIE LE MONTET</poste>
        <poste code="1010070">TRESORERIE LE MOULE</poste>
        <poste code="0831140">TRESORERIE LE MUY</poste>
        <poste code="0270330">TRESORERIE LE NEUBOURG</poste>
        <poste code="0020560">TRESORERIE LE NOUVION-EN-THIERACHE</poste>
        <poste code="0560310">TRESORERIE LE PALAIS</poste>
        <poste code="0941060">TRESORERIE LE PERREUX-SUR-MARNE</poste>
        <poste code="0760320">TRESORERIE LE PETIT-QUEVILLY</poste>
        <poste code="0850120">TRESORERIE LE POIRE-SUR-VIE</poste>
        <poste code="0730250">TRESORERIE LE PONT-DE-BEAUVOISIN</poste>
        <poste code="0381210">TRESORERIE LE-PONT-DE-BEAUVOISIN</poste>
        <poste code="1040010">TRESORERIE LE PORT</poste>
        <poste code="0430000">TRESORERIE GENERALE DE LA HAUTE-LOIRE</poste>
        <poste code="0430230">TRESORERIE LE PUY VILLE</poste>
        <poste code="0430220">TRESORERIE LE PUY SAINT-LOUIS</poste>
        <poste code="0430300">TRESORERIE DE PUY SAINT-JEAN</poste>
        <poste code="0430900">PAIERIE DEPARTEMENTALE DE LA HAUTE-LOIRE</poste>
        <poste code="0430001">SERVICE CONTRLE REDEVANCE AUDIOVISUELLE DE LA HAUTE LOIRE</poste>
        <poste code="0595270">TRESORERIE LE QUESNOY</poste>
        <poste code="0930210">TRESORERIE DU RAINCY MUNICIPALE</poste>
        <poste code="0250440">TRESORERIE LE RUSSEY</poste>
        <poste code="1040110">TRESORERIE LE TAMPON</poste>
        <poste code="0070310">TRESORERIE DE LE TEIL-ROCHEMAURE</poste>
        <poste code="0610270">TRESORERIE DE LE THEIL-SUR-HUISNE ET NOCE</poste>
        <poste code="0880410">TRESORERIE LE THILLOT</poste>
        <poste code="0622240">TRESORERIE LE TOUQUET-PARIS-PLAGE</poste>
        <poste code="0380430">TRESORERIE LE TOUVET</poste>
        <poste code="0760660">TRESORERIE LE TREPORT</poste>
        <poste code="0780390">TRESORERIE LE VESINET</poste>
        <poste code="0300390">TRESORERIE LE VIGAN</poste>
        <poste code="0320160">TRESORERIE LECTOURE</poste>
        <poste code="0300490">TRESORERIE LEDIGNAN</poste>
        <poste code="0620730">TRESORERIE LEFOREST</poste>
        <poste code="0640110">TRESORERIE LEMBEYE</poste>
        <poste code="0860320">TRESORERIE LENCLOITRE</poste>
        <poste code="0620750">TRESORERIE LENS MUNICIPALE</poste>
        <poste code="0620740">TRESORERIE DE LENS</poste>
        <poste code="0620760">TRESORERIE LENS CENTRE HOSPITALIER</poste>
        <poste code="0620001">SERVICE CONTRLE REDEVANCE AUDIOVISUELLE DU PAS DE CALAIS</poste>
        <poste code="0381160">TRESORERIE LES ABRETS</poste>
        <poste code="1010008">CENTRE DE FORMATION DEPARTEMENTAL DES ANTILLES-GUYANE</poste>
        <poste code="1010010">TRESORERIE LES ABYMES-ET-LE-GOSIER</poste>
        <poste code="0180010">TRESORERIE LES AIX-D'ANGILLON</poste>
        <poste code="0270160">TRESORERIE LES ANDELYS</poste>
        <poste code="0381170">TRESORERIE LES AVENIERES</poste>
        <poste code="0730140">TRESORERIE LES ECHELLES</poste>
        <poste code="0850070">TRESORERIE LES HERBIERS-MOUCHAMPS</poste>
        <poste code="0630180">TRESORERIE LES MARTRES-DE-VEYRE</poste>
        <poste code="0340160">TRESORERIE LES MATELLES</poste>
        <poste code="0040140">TRESORERIE LES MEES</poste>
        <poste code="0781130">TRESORERIE LES MUREAUX</poste>
        <poste code="0131110">TRESORERIE LES PENNES-MIRABEAU</poste>
        <poste code="0500450">TRESORERIE LES PIEUX</poste>
        <poste code="0490190">TRESORERIE LES PONTS-DE-CE</poste>
        <poste code="0850360">TRESORERIE CTE DE LUMIERE</poste>
        <poste code="0850350">TRESORERIE DES SABLES D'OLONNE</poste>
        <poste code="1030110">TRESORERIE TROIS-ILETS</poste>
        <poste code="0860380">TRESORERIE LES TROIS-MOUTIERS</poste>
        <poste code="0911060">TRESORERIE LES ULIS</poste>
        <poste code="0070370">TRESORERIE LES VANS</poste>
        <poste code="0640120">TRESORERIE DE LESCAR RIVES DU GAVE</poste>
        <poste code="0290150">TRESORERIE LESNEVEN</poste>
        <poste code="0330360">TRESORERIE LESPARRE-MEDOC</poste>
        <poste code="0500100">TRESORERIE LESSAY</poste>
        <poste code="0110450">TRESORERIE LEUCATE</poste>
        <poste code="0920210">TRESORERIE LEVALLOIS-PERRET MUNICIPALE</poste>
        <poste code="0920410">TRESORERIE OPDHLM DES HAUTS-DE-SEINE</poste>
        <poste code="0920200">TRESORERIE LEVALLOIS-PERRET</poste>
        <poste code="0060060">TRESORERIE LEVENS</poste>
        <poste code="02A0070">TRESORERIE LEVIE</poste>
        <poste code="0250290">TRESORERIE LEVIER</poste>
        <poste code="0360180">TRESORERIE LEVROUX</poste>
        <poste code="0220360">TRESORERIE LEZARDRIEUX</poste>
        <poste code="0790210">TRESORERIE LEZAY</poste>
        <poste code="0110460">TRESORERIE LEZIGNAN-CORBIERES</poste>
        <poste code="0630530">TRESORERIE LEZOUX</poste>
        <poste code="0600560">TRESORERIE LIANCOURT</poste>
        <poste code="0330650">TRESORERIE DE LIBOURNE-FRONSAC-VAYRES</poste>
        <poste code="0330770">TRESORERIE LIBOURNE MUNICIPALE</poste>
        <poste code="0330771">TRESORERIE DE LIBOURNE MUNICIPALE HOP. BOULIN</poste>
        <poste code="1320000">TRESORERIE AMBASSADE DE FRANCE AU GABON</poste>
        <poste code="0622120">TRESORERIE LICQUES</poste>
        <poste code="0020180">TRESORERIE LIESSE</poste>
        <poste code="0770250">TRESORERIE DE SENART GESTION PUBLIQUE LOCALE</poste>
        <poste code="0770270">TRESORERIE DE SENART</poste>
        <poste code="0620770">TRESORERIE LIEVIN</poste>
        <poste code="0880270">TRESORERIE LIFFOL-LE-GRAND</poste>
        <poste code="0350180">TRESORERIE LIFFRE</poste>
        <poste code="0180220">TRESORERIE DE LIGNIERES</poste>
        <poste code="0550150">TRESORERIE DE LIGNY-EN-BARROIS</poste>
        <poste code="0370190">TRESORERIE LIGUEIL</poste>
        <poste code="0590000">TRESORERIE GENERALE DU NORD</poste>
        <poste code="0590007">CENTRE REGIONAL DES PENSIONS DU NORD</poste>
        <poste code="0590008">CENTRE DE FORMATION DEPARTEMENTAL DU NORD</poste>
        <poste code="0590009">DEPARTEMENT INFORMATIQUE DU NORD</poste>
        <poste code="0590240">TRESORERIE LILLE MUNICIPALE</poste>
        <poste code="0590250">RECETTE DES FINANCES DE LILLE CHU</poste>
        <poste code="0590530">TRESORERIE LILLE COMMUNAUTE URBAINE</poste>
        <poste code="0590800">PAIERIE REGIONALE DU NORD-PAS-DE-CALAIS</poste>
        <poste code="0590900">PAIERIE DEPARTEMENTALE DU NORD</poste>
        <poste code="0590006">CENTRE NATIONAL DE GESTION DES CONCOURS DE LILLE (CONCOURS)</poste>
        <poste code="0590005">CPS CENTRE PRLVEMENT SERVICE</poste>
        <poste code="0590180">TRESORERIE DU GRAND LILLE</poste>
        <poste code="0599000">RECETTE DES FINANCES DE LILLE</poste>
        <poste code="0590230">TRESORERIE LILLE AMENDES</poste>
        <poste code="0590001">SERVICE CONTRLE REDEVANCE AUDIOVISUELLE DU NORD</poste>
        <poste code="0590004">CE CENTRE ENCAISSEMENT LILLE</poste>
        <poste code="0762160">TRESORERIE LILLEBONNE</poste>
        <poste code="0620780">TRESORERIE LILLERS</poste>
        <poste code="0781060">TRESORERIE LIMAY</poste>
        <poste code="0870000">TRESORERIE GENERALE DE LA HAUTE-VIENNE</poste>
        <poste code="0870009">DEPARTEMENT INFORMATIQUE DE LA HAUTE-VIENNE</poste>
        <poste code="0870110">TRESORERIE DE LIMOGES 1ERE DIVISION</poste>
        <poste code="0870120">TRESORERIE DE LIMOGES 2EME DIVISION</poste>
        <poste code="0870130">TRESORERIE LIMOGES BANLIEUE</poste>
        <poste code="0870140">TRESORERIE LIMOGES MUNICIPALE</poste>
        <poste code="0870150">TRESORERIE DE LIMOGES CHU ET CH ESQUIROL</poste>
        <poste code="0870340">TRESORERIE LIMOGES OPHLM</poste>
        <poste code="0870800">PAIERIE REGIONALE DE LIMOUSIN</poste>
        <poste code="0870900">PAIERIE DEPARTEMENTALE DE LA HAUTE-VIENNE</poste>
        <poste code="0870151">TRESORERIE DE LIMOGES CHU-CH ESQUIROL - ANNEXE</poste>
        <poste code="0870007">CENTRE REGIONAL DES PENSIONS DE LA HAUTE-VIENNE</poste>
        <poste code="0870008">CENTRE DE FORMATION DEPARTEMENTAL DE LA HAUTE-VIENNE</poste>
        <poste code="0870002">SERVICE CONTRLE REDEVANCE AUDIOVISUELLE DE LA HAUTE VIENNE</poste>
        <poste code="0460170">TRESORERIE LIMOGNE-EN-QUERCY</poste>
        <poste code="0911070">TRESORERIE LIMOURS</poste>
        <poste code="0110230">TRESORERIE DE LIMOUX</poste>
        <poste code="0670560">TRESORERIE STRASBOURG OUEST-LINGOLSHEIM</poste>
        <poste code="0140520">TRESORERIE DE LISIEUX INTERCOM</poste>
        <poste code="0140570">TRESORERIE DE LISIEUX</poste>
        <poste code="0140530">TRESORERIE LIVAROT</poste>
        <poste code="0930130">TRESORERIE LIVRY-GARGAN</poste>
        <poste code="0772130">TRESORERIE LIZY-CROUY-SUR-OURCQ</poste>
        <poste code="0370200">TRESORERIE DE LOCHES</poste>
        <poste code="0560060">TRESORERIE LOCMINE</poste>
        <poste code="0340130">TRESORERIE LODEVE</poste>
        <poste code="0320320">TRESORERIE SAMATAN</poste>
        <poste code="0320170">TRESORERIE LOMBEZ</poste>
        <poste code="1770000">TRESORERIE AMBASSADE DE FRANCE EN GRANDE-BRETAGNE</poste>
        <poste code="0911080">TRESORERIE LONGJUMEAU</poste>
        <poste code="0780310">TRESORERIE DE LONGNES</poste>
        <poste code="0490350">TRESORERIE DE LONGUE-JUMELLES</poste>
        <poste code="0760620">TRESORERIE LONGUEVILLE-SUR-SCIE</poste>
        <poste code="0540440">TRESORERIE DE LONGUYON</poste>
        <poste code="0540450">TRESORERIE DE LONGWY-VILLERUPT</poste>
        <poste code="0390000">TRESORERIE GENERALE DU JURA</poste>
        <poste code="0390150">TRESORERIE LONS MUNICIPALE ET EPL</poste>
        <poste code="0390900">PAIERIE DEPARTEMENTALE DU JURA</poste>
        <poste code="0390100">TRESORERIE DE LONS IMPOTS ET AMENDES</poste>
        <poste code="0831120">TRESORERIE LORGUES</poste>
        <poste code="0560290">TRESORERIE DE LORIENT</poste>
        <poste code="0560300">TRESORERIE DE LORIENT COLLECTIVITES</poste>
        <poste code="0560340">TRESORERIE DE LORIENT HPITAUX-HLM</poste>
        <poste code="0260120">TRESORERIE LORIOL-SUR-DROME</poste>
        <poste code="0580140">TRESORERIE LORMES</poste>
        <poste code="0570230">TRESORERIE LORQUIN</poste>
        <poste code="0770350">TRESORERIE LORREZ-LE-BOCAGE-PREAUX</poste>
        <poste code="0450380">TRESORERIE DE LORRIS</poste>
        <poste code="0220090">TRESORERIE LOUDEAC</poste>
        <poste code="0860330">TRESORERIE LOUDUN</poste>
        <poste code="0720250">TRESORERIE LOUE-BRULON</poste>
        <poste code="0710140">TRESORERIE LOUHANS</poste>
        <poste code="0170050">TRESORERIE LOULAY-VILLENEUVE-LA-COMTESSE</poste>
        <poste code="0650170">TRESORERIE DE LOURDES</poste>
        <poste code="0650180">TRESORERIE LOURES-BAROUSSE</poste>
        <poste code="0270300">TRESORERIE LOUVIERS</poste>
        <poste code="0350190">TRESORERIE LOUVIGNE-DU-DESERT</poste>
        <poste code="0951040">TRESORERIE LOUVRES-GOUSSAINVILLE</poste>
        <poste code="0190340">TRESORERIE ARNAC-POMPADOUR</poste>
        <poste code="0190290">TRESORERIE LUBERSAC</poste>
        <poste code="0260130">TRESORERIE LUC-EN-DIOIS</poste>
        <poste code="0280130">TRESORERIE CHARTRES BANLIEUE</poste>
        <poste code="0710610">TRESORERIE DE LUCENAY-L'EVEQUE</poste>
        <poste code="0850230">TRESORERIE LUCON-SAINT-MICHEL-EN-L'HERM</poste>
        <poste code="0710150">TRESORERIE DE LUGNY</poste>
        <poste code="0622300">TRESORERIE LUMBRES</poste>
        <poste code="0340150">TRESORERIE DE LUNEL</poste>
        <poste code="0760630">TRESORERIE LUNERAY</poste>
        <poste code="0540380">TRESORERIE LUNEVILLE</poste>
        <poste code="0030060">TRESORERIE LURCY-LEVIS</poste>
        <poste code="0700250">TRESORERIE DE LURE</poste>
        <poste code="0860100">TRESORERIE LUSIGNAN</poste>
        <poste code="0100170">TRESORERIE DE LUSIGNY-SUR-BARSE</poste>
        <poste code="0860110">TRESORERIE LUSSAC-LES-CHATEAUX</poste>
        <poste code="0700270">TRESORERIE DE LUXEUIL-LES-BAINS</poste>
        <poste code="0370210">TRESORERIE DE LUYNES</poste>
        <poste code="0650190">TRESORERIE LUZ-SAINT-SAUVEUR</poste>
        <poste code="0951050">TRESORERIE LUZARCHES</poste>
        <poste code="0460190">TRESORERIE LUZECH</poste>
        <poste code="0090100">TRESORERIE LUZENAC-LES-CABANNES</poste>
        <poste code="0630620">TRESORERIE DE LUZILLAT</poste>
        <poste code="0580150">TRESORERIE LUZY</poste>
        <poste code="0690000">TRESORERIE GENERALE DU RHONE</poste>
        <poste code="0690007">CENTRE REGIONAL DES PENSIONS DU RHONE</poste>
        <poste code="0690008">CENTRE DE FORMATION DEPARTEMENTAL DU RHONE</poste>
        <poste code="0690009">DEPARTEMENT INFORMATIQUE DU RHONE</poste>
        <poste code="0690100">TRESORERIE LYON PRESQU'LE</poste>
        <poste code="0690110">TRESORERIE DE LYON PART DIEU</poste>
        <poste code="0690130">TRESORERIE LYON 5EME ET 9EME ARRONDTS</poste>
        <poste code="0690150">TRESORERIE LYON 7EME ARRONDISSEMENT</poste>
        <poste code="0690160">TRESORERIE LYON 8EME ARRONDISSEMENT</poste>
        <poste code="0690180">TRESORERIE LYON AMENDES</poste>
        <poste code="0690220">RECETTE DES FINANCES LYON HOSPICES CIVILS</poste>
        <poste code="0690410">TRESORERIE LYON COMMUNAUTE URBAINE</poste>
        <poste code="0690900">PAIERIE DEPARTEMENTALE DU RHONE</poste>
        <poste code="3000010">ECOLE DES CADRES B</poste>
        <poste code="0690001">SERVICE CONTRLE REDEVANCE AUDIOVISUELLE DU RHNE</poste>
        <poste code="0690190">RECETTE DES FINANCES LYON MUNICIPALE</poste>
        <poste code="0690005">CPS CENTRE PRELEVEMENT SERVICE</poste>
        <poste code="0590160">TRESORERIE LANNOY</poste>
        <poste code="0440110">TRESORERIE MACHECOUL</poste>
        <poste code="0710000">TRESORERIE GENERALE DE SAONE-ET-LOIRE</poste>
        <poste code="0710160">TRESORERIE MACON</poste>
        <poste code="0710170">TRESORERIE DE MACON MUNICIPALE</poste>
        <poste code="0710900">PAIERIE DEPARTEMENTALE DE SAONE-ET-LOIRE</poste>
        <poste code="1840000">TRESORERIE AMBASSADE DE FRANCE EN ESPAGNE</poste>
        <poste code="0510360">TRESORERIE EPERNAY MUNICIPALE</poste>
        <poste code="0510350">TRESORERIE D' EPERNAY BANLIEUE</poste>
        <poste code="0870160">TRESORERIE DE MAGNAC-LAVAL</poste>
        <poste code="0950150">TRESORERIE MAGNY-EN-VEXIN</poste>
        <poste code="0250410">TRESORERIE MAICHE</poste>
        <poste code="0850240">TRESORERIE DE MAILLEZAIS-BENET ET VIX</poste>
        <poste code="0280250">TRESORERIE DE MAINTENON</poste>
        <poste code="0280900">PAIERIE DEPARTEMENTALE D'EURE-ET-LOIR</poste>
        <poste code="0940150">TRESORERIE DE MAISONS-ALFORT/ALFORTVILLE</poste>
        <poste code="0781070">TRESORERIE DE MAISONS-LAFFITTE</poste>
        <poste code="0570250">TRESORERIE MAIZIERES-LES-METZ</poste>
        <poste code="0921070">TRESORERIE MALAKOFF</poste>
        <poste code="0190250">TRESORERIE DE MALEMORT</poste>
        <poste code="0450390">TRESORERIE DE MALESHERBES</poste>
        <poste code="0560070">TRESORERIE MALESTROIT</poste>
        <poste code="0720280">TRESORERIE MAMERS-SAINT-COSME-EN-VAIRAIS</poste>
        <poste code="1430000">TRESORERIE GENERALE DE MAYOTTE</poste>
        <poste code="1430010">TRESORERIE MAYOTTE MUNICIPALE</poste>
        <poste code="1430900">PAIERIE DEPARTEMENTALE DE MAYOTTE</poste>
        <poste code="0061150">TRESORERIE MANDELIEU LA NAPOULE</poste>
        <poste code="0040130">TRESORERIE MANOSQUE</poste>
        <poste code="0040001">CELLULE CONTRLE REDEVANCE AUDIOVISUELLE DES ALPES DE HAUTE PROVENCE</poste>
        <poste code="0160260">TRESORERIE MANSLE</poste>
        <poste code="0781080">TRESORERIE MANTES-LA-JOLIE</poste>
        <poste code="0781090">TRESORERIE MANTES-LA-JOLIE MUNICIPALE</poste>
        <poste code="0781100">TRESORERIE MANTES-LA-VILLE</poste>
        <poste code="0630380">TRESORERIE MANZAT</poste>
        <poste code="0170060">TRESORERIE MARANS</poste>
        <poste code="0250200">TRESORERIE MARCHAUX</poste>
        <poste code="0410250">TRESORERIE MARCHENOIR</poste>
        <poste code="0593060">TRESORERIE MARCHIENNES</poste>
        <poste code="0320180">TRESORERIE MARCIAC</poste>
        <poste code="0710180">TRESORERIE MARCIGNY -SAINT CHRISTOPHE</poste>
        <poste code="0120110">TRESORERIE MARCILLAC-VALLON-CONQUES</poste>
        <poste code="0030270">TRESORERIE MARCILLAT-DURDAT</poste>
        <poste code="0100190">TRESORERIE DE MARCILLY-LE-HAYER</poste>
        <poste code="0670260">TRESORERIE MARCKOLSHEIM</poste>
        <poste code="0590280">TRESORERIE MARCQ-EN-BAROEUL</poste>
        <poste code="0170180">TRESORERIE MARENNES</poste>
        <poste code="0240160">TRESORERIE MAREUIL</poste>
        <poste code="0850080">TRESORERIE MAREUIL-SUR-LAY-DISSAIS</poste>
        <poste code="0600500">TRESORERIE MARGNY-LES-COMPIEGNE</poste>
        <poste code="0131090">TRESORERIE MARIGNANE</poste>
        <poste code="0500110">TRESORERIE DE MARIGNY</poste>
        <poste code="0950160">TRESORERIE MARINES</poste>
        <poste code="0020190">TRESORERIE DE MARLE</poste>
        <poste code="0595080">TRESORERIE MARLY</poste>
        <poste code="0780180">TRESORERIE MARLY-LE-ROI</poste>
        <poste code="0470220">TRESORERIE DE MARMANDE</poste>
        <poste code="0470230">TRESORERIE DE MARMANDE MUNICIPALE</poste>
        <poste code="0671110">TRESORERIE MARMOUTIER</poste>
        <poste code="0700290">TRESORERIE DE MARNAY-PESMES</poste>
        <poste code="0772210">TRESORERIE MARNE-LA-VALLEE</poste>
        <poste code="0772090">TRESORERIE BUSSY SAINT GEORGES</poste>
        <poste code="0772080">TRESORERIE DE MAGNY-LE-HONGRE</poste>
        <poste code="0720370">TRESORERIE DE MAROLLES-LES-BRAULTS</poste>
        <poste code="0760260">TRESORERIE MAROMME</poste>
        <poste code="0620170">TRESORERIE MARQUION</poste>
        <poste code="0622130">TRESORERIE MARQUISE</poste>
        <poste code="0340390">TRESORERIE MARSEILLAN</poste>
        <poste code="0130230">TRESORERIE MARSEILLE 12E ET 13E ARRONDT</poste>
        <poste code="0130000">TRESORERIE GENERALE DES BOUCHES-DU-RHONE</poste>
        <poste code="0130007">CENTRE REGIONAL DES PENSIONS DES BOUCHES-DU-RHONE</poste>
        <poste code="0130008">CENTRE DE FORMATION DEPARTEMENTAL DES BOUCHES-DU-RHONE</poste>
        <poste code="0130009">DEPARTEMENT INFORMATIQUE DES BOUCHES-DU-RHONE</poste>
        <poste code="0130040">TRESORERIE DE MARSEILLE 1ER ET 6EME ARRONDT</poste>
        <poste code="0130070">TRESORERIE MARSEILLE 3EME ET 14EME ARRONDT</poste>
        <poste code="0130080">TRESORERIE MARSEILLE 4EME ARRONDISSEMENT</poste>
        <poste code="0130090">TRESORERIE MARSEILLE 5EME ARRONDISSEMENT</poste>
        <poste code="0130120">TRESORERIE DE MARSEILLE 7EME ARRONDISSEMENT</poste>
        <poste code="0130130">TRESORERIE MARSEILLE 8EME ARRONDISSEMENT</poste>
        <poste code="0130140">TRESORERIE DE MARSEILLE 10E ET 11E ARRONDT</poste>
        <poste code="0130160">TRESORERIE DE MARSEILLE 2E,15E ET 16E ARRONDT</poste>
        <poste code="0130170">TRESORERIE MARSEILLE AMENDES</poste>
        <poste code="0130180">RECETTE DES FINANCES MARSEILLE MUNICIPALE</poste>
        <poste code="0130190">RECETTE DES FINANCES MARSEILLE ASSISTANCE PUBLIQUE</poste>
        <poste code="0130210">TRESORERIE MARSEILLE 9EME ARRONDISSEMENT</poste>
        <poste code="0130250">TRESORERIE DE MARSEILLE HOSPITALIERE</poste>
        <poste code="0130800">PAIERIE REGIONALE DE PROVENCE-ALPES-COTE D'AZUR</poste>
        <poste code="0130900">PAIERIE DEPARTEMENTALE DES BOUCHES-DU-RHONE</poste>
        <poste code="0130001">SERVICE CONTRLE REDEVANCE AUDIOVISUELLE DES BOUCHES DU RHNE</poste>
        <poste code="0139000">RECETTE DES FINANCES DE MARSEILLE</poste>
        <poste code="0460200">TRESORERIE MARTEL</poste>
        <poste code="0132150">TRESORERIE MARTIGUES</poste>
        <poste code="0480120">TRESORERIE MARVEJOLS</poste>
        <poste code="0680270">TRESORERIE MASEVAUX</poste>
        <poste code="0593180">TRESORERIE DE MASNIERES</poste>
        <poste code="0320190">TRESORERIE MASSEUBE</poste>
        <poste code="0150120">TRESORERIE MASSIAC</poste>
        <poste code="0911090">TRESORERIE MASSY</poste>
        <poste code="0170300">TRESORERIE MATHA-BEAUVAIS-SUR-MATHA</poste>
        <poste code="0220290">TRESORERIE MATIGNON</poste>
        <poste code="0595240">TRESORERIE MAUBEUGE VILLE</poste>
        <poste code="0595250">TRESORERIE DE MAUBEUGE BANLIEUE</poste>
        <poste code="0595260">TRESORERIE MAUBEUGE MUNICIPALE</poste>
        <poste code="0650200">TRESORERIE MAUBOURGUET</poste>
        <poste code="0340170">TRESORERIE DE MAUGUIO</poste>
        <poste code="0781110">TRESORERIE MAULE</poste>
        <poste code="0790130">TRESORERIE MAULEON</poste>
        <poste code="0640140">TRESORERIE MAULEON-LICHARRE</poste>
        <poste code="0780120">TRESORERIE MAUREPAS</poste>
        <poste code="0150130">TRESORERIE MAURIAC</poste>
        <poste code="0560080">TRESORERIE MAURON</poste>
        <poste code="0150140">TRESORERIE MAURS</poste>
        <poste code="0132080">TRESORERIE MAUSSANE-VALLEE DES BAUX</poste>
        <poste code="0320200">TRESORERIE MAUVEZIN-COLOGNE</poste>
        <poste code="0790220">TRESORERIE MAUZE-SUR-LE-MIGNON</poste>
        <poste code="0540110">TRESORERIE DE MAXEVILLE</poste>
        <poste code="0530240">TRESORERIE MAYENNE SAINT-MARTIN</poste>
        <poste code="0530250">TRESORERIE DU PAYS DE MAYENNE</poste>
        <poste code="0810280">TRESORERIE MAZAMET</poste>
        <poste code="0790230">TRESORERIE MAZIERES-EN-GATINE</poste>
        <poste code="0772190">TRESORERIE DE MEAUX</poste>
        <poste code="0772000">RECETTE DES FINANCES MEAUX</poste>
        <poste code="0772140">TRESORERIE MEAUX MUNICIPALE.ET BANLIEUE</poste>
        <poste code="0180240">TRESORERIE DE MEHUN-SUR-YEVRE</poste>
        <poste code="0700300">TRESORERIE MELISEY-FAUCOGNEY</poste>
        <poste code="0790240">TRESORERIE MELLE</poste>
        <poste code="0770000">TRESORERIE GENERALE DE SEINE-ET-MARNE</poste>
        <poste code="0770150">TRESORERIE MELUN VAL DE SEINE SEC PU LOCAL</poste>
        <poste code="0770160">TRESORERIE MELUN VAL DE SEINE IMPOTS</poste>
        <poste code="0770290">TRESORERIE SEINE-ET-MARNE AMENDES</poste>
        <poste code="0770900">PAIERIE DEPARTEMENTALE DE SEINE-ET-MARNE</poste>
        <poste code="0770001">SERVICE CONTRLE REDEVANCE AUDIOVISUELLE DE SEINE ET MARNE</poste>
        <poste code="0480130">TRESORERIE MENDE</poste>
        <poste code="0480900">PAIERIE DEPARTEMENTALE DE LA LOZERE</poste>
        <poste code="0480000">TRESORERIE GENERALE DE LA LOZERE</poste>
        <poste code="0790250">TRESORERIE MENIGOUTE</poste>
        <poste code="0910190">TRESORERIE MENNECY</poste>
        <poste code="0380230">TRESORERIE MENS</poste>
        <poste code="0060070">TRESORERIE DE MENTON</poste>
        <poste code="0060080">TRESORERIE DE MENTON MUNICIPALE</poste>
        <poste code="0410110">TRESORERIE MER</poste>
        <poste code="0220110">TRESORERIE MERDRIGNAC</poste>
        <poste code="0330580">TRESORERIE MERIGNAC</poste>
        <poste code="0671120">TRESORERIE MERTZWILLER</poste>
        <poste code="0600250">TRESORERIE MERU</poste>
        <poste code="0594190">TRESORERIE MERVILLE</poste>
        <poste code="0100210">TRESORERIE DE MERY-SUR-SEINE</poste>
        <poste code="0530260">TRESORERIE DE PAYS DE MESLAY-GREZ</poste>
        <poste code="0570000">TRESORERIE GENERALE DE LA MOSELLE</poste>
        <poste code="0570007">CENTRE REGIONAL DES PENSIONS DE LA MOSELLE</poste>
        <poste code="0570008">CENTRE DE FORMATION DEPARTEMENTAL DE LA MOSELLE</poste>
        <poste code="0570009">DEPARTEMENT INFORMATIQUE DE LA MOSELLE</poste>
        <poste code="0570270">TRESORERIE METZ SERPENOISE</poste>
        <poste code="0570300">TRESORERIE METZ MUNICIPALE</poste>
        <poste code="0570600">TRESORERIE METZ ESPLANADE</poste>
        <poste code="0570610">TRESORERIE METZ-THIONVILLE ETS. HOSP</poste>
        <poste code="0570800">PAIERIE REGIONALE DE LORRAINE</poste>
        <poste code="0570900">PAIERIE DEPARTEMENTALE DE LA MOSELLE</poste>
        <poste code="0570006">PLE NATIONAL DE SOUTIEN AU RESEAU DE METZ - SECTEUR PUBLIC LOCAL</poste>
        <poste code="0570001">SERVICE CONTRLE REDEVANCE AUDIOVISUELLE DE LA MOSELLE</poste>
        <poste code="0570310">TRESORERIE METZERVISSE</poste>
        <poste code="0921080">TRESORERIE DE MEUDON</poste>
        <poste code="0781120">TRESORERIE MEULAN</poste>
        <poste code="0450130">TRESORERIE MEUNG-SUR-LOIRE</poste>
        <poste code="0010190">TRESORERIE MEXIMIEUX</poste>
        <poste code="0380450">TRESORERIE MEYLAN</poste>
        <poste code="0190100">TRESORERIE MEYMAC</poste>
        <poste code="0480140">TRESORERIE MEYRUEIS</poste>
        <poste code="0190300">TRESORERIE MEYSSAC</poste>
        <poste code="0690370">TRESORERIE DE MEYZIEU</poste>
        <poste code="0340180">TRESORERIE MEZE</poste>
        <poste code="0140540">TRESORERIE MEZIDON-CANON</poste>
        <poste code="0470090">TRESORERIE MEZIN</poste>
        <poste code="0320210">TRESORERIE MIELAN</poste>
        <poste code="0890270">TRESORERIE MIGENNES</poste>
        <poste code="0660100">TRESORERIE MILLAS</poste>
        <poste code="0120330">TRESORERIE MILLAU-SAINT-BEAUZELY-VEZINS</poste>
        <poste code="0910210">TRESORERIE MILLY-LA-FORET</poste>
        <poste code="0400070">TRESORERIE MIMIZAN</poste>
        <poste code="0132170">TRESORERIE MIRAMAS</poste>
        <poste code="0170310">TRESORERIE MIRAMBEAU</poste>
        <poste code="0470250">TRESORERIE MIRAMONT-DE-GUYENNE</poste>
        <poste code="0320230">TRESORERIE MIRANDE-MONTESQUIOU</poste>
        <poste code="0860120">TRESORERIE MIREBEAU</poste>
        <poste code="0210250">TRESORERIE MIREBEAU</poste>
        <poste code="0880300">TRESORERIE MIRECOURT</poste>
        <poste code="0090250">TRESORERIE MIREPOIX</poste>
        <poste code="0010200">TRESORERIE MIRIBEL</poste>
        <poste code="0730200">TRESORERIE MODANE</poste>
        <poste code="0380240">TRESORERIE MOIRANS-VOREPPE</poste>
        <poste code="0390350">TRESORERIE MOIRANS-EN-MONTAGNE</poste>
        <poste code="0440120">TRESORERIE MOISDON-LA-RIVIERE</poste>
        <poste code="0820120">TRESORERIE MOISSAC</poste>
        <poste code="0670290">TRESORERIE DE MOLSHEIM</poste>
        <poste code="0820140">TRESORERIE MONCLAR-DE-QUERCY</poste>
        <poste code="0220120">TRESORERIE DE MONCONTOUR</poste>
        <poste code="0790260">TRESORERIE MONCOUTANT</poste>
        <poste code="0140260">TRESORERIE CAEN BANLIEUE EST</poste>
        <poste code="0410260">TRESORERIE MONDOUBLEAU</poste>
        <poste code="0640150">TRESORERIE MONEIN</poste>
        <poste code="0380250">TRESORERIE MONESTIER-DE-CLERMONT</poste>
        <poste code="0810120">TRESORERIE MONESTIES</poste>
        <poste code="0470270">TRESORERIE DE MONFLANQUIN</poste>
        <poste code="0430160">TRESORERIE MONISTROL-SUR-LOIRE</poste>
        <poste code="0690520">TRESORERIE MONSOLS</poste>
        <poste code="0400001">DEPARTEMENT DES VERIFICATIONS DES LANDES</poste>
        <poste code="0400080">TRESORERIE MONT-DE-MARSAN</poste>
        <poste code="0400090">TRESORERIE MONT-DE-MARSAN MUNICIPALE</poste>
        <poste code="0400190">TRESORERIE OPDHLM DES LANDES</poste>
        <poste code="0400900">PAIERIE DEPARTEMENTALE DES LANDES</poste>
        <poste code="0400000">TRESORERIE GENERALE DES LANDES</poste>
        <poste code="0660110">TRESORERIE MONT-LOUIS</poste>
        <poste code="0390370">TRESORERIE DU VAL D'AMOUR</poste>
        <poste code="0850090">TRESORERIE DE MONTAIGU-ROCHESERVIERE</poste>
        <poste code="0820150">TRESORERIE MONTAIGU-DE-QUERCY</poste>
        <poste code="0630400">TRESORERIE DE MONTAIGUT-EN-COMBRAILLE</poste>
        <poste code="0381190">TRESORERIE MONTALIEU-VERCIEU</poste>
        <poste code="0450400">TRESORERIE MONTARGIS</poste>
        <poste code="0450410">TRESORERIE MONTARGIS MUNICIPALE</poste>
        <poste code="0310160">TRESORERIE DES VALLEES DU TARN ET DU GIROU</poste>
        <poste code="0820000">TRESORERIE GENERALE DE TARN-ET-GARONNE</poste>
        <poste code="0820160">TRESORERIE MONTAUBAN</poste>
        <poste code="0820170">TRESORERIE DE MONTAUBAN MUNICIPALE</poste>
        <poste code="0820900">PAIERIE DEPARTEMENTALE DU TARN-ET-GARONNE</poste>
        <poste code="0820001">SERVICE CONTRLE REDEVANCE AUDIOVISUELLE DU TARN ET GARONNE</poste>
        <poste code="0350220">TRESORERIE MONTAUBAN</poste>
        <poste code="0210260">TRESORERIE MONTBARD</poste>
        <poste code="0120340">TRESORERIE DE MONTBAZENS-LANUEJOULS</poste>
        <poste code="0370240">TRESORERIE DE MONTBAZON</poste>
        <poste code="0250420">TRESORERIE MONTBELIARD MUNICIPALE</poste>
        <poste code="0900121">TRESORERIE BELFORT ETS H MONTBELIARD</poste>
        <poste code="0700310">TRESORERIE MONTBOZON-DAMPIERRE-SUR-LINOTTE</poste>
        <poste code="0420230">TRESORERIE MONTBRISON</poste>
        <poste code="0160300">TRESORERIE DE MONTBRON</poste>
        <poste code="0710450">TRESORERIE MONTCEAU-LES-MINES</poste>
        <poste code="0710430">TRESORERIE DE MONTCENIS-MONTCHANIN</poste>
        <poste code="0460210">TRESORERIE MONTCUQ</poste>
        <poste code="0800310">TRESORERIE MONTDIDIER</poste>
        <poste code="0500440">TRESORERIE MONTEBOURG</poste>
        <poste code="0820180">TRESORERIE MONTECH</poste>
        <poste code="0260360">TRESORERIE MONTELIMAR</poste>
        <poste code="0770360">TRESORERIE MONTEREAU-FAULT-YONNE</poste>
        <poste code="0840230">TRESORERIE MONTEUX</poste>
        <poste code="0430170">TRESORERIE MONTFAUCON-EN-VELAY</poste>
        <poste code="0840070">TRESORERIE AVIGNON CTRE HOSP.SPEC.MONTFAVET</poste>
        <poste code="0930140">TRESORERIE DE MONTFERMEIL MUN. ET HOP.</poste>
        <poste code="0400240">TRESORERIE MONTFORT-EN-CHALOSSE</poste>
        <poste code="0780210">TRESORERIE MONTFORT-L'AMAURY</poste>
        <poste code="0350230">TRESORERIE MONTFORT</poste>
        <poste code="0270320">TRESORERIE MONTFORT-SUR-RISLE</poste>
        <poste code="0910220">TRESORERIE MONTGERON</poste>
        <poste code="0080290">TRESORERIE MONTHERME</poste>
        <poste code="0880310">TRESORERIE MONTHUREUX-SUR-SAONE</poste>
        <poste code="0520210">TRESORERIE MONTIER-EN-DER</poste>
        <poste code="0550170">TRESORERIE DE MONTIERS-SUR-SAULX</poste>
        <poste code="0240180">TRESORERIE MONTIGNAC-PLAZAC</poste>
        <poste code="0780060">TRESORERIE MONTIGNY-LE-BRETONNEUX</poste>
        <poste code="0780460">TRESORERIE YVELINES AMENDES</poste>
        <poste code="0570320">TRESORERIE MONTIGNY-PAYS MESSIN</poste>
        <poste code="0210270">TRESORERIE MONTIGNY-SUR-AUBE</poste>
        <poste code="0762170">TRESORERIE MONTIVILLIERS</poste>
        <poste code="0911100">TRESORERIE MONTLHERY</poste>
        <poste code="0170320">TRESORERIE MONTLIEU-LA-GARDE-CHEVANCEAUX</poste>
        <poste code="0030300">TRESORERIE DE MONTLUCON MUNICIPALE</poste>
        <poste code="0030290">TRESORERIE DE MONTLUCON-CHATEAU</poste>
        <poste code="0030370">TRESORERIE DE MONTLUON ETS HOSPITALIERS</poste>
        <poste code="0010210">TRESORERIE MONTLUEL</poste>
        <poste code="0030320">TRESORERIE MONTMARAULT</poste>
        <poste code="0500120">TRESORERIE MONTMARTIN-QUETTREVILLE</poste>
        <poste code="0550400">TRESORERIE MONTMEDY</poste>
        <poste code="0730210">TRESORERIE MONTMELIAN</poste>
        <poste code="0260150">TRESORERIE MONTMEYRAN</poste>
        <poste code="0510390">TRESORERIE MONTMIRAIL</poste>
        <poste code="0390380">TRESORERIE MONTMIREY-LE-CHATEAU</poste>
        <poste code="0160320">TRESORERIE MONTMOREAU-SAINT-CYBARD</poste>
        <poste code="0951070">TRESORERIE DE MONTMORENCY</poste>
        <poste code="0860130">TRESORERIE MONTMORILLON</poste>
        <poste code="0441120">TRESORERIE DE MONTOIR DE BRETAGNE</poste>
        <poste code="0410270">TRESORERIE MONTOIRE-SAVIGNY</poste>
        <poste code="0340000">TRESORERIE GENERALE DE L' HERAULT</poste>
        <poste code="0340007">CENTRE REGIONAL DES PENSIONS DE L' HERAULT</poste>
        <poste code="0340008">CENTRE DE FORMATION DEPARTEMENTAL DE L' HERAULT</poste>
        <poste code="0340009">DEPARTEMENT INFORMATIQUE DE L' HERAULT</poste>
        <poste code="0340190">TRESORERIE MONTPELLIER 1ERE DIVISION</poste>
        <poste code="0340200">TRESORERIE MONTPELLIER 2EME DIVISION</poste>
        <poste code="0340210">TRESORERIE MONTPELLIER MUNICIPALE</poste>
        <poste code="0340220">TRESORERIE DE MONTPELLIER CHR</poste>
        <poste code="0340320">TRESORERIE HERAULT AMENDES</poste>
        <poste code="0340800">PAIERIE REGIONALE DE LANGUEDOC-ROUSSILLON</poste>
        <poste code="0340900">PAIERIE DEPARTEMENTALE DE L' HERAULT</poste>
        <poste code="0340001">SERVICE CONTRLE REDEVANCE AUDIOVISUELLE DE L' HERAULT</poste>
        <poste code="0340006">PLE NATIONAL ANAFI HOSP-HLM - RISQUES COLLOC</poste>
        <poste code="0340005">CPS CENTRE PRLVEMENT SERVICE</poste>
        <poste code="0070170">TRESORERIE MONTPEZAT-SOUS-BAUZON</poste>
        <poste code="0240190">TRESORERIE MONTPON-MENESTEROL-VAUCLAIRE</poste>
        <poste code="0110260">TRESORERIE MONTREAL</poste>
        <poste code="0810290">TRESORERIE MONTREDON-LABESSONNIE</poste>
        <poste code="0310510">TRESORERIE DE MONTREJEAU</poste>
        <poste code="0622230">TRESORERIE MONTREUIL-SUR-MER</poste>
        <poste code="0930150">TRESORERIE MONTREUIL</poste>
        <poste code="0750009">DEPARTEMENT INFORMATIQUE DE LA RECETTE GENERALE DES FINANCES</poste>
        <poste code="0930160">TRESORERIE MONTREUIL MUNICIPALE</poste>
        <poste code="0490520">TRESORERIE MONTREUIL-BELLAY</poste>
        <poste code="4130000">DGCP 3ME SD - SYSTME D'INFORMATION</poste>
        <poste code="4130100">DGCP 3A - PILOTAGE</poste>
        <poste code="4140000">DGCP 4ME SD - RECETTES DE L'ETAT</poste>
        <poste code="4130200">DGCP 3B - MOYENS INFORMATIQUES</poste>
        <poste code="4130300">DGCP 3C - RECOUVREMENT DE L'IMPT</poste>
        <poste code="4140100">DGCP 4A - PILOTAGE, RELATIONS USAGERS</poste>
        <poste code="4130400">DGCP 3D - PROJETS DE DVELOPPEMENT</poste>
        <poste code="4140200">DGCP 4B -RECOUVREMT GESTION/EXPERTISE</poste>
        <poste code="4130500">DGCP 3E - COMPTABILITS-DPENSES ETAT</poste>
        <poste code="4136000">DGCP EQUIPE PROJET DITIQUE</poste>
        <poste code="4140300">DGCP 4C - MOA SYSTME D'INFORMATION</poste>
        <poste code="4138000">DGCP MISSION SCURIT DU SI</poste>
        <poste code="4148000">DGCP AMENDES : RINGNIERIE</poste>
        <poste code="4138100">DGCP CELLULE D'ANIMATION DU SI</poste>
        <poste code="0900090">TRESORERIE DE MONTREUX-CHATEAU</poste>
        <poste code="0490470">TRESORERIE MONTREVAULT</poste>
        <poste code="0010220">TRESORERIE MONTREVEL-EN-BRESSE</poste>
        <poste code="0410130">TRESORERIE MONTRICHARD</poste>
        <poste code="0921090">TRESORERIE MONTROUGE</poste>
        <poste code="0150150">TRESORERIE MONTSALVY</poste>
        <poste code="0580170">TRESORERIE MONTSAUCHE</poste>
        <poste code="0760290">TRESORERIE MONTVILLE</poste>
        <poste code="0400110">TRESORERIE MORCENX</poste>
        <poste code="0410280">TRESORERIE MOREE</poste>
        <poste code="0381200">TRESORERIE MORESTEL</poste>
        <poste code="0770370">TRESORERIE MORET-SUR-LOING</poste>
        <poste code="0800320">TRESORERIE MOREUIL</poste>
        <poste code="0390390">TRESORERIE DE MOREZ</poste>
        <poste code="0640160">TRESORERIE DE MORLAAS</poste>
        <poste code="0290250">TRESORERIE MORLAIX ET BANLIEUE</poste>
        <poste code="0290260">TRESORERIE MORLAIX MUNICIPALE</poste>
        <poste code="0840240">TRESORERIE DE MORMOIRON</poste>
        <poste code="0690240">TRESORERIE MORNANT</poste>
        <poste code="1010060">TRESORERIE MORNE-A-L'EAU</poste>
        <poste code="0610190">TRESORERIE DE MORTAGNE-AU-PERCHE</poste>
        <poste code="0850100">TRESORERIE MORTAGNE-SUR-SEVRE-TIFFAUGES</poste>
        <poste code="0500300">TRESORERIE DE MORTAIN-SOURDEVAL</poste>
        <poste code="0250480">TRESORERIE MORTEAU</poste>
        <poste code="0061160">TRESORERIE MOUGINS</poste>
        <poste code="0030000">TRESORERIE GENERALE DE L' ALLIER</poste>
        <poste code="0030080">TRESORERIE DE MOULINS MUNICIPALE</poste>
        <poste code="0030900">PAIERIE DEPARTEMENTALE DE L' ALLIER</poste>
        <poste code="0580180">TRESORERIE MOULINS-ENGILBERT</poste>
        <poste code="0640030">TRESORERIE DU BASSIN DE LACQ</poste>
        <poste code="0510120">TRESORERIE MOURMELON-LE-GRAND</poste>
        <poste code="0250310">TRESORERIE DE MOUTHE-LABERGEMENT-JOUGNE</poste>
        <poste code="0850330">TRESORERIE DE MOUTIERS-LES-MAUXFAITS</poste>
        <poste code="0730230">TRESORERIE DE MOUTIERS</poste>
        <poste code="0600320">TRESORERIE MOUY</poste>
        <poste code="0020550">TRESORERIE MOY-DE-L'AISNE</poste>
        <poste code="0570340">TRESORERIE MOYEUVRE-GRANDE</poste>
        <poste code="0400250">TRESORERIE MUGRON</poste>
        <poste code="0681000">RECETTE DES FINANCES MULHOUSE</poste>
        <poste code="0681120">TRESORERIE DE MULHOUSE RECOUVREMENT</poste>
        <poste code="0681170">TRESORERIE MULHOUSE MUNICIPALE</poste>
        <poste code="0681240">TRESORERIE DE MULHOUSE CENTRE HOSPITALIER</poste>
        <poste code="0681250">TRESORERIE DE MULHOUSE COURONNE</poste>
        <poste code="0680110">TRESORERIE MUNSTER</poste>
        <poste code="0680130">TRESORERIE MUNTZENHEIM</poste>
        <poste code="0220130">TRESORERIE MUR-DE-BRETAGNE</poste>
        <poste code="0150160">TRESORERIE MURAT</poste>
        <poste code="0310190">TRESORERIE MURET</poste>
        <poste code="0340400">TRESORERIE DE MURVIEL-LES-BEZIERS-AUTIGNAC</poste>
        <poste code="0240570">TRESORERIE DE VILLAMBLARD</poste>
        <poste code="0240200">TRESORERIE MUSSIDAN</poste>
        <poste code="0670310">TRESORERIE MUTTERSHOLTZ</poste>
        <poste code="0670320">TRESORERIE MUTZIG</poste>
        <poste code="0310200">TRESORERIE NAILLOUX</poste>
        <poste code="0120350">TRESORERIE NAJAC</poste>
        <poste code="9200000">AG.COMPT.APPROVISIONNEMENT DES ARMEES EN PRODUITS PETROLIERS</poste>
        <poste code="0540001">SERVICE CONTRLE REDEVANCE AUDIOVISUELLE DE LA MEURTHE ET MOSELLE</poste>
        <poste code="0540000">TRESORERIE GENERALE DE MEURTHE-ET-MOSELLE</poste>
        <poste code="0540130">TRESORERIE DE NANCY</poste>
        <poste code="0540140">TRESORERIE NANCY MUNICIPALE</poste>
        <poste code="0540150">TRESORERIE NANCY C.H.U</poste>
        <poste code="0540900">PAIERIE DEPARTEMENTALE DE MEURTHE-ET-MOSELLE</poste>
        <poste code="0770200">TRESORERIE DE NANGIS</poste>
        <poste code="0120360">TRESORERIE DU LARZAC</poste>
        <poste code="0920000">TRESORERIE GENERALE DES HAUTS-DE-SEINE</poste>
        <poste code="0920008">CENTRE DE FORMATION DEPARTEMENTAL DES HAUTS-DE-SEINE</poste>
        <poste code="0920009">DEPARTEMENT INFORMATIQUE DES HAUTS-DE-SEINE</poste>
        <poste code="0920260">TRESORERIE DE NANTERRE MUNICIPALE</poste>
        <poste code="0920900">PAIERIE DEPARTEMENTALE DES HAUTS-DE-SEINE</poste>
        <poste code="0920250">TRESORERIE NANTERRE</poste>
        <poste code="0920420">TRESORERIE HAUTS-DE-SEINE AMENDES</poste>
        <poste code="0920001">SERVICE CONTRLE REDEVANCE AUDIOVISUELLE DES HAUTS DE SEINE</poste>
        <poste code="0440000">TRESORERIE GENERALE DE LOIRE-ATLANTIQUE</poste>
        <poste code="0440007">CENTRE REGIONAL DES PENSIONS DE LOIRE-ATLANTIQUE</poste>
        <poste code="0440008">CENTRE DE FORMATION DEPARTEMENTAL DE LOIRE-ATLANTIQUE</poste>
        <poste code="0440009">DEPARTEMENT INFORMATIQUE DE LOIRE-ATLANTIQUE</poste>
        <poste code="0440130">TRESORERIE NANTES I PETIT-BOIS</poste>
        <poste code="0440150">TRESORERIE DE NANTES FEYDEAU</poste>
        <poste code="0440160">TRESORERIE DE NANTES-LES-PONTS AMENDES</poste>
        <poste code="0440190">TRESORERIE DE NANTES MUNICIPALE</poste>
        <poste code="0440200">TRESORERIE NANTES CHU</poste>
        <poste code="0440800">PAIERIE REGIONALE DES PAYS DE LA LOIRE</poste>
        <poste code="0440900">PAIERIE DEPARTEMENTALE DE LOIRE-ATLANTIQUE</poste>
        <poste code="9300000">TRESORERIE GENERALE POUR L'ETRANGER</poste>
        <poste code="9300007">CENTRE REGIONAL DES PENSIONS POUR L'ETRANGER</poste>
        <poste code="9190000">AGENCE COMPTABLE ETS AUTONOMIE FINANCIRE - TGE</poste>
        <poste code="0440001">SERVICE CONTRLE REDEVANCE AUDIOVISUELLE DE LOIRE ATLANTIQUE</poste>
        <poste code="0600380">TRESORERIE NANTEUIL-LE-HAUDOUIN</poste>
        <poste code="0870180">TRESORERIE DE NANTIAT</poste>
        <poste code="0010230">TRESORERIE NANTUA</poste>
        <poste code="0110490">TRESORERIE NARBONNE AGGLOMERATION</poste>
        <poste code="0110470">TRESORERIE DE NARBONNE VILLE</poste>
        <poste code="0120130">TRESORERIE DE NAUCELLE</poste>
        <poste code="0640180">TRESORERIE NAVARRENX</poste>
        <poste code="0640190">TRESORERIE NAY</poste>
        <poste code="0780230">TRESORERIE NEAUPHLE-LE-CHATEAU</poste>
        <poste code="0820190">TRESORERIE NEGREPELISSE</poste>
        <poste code="0770380">TRESORERIE NEMOURS-BOURRON-MARLOTTE</poste>
        <poste code="0470100">TRESORERIE NERAC</poste>
        <poste code="0680140">TRESORERIE DE NEUF-BRISACH</poste>
        <poste code="0880120">TRESORERIE COUSSEY-MARTIGNY-LES-GERBONVAUX</poste>
        <poste code="0880320">TRESORERIE NEUFCHATEAU</poste>
        <poste code="0760730">TRESORERIE DE NEUFCHATEL-EN-BRAY</poste>
        <poste code="0370260">TRESORERIE DE NEUILLE-PONT-PIERRE</poste>
        <poste code="0600390">TRESORERIE NEUILLY-EN-THELLE</poste>
        <poste code="0930170">TRESORERIE NEUILLY-PLAISANCE</poste>
        <poste code="0930350">TRESORERIE VILLE-EVRARD CHS</poste>
        <poste code="0920270">TRESORERIE NEUILLY-SUR-SEINE</poste>
        <poste code="0920280">TRESORERIE NEUILLY-SUR-SEINE MUNICIPALE</poste>
        <poste code="0410140">TRESORERIE NEUNG-SUR-BEUVRON</poste>
        <poste code="0540220">TRESORERIE NEUVES-MAISONS</poste>
        <poste code="0190110">TRESORERIE NEUVIC</poste>
        <poste code="0450150">TRESORERIE NEUVILLE-AUX-BOIS</poste>
        <poste code="0860140">TRESORERIE NEUVILLE-DE-POITOU</poste>
        <poste code="0593190">TRESORERIE DE NEUVILLE-SAINT-REMY</poste>
        <poste code="0690250">TRESORERIE DE NEUVILLE-SUR-SAONE</poste>
        <poste code="0370270">TRESORERIE DE NEUVY-LE-ROI</poste>
        <poste code="0580000">TRESORERIE GENERALE DE LA NIEVRE</poste>
        <poste code="0580190">TRESORERIE NEVERS</poste>
        <poste code="0580200">TRESORERIE NEVERS MUNICIPALE ET BANLIEUE</poste>
        <poste code="0580210">TRESORERIE NEVERS HOPITAL</poste>
        <poste code="0580900">PAIERIE DEPARTEMENTALE DE LA NIEVRE</poste>
        <poste code="0870190">TRESORERIE DE NEXON</poste>
        <poste code="0060000">TRESORERIE GENERALE DES ALPES-MARITIMES</poste>
        <poste code="0060007">CENTRE REGIONAL DES PENSIONS DES ALPES-MARITIMES</poste>
        <poste code="0060008">CENTRE DE FORMATION DEPARTEMENTAL DES ALPES-MARITIMES</poste>
        <poste code="0060009">DEPARTEMENT INFORMATIQUE DES ALPES-MARITIMES</poste>
        <poste code="0060090">TRESORERIE NICE PORT-ROSSINI</poste>
        <poste code="0060120">TRESORERIE NICE ARENES-VERDI</poste>
        <poste code="0060130">TRESORERIE NICE LA PLAINE</poste>
        <poste code="0060140">TRESORERIE ALPES MARITIMES AMENDES</poste>
        <poste code="0060150">TRESORERIE NICE MUNICIPALE</poste>
        <poste code="0060160">TRESORERIE NICE CENTRE HOSPITALIER</poste>
        <poste code="0060260">TRESORERIE NICE OPHLM</poste>
        <poste code="0060900">PAIERIE DEPARTEMENTALE DES ALPES-MARITIMES</poste>
        <poste code="0060001">SERVICE CONTRLE REDEVANCE AUDIOVISUELLE DES ALPES MARITIMES</poste>
        <poste code="0671130">TRESORERIE NIEDERBRONN-LES-BAINS</poste>
        <poste code="0300000">TRESORERIE GENERALE DU GARD</poste>
        <poste code="0300150">TRESORERIE NIMES NORD</poste>
        <poste code="0300160">TRESORERIE DE NIMES SUD</poste>
        <poste code="0300180">TRESORERIE NIMES MUNICIPALE</poste>
        <poste code="0300190">TRESORERIE NIMES CHU</poste>
        <poste code="0300900">PAIERIE DEPARTEMENTALE DU GARD</poste>
        <poste code="0300001">SERVICE CONTRLE REDEVANCE AUDIOVISUELLE DU GARD</poste>
        <poste code="0300170">TRESORERIE DE NIMES BANLIEUE</poste>
        <poste code="0790000">TRESORERIE GENERALE DES DEUX-SEVRES</poste>
        <poste code="0790180">TRESORERIE NIORT CENTRE HOSPITALIER</poste>
        <poste code="0790290">TRESORERIE DE NIORT</poste>
        <poste code="0790300">TRESORERIE MUNICIPALE DE NIORT-SEVRE</poste>
        <poste code="0790900">PAIERIE DEPARTEMENTALE DES DEUX-SEVRES</poste>
        <poste code="0790420">TRESORERIE DE NIORT OPAC SUD-DEUX-SEVRES</poste>
        <poste code="0600270">TRESORERIE NOAILLES</poste>
        <poste code="0320260">TRESORERIE NOGARO</poste>
        <poste code="0520220">TRESORERIE NOGENT-BIESLES</poste>
        <poste code="0280370">TRESORERIE NOGENT-LE-ROI</poste>
        <poste code="0280270">TRESORERIE DE NOGENT-LE-ROTROU THIRON-GARDAIS</poste>
        <poste code="0941050">TRESORERIE NOGENT-SUR-MARNE</poste>
        <poste code="0941000">RECETTE DES FINANCES NOGENT-SUR-MARNE</poste>
        <poste code="0100250">TRESORERIE DE NOGENT-SUR-SEINE</poste>
        <poste code="0422200">TRESORERIE NOIRETABLE</poste>
        <poste code="0850340">TRESORERIE NOIRMOUTIER-EN-L'ILE</poste>
        <poste code="3000000">ECOLE NATIONALE DU TRESOR PUBLIC - SCN</poste>
        <poste code="3000022">ECOLE ENT-PREPARATION AUX CONCOURS</poste>
        <poste code="0930490">TRESORERIE DES NON RESIDENTS</poste>
        <poste code="0756000">AGENCE COMPTABLE DES SERVICES INDUSTRIELS DE L'ARMEMENT</poste>
        <poste code="0930008">CENTRE DE FORMATION DEPARTEMENTAL DE LA SEINE-SAINT-DENIS</poste>
        <poste code="0930340">TRESORERIE NOISY-LE-GRAND</poste>
        <poste code="3000020">ECOLE DES CADRES C</poste>
        <poste code="3000030">CENTRE NATIONAL DE DOCUMENTATION DU TRESOR PUBLIC</poste>
        <poste code="4006000">DGCP PROGRAMME HELIOS</poste>
        <poste code="4110300">DGCP 1C : RESP. DES COMPTABLES</poste>
        <poste code="4268000">DGCP MISSION VRIF COMPTES DE GESTION</poste>
        <poste code="4008121">DGCP SERVICES GNRAUX - ANNEXE NOISY</poste>
        <poste code="9470001">SCE DE CONTRLE BUDGTAIRE COMPTABLE MINISTRIEL MINEFI - ANNEXE NOISY-LE-GRAND</poste>
        <poste code="0930180">TRESORERIE DE NOISY-LE-SEC</poste>
        <poste code="0930006">PLE NATIONAL DE GESTION DES PENSIONS</poste>
        <poste code="0210550">TRESORERIE NOLAY</poste>
        <poste code="0540180">TRESORERIE DE NOMENY</poste>
        <poste code="0270100">TRESORERIE NONANCOURT</poste>
        <poste code="0240220">TRESORERIE DE NONTRON</poste>
        <poste code="0440210">TRESORERIE NORT-SUR-ERDRE</poste>
        <poste code="1620001">TRESORERIE GENERALE DE LA NOUVELLE-CALEDONIE</poste>
        <poste code="1620000">TRESORERIE GENERALE DE LA NOUVELLE-CALEDONIE</poste>
        <poste code="1620010">TRESORERIE DE LA PROVINCE SUD</poste>
        <poste code="1620040">TRESORERIE DE LA PROVINCE DES ILES LOYAUTE</poste>
        <poste code="1620050">PAIERIE DE LA NOUVELLE CALDONIE ET ETS PCS</poste>
        <poste code="1620060">TRESORERIE CENTRES HOSPITALIERS DE NOUMEA</poste>
        <poste code="0080320">TRESORERIE NOUZONVILLE</poste>
        <poste code="0490370">TRESORERIE NOYANT</poste>
        <poste code="0600520">TRESORERIE NOYON</poste>
        <poste code="0440220">TRESORERIE NOZAY</poste>
        <poste code="0390160">TRESORERIE NOZEROY-CENSEAU</poste>
        <poste code="0210560">TRESORERIE NUITS-SAINT-GEORGES</poste>
        <poste code="0260370">TRESORERIE NYONS</poste>
        <poste code="1350000">TRESORERIE AMBASSADE DE FRANCE AU TCHAD</poste>
        <poste code="0670350">TRESORERIE OBERNAI</poste>
        <poste code="0670390">TRESORERIE ROSHEIM</poste>
        <poste code="0190350">TRESORERIE AYEN</poste>
        <poste code="0190310">TRESORERIE D' OBJAT</poste>
        <poste code="0760640">TRESORERIE OFFRANVILLE</poste>
        <poste code="0800710">TRESORERIE OISEMONT</poste>
        <poste code="0830100">TRESORERIE OLLIOULES</poste>
        <poste code="0640200">TRESORERIE OLORON-ARAMITS</poste>
        <poste code="0410150">TRESORERIE D' ONZAIN-HERBAULT</poste>
        <poste code="0840250">TRESORERIE ORANGE</poste>
        <poste code="0140550">TRESORERIE ORBEC</poste>
        <poste code="0593070">TRESORERIE ORCHIES</poste>
        <poste code="0390170">TRESORERIE ORGELET</poste>
        <poste code="0132090">TRESORERIE ORGON</poste>
        <poste code="0450170">TRESORERIE D' ORLEANS</poste>
        <poste code="0450000">TRESORERIE GENERALE DU LOIRET</poste>
        <poste code="0450001">ANNEXE T.G. DU LOIRET</poste>
        <poste code="0450110">TRESORERIE ORLEANS BANLIEUE</poste>
        <poste code="0450800">PAIERIE REGIONALE DE CENTRE</poste>
        <poste code="0450190">TRESORERIE D' ORLEANS MUNICIPALE</poste>
        <poste code="0450200">TRESORERIE ORLEANS CENTRES HOSPITALIERS</poste>
        <poste code="0450900">PAIERIE DEPARTEMENTALE DU LOIRET</poste>
        <poste code="0450002">SERVICE CONTRLE REDEVANCE AUDIOVISUELLE DU LOIRET</poste>
        <poste code="0450160">TRESORERIE OLIVET</poste>
        <poste code="0940300">TRESORERIE ORLY</poste>
        <poste code="0250160">TRESORERIE ORNANS</poste>
        <poste code="0911110">TRESORERIE ORSAY</poste>
        <poste code="0640210">TRESORERIE D' ORTHEZ</poste>
        <poste code="0650230">TRESORERIE OSSUN</poste>
        <poste code="0681180">TRESORERIE OTTMARSHEIM</poste>
        <poste code="1250000">TRESORERIE AMBASSADE DE FRANCE AU BURKINA-FASO</poste>
        <poste code="0140250">TRESORERIE OUISTREHAM</poste>
        <poste code="0690260">TRESORERIE OULLINS</poste>
        <poste code="0090120">TRESORERIE OUST-MASSAT</poste>
        <poste code="0450420">TRESORERIE OUTARVILLE</poste>
        <poste code="0622090">TRESORERIE D' OUTREAU</poste>
        <poste code="0622310">TRESORERIE OYE-PLAGE</poste>
        <poste code="0010240">TRESORERIE OYONNAX</poste>
        <poste code="0270110">TRESORERIE PACY-SUR-EURE</poste>
        <poste code="0441190">TRESORERIE PAIMBOEUF</poste>
        <poste code="0220460">TRESORERIE PAIMPOL</poste>
        <poste code="0911120">TRESORERIE PALAISEAU</poste>
        <poste code="0911000">RECETTE DES FINANCES PALAISEAU</poste>
        <poste code="0090260">TRESORERIE DE PAMIERS</poste>
        <poste code="0930190">TRESORERIE PANTIN</poste>
        <poste code="0930200">TRESORERIE PANTIN MUNICIPALE</poste>
        <poste code="0930390">TRESORERIE SEINE-SAINT-DENIS AMENDES</poste>
        <poste code="9130000">AGENCE COMPTABLE DIRECTION GRANDES ENTREPRISES</poste>
        <poste code="1610020">TRESORERIE DU VENT, AUSTRALES ET ARCHIPELS</poste>
        <poste code="1610000">TRESORERIE GENERALE DE LA POLYNESIE FRANCAISE</poste>
        <poste code="1610050">TRESORERIE DES ETABLISSEMENTS PUBLICS</poste>
        <poste code="1610060">TRESORERIE DE LA PAIERIE DE POLYNESIE FRANCAISE</poste>
        <poste code="1610070">TRESORERIE CTRE HOSP DE POLYNESIE FRANCAISE</poste>
        <poste code="0710230">TRESORERIE PARAY-LE-MONIAL</poste>
        <poste code="0400120">TRESORERIE PARENTIS-EN-BORN</poste>
        <poste code="0750060">TRESORERIE PARIS 5E ARRONDISSEMENT</poste>
        <poste code="0750110">TRESORERIE PARIS 8 E</poste>
        <poste code="0750000">RECETTE GENERALE DES FINANCES DE PARIS</poste>
        <poste code="0750001">RECETTE GENERALE DES FINANCES DE PARIS - ANNEXE NDV</poste>
        <poste code="0750008">CENTRE DE FORMATION DEPARTEMENTAL DE LA R.G.F. DE PARIS</poste>
        <poste code="0750010">TRESORERIE DE PARIS CENTRE</poste>
        <poste code="0750080">TRESORERIE PARIS 6E ARRONDT</poste>
        <poste code="0750100">TRESORERIE PARIS 7E ARRONDISSEMENT</poste>
        <poste code="0750140">TRESORERIE PARIS 9E ARRONDT 1ERE DIVISION</poste>
        <poste code="0750150">TRESORERIE PARIS 9E ARRONDT 2EME DIVISION</poste>
        <poste code="0750160">TRESORERIE PARIS 10E ARRONDT 1ERE DIVISION</poste>
        <poste code="0750170">TRESORERIE PARIS 10E ARRONDT 2EME DIVISION</poste>
        <poste code="0750180">TRESORERIE PARIS 11E ARRONDT 1ERE DIVISION</poste>
        <poste code="0750190">TRESORERIE DE PARIS 11E ARRONDT 2EME DIVISION</poste>
        <poste code="0750210">TRESORERIE PARIS 12E ARRONDT 1ERE DIVISION</poste>
        <poste code="0750220">TRESORERIE PARIS 12E ARRONDT 2EME DIVISION</poste>
        <poste code="0750230">TRESORERIE PARIS 13E ARRONDT 1ERE DIVISION</poste>
        <poste code="0750240">TRESORERIE PARIS 13E ARRONDT 2EME DIVISION</poste>
        <poste code="0750250">TRESORERIE PARIS 14E ARRONDT 1ERE DIVISION</poste>
        <poste code="0750260">TRESORERIE PARIS 14E ARRONDT 2EME DIVISION</poste>
        <poste code="0750280">TRESORERIE PARIS 15E ARRONDT 1ERE DIVISION</poste>
        <poste code="0750290">TRESORERIE PARIS 15E ARRONDT 2EME DIVISION</poste>
        <poste code="0750300">TRESORERIE PARIS 15E ARRONDT 3EME DIVISION</poste>
        <poste code="0750310">TRESORERIE PARIS 16E ARRONDT 1ERE DIVISION</poste>
        <poste code="0750320">TRESORERIE PARIS 16E ARRONDT 2EME DIVISION</poste>
        <poste code="0750330">TRESORERIE PARIS 16E ARRONDT 3EME DIVISION</poste>
        <poste code="0750340">TRESORERIE PARIS 17E ARRONDT 1ERE DIVISION</poste>
        <poste code="0750350">TRESORERIE PARIS 17E ARRONDT 2EME DIVISION</poste>
        <poste code="0750360">TRESORERIE PARIS 17E ARRONDT 3EME DIVISION</poste>
        <poste code="0750370">TRESORERIE PARIS 17E ARRONDT 4EME DIVISION</poste>
        <poste code="0750380">TRESORERIE DE PARIS 18E ARRONDT 1ERE DIVISION</poste>
        <poste code="0750400">TRESORERIE PARIS 18E ARRONDT 2EME DIVISION</poste>
        <poste code="0750410">TRESORERIE PARIS 19E ARRONDT 1ERE DIVISION</poste>
        <poste code="0750420">TRESORERIE PARIS 19E ARRONDT 2EME DIVISION</poste>
        <poste code="0750430">TRESORERIE PARIS 20E ARRONDT 1ERE DIVISION</poste>
        <poste code="0750440">TRESORERIE PARIS 20E ARRONDT 2EME DIVISION</poste>
        <poste code="0750450">TRESORERIE PARIS 15E ARRONDT 4EME DIVISION</poste>
        <poste code="0750470">TRESORERIE PARIS 16E ARRONDT 4EME DIVISION</poste>
        <poste code="0750610">TRESORERIE PARIS AMENDES 1ERE DIVISION</poste>
        <poste code="0750620">TRESORERIE PARIS AMENDES 2EME DIVISION</poste>
        <poste code="0750630">TRESORERIE PARIS AMENDES DE TRANSPORTS</poste>
        <poste code="0750640">TRESORERIE PARIS CENTRES HOSPITALIERS SPEC.</poste>
        <poste code="0750650">TRESORERIE ETABLISSEMENTS PUBLICS LOCAUX</poste>
        <poste code="0750660">TRESORERIE CENTRE D'ACTION SOCIALE DE PARIS</poste>
        <poste code="0750990">RECETTE GENERALE DES FINANCES DE PARIS-VILLE-DPT-PRF POLICE</poste>
        <poste code="0751000">AGENCE COMPTABLE DES SERVICES DES AEROPORTS DE PARIS</poste>
        <poste code="0752000">PAIERIE GENERALE DU TRESOR</poste>
        <poste code="0752009">DEPARTEMENT INFORMATIQUE DE LA PAIERIE GNRALE DU TRSOR</poste>
        <poste code="0753000">TRESORERIE GENERALE DE L' ASSISTANCE PUB. - HOPITAUX PARIS</poste>
        <poste code="0753001">TRESORERIE GENERALE ANNEXE ASSISTANCE PUB.-HP.PARIS</poste>
        <poste code="0753009">DEPARTEMENT INFORMATIQUE DE L' ASSISTANCE PUB. - HOPITAUX PARIS</poste>
        <poste code="0754000">RECETTE PRINCIPALE REGIONALE DES DOUANES DE PARIS</poste>
        <poste code="0755000">AGENCE COMPTABLE DES IMPOTS DE PARIS</poste>
        <poste code="9000000">TRESORERIE GENERALE DE L' ACCT</poste>
        <poste code="9000009">DEPARTEMENT INFORMATIQUE DE L' ACCT</poste>
        <poste code="9100000">AGENCE COMPTABLE DOCUMENTATION FRANCAISE</poste>
        <poste code="9150000">AGENCE COMPTABLE FONDS PEREQ. TRANSPORTS AERIENS</poste>
        <poste code="9300010">SERVICE DE LA TRESORERIE DE L' ANTENNE TGE</poste>
        <poste code="9420000">SCE DE CONTRLE BUDGTAIRE COMPTABLE MINISTRIEL AUPRES DU MINISTERE CHARGE DE L'INTERIEUR</poste>
        <poste code="0750991">RECETTE GENERALE DES FINANCES DE PARIS - RGION</poste>
        <poste code="0750992">RECETTE GENERALE DES FINANCES DE PARIS - ETS INTERDEPARTEMENTAUX</poste>
        <poste code="0750993">RECETTE GENERALE DES FINANCES DE PARIS - AUTRES ETS LOCAUX</poste>
        <poste code="9510000">SCE DE CONTRLE BUDGTAIRE COMPTABLE MINISTRIEL AUPRES DES SERVICES DU 1ER MINISTRE</poste>
        <poste code="9520000">SCE DE CONTRLE BUDGTAIRE COMPTABLE MINISTRIEL AUPRES DU MINISTRE CHARG DE LA CULTURE</poste>
        <poste code="9120000">AGENCE COMPTABLE DU B.A. MONNAIES ET MDAILLES</poste>
        <poste code="9170000">AGENCE COMPTABLE BA PUBLI OFFICIELLES - INFO ADMI</poste>
        <poste code="9090009">DEPARTEMENT INFORMATIQUE CBLE CENTRALISATEUR COMPTES TAT</poste>
        <poste code="9110000">AGENCE COMPTABLE DU SERVICE CTRE NAT.FONCTION PUBL.TERRITOR.</poste>
        <poste code="0759000">AGENCE COMPT. REGIE INDUSTRIELLE ETABLISSEMENTS PENITENTIAIRES</poste>
        <poste code="9430000">SCE DE CONTRLE BUDGTAIRE COMPTABLE MINISTRIEL AUPRES DU MINISTRE CHARG DE LA JUSTICE</poste>
        <poste code="0750006">PLE NATIONAL DE SOUTIEN AU RESEAU MOYENS DE PAIEMENT DU SPL</poste>
        <poste code="0750007">CENTRE REGIONAL DES PENSIONS DU TRESOR</poste>
        <poste code="9530000">SCE DE CONTRLE BUDGTAIRE COMPTABLE MINISTRIEL AUPRES DU MINISTRE DE L'ENVIRONNEMENT</poste>
        <poste code="9940001">RECETTE DES FINANCES DOMAINE - ANNEXE ST-PTERSBOURG</poste>
        <poste code="9700000">RECETTE GENERALE DES FINANCES LIQUIDATION OP REDEVANCE</poste>
        <poste code="0750002">SERVICE CONTRLE REDEVANCE AUDIOVISUELLE DE PARIS</poste>
        <poste code="4000000">DGCP DIRECTION GNRALE</poste>
        <poste code="4008300">DGCP CONTRLE DE GESTION</poste>
        <poste code="4100000">DGCP SERVICE RESSOURCES RSEAU</poste>
        <poste code="4200000">DGCP SERVICE FONCTION COMPTABLE TAT</poste>
        <poste code="4110000">DGCP 1RE SD : PILOTAGE-BUDGET-RSEAU</poste>
        <poste code="4008000">DGCP MISSION AUDIT EVAL CONTRLE</poste>
        <poste code="4120000">DGCP 2ME SD - RESSOURCES HUMAINES</poste>
        <poste code="4008100">DGCP CABINET DU DIRECTEUR GNRAL</poste>
        <poste code="4126000">DGCP MISSION SIRH (SEQUOIA)</poste>
        <poste code="4008110">DGCP COMMUNICATION</poste>
        <poste code="4008120">DGCP SERVICES GENERAUX</poste>
        <poste code="4010000">DGCP SCN COPERNIC</poste>
        <poste code="4110100">DGCP 1A - PILOTAGE ET RSEAU</poste>
        <poste code="4120100">DGCP 2A - PILOTAGE ET DIALOGUE SOCIAL</poste>
        <poste code="4008200">DGCP PORTAIL MINEFI COLLOC</poste>
        <poste code="4108000">DGCP MISSION DE COOP INTERNATIONALE</poste>
        <poste code="4110200">DGCP 1B - MOYENS BUDG. ET IMMO.</poste>
        <poste code="4118000">DGCP CELLULE QUALIT SIMPLIFICATION</poste>
        <poste code="4120300">DGCP 2C - CADRES SUP, AGENTS CPTABLES</poste>
        <poste code="4110500">DGCP CELLULE SCURIT</poste>
        <poste code="4120400">DGCP 2D - PERSONNELS DE CATGORIE A</poste>
        <poste code="4110400">DGCP 1D : EXPERTISE ET ACTIONS CO.</poste>
        <poste code="4150000">DGCP 5ME SD : SECTEUR PUBLIC LOCAL</poste>
        <poste code="4150100">DGCP 5A : PILOTAGE ET MOA DU SI</poste>
        <poste code="4150200">DGCP 5B : EXPERTISE JURIDIQUE</poste>
        <poste code="4270000">DGCP 7ME SD : ORG. COMPTABLE/DPENSE</poste>
        <poste code="4150300">DGCP 5C : COMPTABILITS LOCALES</poste>
        <poste code="4206000">DGCP FCE-MISSION CONDUITE CHANGEMENT</poste>
        <poste code="4270100">DGCP 7A -ORGANISATION COMPTABLE</poste>
        <poste code="4150400">DGCP 5D : ACTIV. BANC. ET SERV. FIN</poste>
        <poste code="4206100">DGCP FCE-MISSION DOCTRINE COMPTABLE</poste>
        <poste code="4270200">DGCP 7B : MODERNISATION DE LA DPENSE</poste>
        <poste code="4270300">DGCP 7C - RMUNRATIONS ET PENSIONS</poste>
        <poste code="4270400">DGCP 7D : OPRATEURS DE L ETAT</poste>
        <poste code="4260000">DGCP 6ME SD - NORMES ET AUDITS COMPT</poste>
        <poste code="4260100">DGCP 6A - CONTRLE ET AUDIT INTERNES</poste>
        <poste code="4260200">DGCP 6B - COMPTABILIT DE L'TAT</poste>
        <poste code="4260300">DGCP 6C - COMPTES NATIONAUX</poste>
        <poste code="9470000">SCE DE CONTRLE BUDGTAIRE COMPTABLE MINISTRIEL AUPRES DU MINFI</poste>
        <poste code="4006100">DGCP MISSION CNE DGI/DGCP - ACCUEIL</poste>
        <poste code="4300000">DGCP SERVICE FRANCE DOMAINE</poste>
        <poste code="4300100">DGCP MISSIONS DOMANIALES</poste>
        <poste code="4306000">DGCP POLITIQUE IMMOBILIRE DE L'ETAT</poste>
        <poste code="9090000">RECETTE DES FINANCES CBLE CENTRALISATEUR COMPTES TAT</poste>
        <poste code="4120200">DGCP 2B - FORMATION ET GPEEC</poste>
        <poste code="4120500">DGCP 2E - PERSONNELS B,C,CONTRACTUELS</poste>
        <poste code="9540000">SCE DE CONTRLE BUDGTAIRE COMPTABLE MINISTRIEL AUPRES DU MINISTRE JEUNESSE ET SPORTS</poste>
        <poste code="4260101">DGCP BUREAU 6A - ANNEXE AURIOL</poste>
        <poste code="9490000">SCE DE CONTRLE BUDGTAIRE COMPTABLE MINISTRIEL AUPRES DU MINISTRE AFFAIRES SOCIALES</poste>
        <poste code="9480000">SCE DE CONTRLE BUDGTAIRE COMPTABLE MINISTRIEL AUPRES DU MINISTRE CHARG DE L'EMPLOI</poste>
        <poste code="9140000">AGENCE COMPTABLE DU BA CONTRLE EXPLOITATION ARIEN</poste>
        <poste code="9160000">AGENCE COMPTABLE DU BA DES JOURNAUX OFFICIELS</poste>
        <poste code="0750480">TRESORERIE PARIS 20E ARRONDT 3EME DIVISION</poste>
        <poste code="9450000">SCE DE CONTRLE BUDGTAIRE COMPTABLE MINISTRIEL AUPRES DU MINISTRE DE L'QUIPEMENT</poste>
        <poste code="9410000">SCE DE CONTRLE BUDGTAIRE COMPTABLE MINISTRIEL AUPRES DU MINISTRE AGRICULTURE</poste>
        <poste code="9440000">SCE DE CONTRLE BUDGTAIRE COMPTABLE MINISTRIEL AUPRES DU MINISTRE DE L'OUTRE-MER</poste>
        <poste code="9460000">SCE DE CONTRLE BUDGTAIRE COMPTABLE MINISTRIEL AUPRES DU MINISTRE DE L'DUCATION ET RECH</poste>
        <poste code="0790320">TRESORERIE DE PARTHENAY</poste>
        <poste code="0450220">TRESORERIE PATAY</poste>
        <poste code="0640000">TRESORERIE GENERALE DES PYRENEES-ATLANTIQUES</poste>
        <poste code="0640230">TRESORERIE DE PAU</poste>
        <poste code="0640250">TRESORERIE PAU ETABLISSEMENTS HOSPITALIERS</poste>
        <poste code="0640260">TRESORERIE PAU MUNICIPALE</poste>
        <poste code="0640900">PAIERIE DEPARTEMENTALE DES PYRENEES-ATLANTIQUES</poste>
        <poste code="0640001">SERVICE CONTRLE REDEVANCE AUDIOVISUELLE DES PYRENEES-ATLANTIQUES</poste>
        <poste code="0330390">TRESORERIE DE PAUILLAC</poste>
        <poste code="0430180">TRESORERIE PAULHAGUET</poste>
        <poste code="1500000">TRESORERIE AMBASSADE DE FRANCE EN CHINE A PEKIN</poste>
        <poste code="0420070">TRESORERIE PELUSSIN</poste>
        <poste code="0470280">TRESORERIE PENNE-D'AGENAIS</poste>
        <poste code="0500140">TRESORERIE PERIERS-SAINT-SAUVEUR-LENDELIN</poste>
        <poste code="0170100">TRESORERIE LA ROCHELLE BANLIEUE</poste>
        <poste code="0240000">TRESORERIE GENERALE DE LA DORDOGNE</poste>
        <poste code="0240240">TRESORERIE DE PERIGUEUX MUNICIPALE</poste>
        <poste code="0240450">TRESORERIE PERIGUEUX ETS HOSP</poste>
        <poste code="0240900">PAIERIE DEPARTEMENTALE DE LA DORDOGNE</poste>
        <poste code="0240230">TRESORERIE DE PERIGUEUX</poste>
        <poste code="0240001">SERVICE CONTRLE REDEVANCE AUDIOVISUELLE DE LA DORDOGNE</poste>
        <poste code="0620410">TRESORERIE HEUCHIN-PERNES</poste>
        <poste code="0840260">TRESORERIE PERNES-LES-FONTAINES</poste>
        <poste code="0010290">TRESORERIE BOURG BANLIEUE</poste>
        <poste code="0800560">TRESORERIE PERONNE</poste>
        <poste code="0660000">TRESORERIE GENERALE DES PYRENEES-ORIENTALES</poste>
        <poste code="0660130">TRESORERIE PERPIGNAN</poste>
        <poste code="0660140">TRESORERIE PERPIGNAN MUNICIPALE</poste>
        <poste code="0660150">TRESORERIE PERPIGNAN HOSPICES</poste>
        <poste code="0660290">TRESORERIE DE PERPIGNAN HLM</poste>
        <poste code="0660001">CELLULE CONTRLE REDEVANCE AUDIOVISUELLE DES PYRENEES ORIENTALES</poste>
        <poste code="0710240">TRESORERIE DE PERRECY-PALINGES</poste>
        <poste code="0220370">TRESORERIE PERROS-GUIREC</poste>
        <poste code="0840150">TRESORERIE PERTUIS</poste>
        <poste code="0330410">TRESORERIE PESSAC</poste>
        <poste code="0400260">TRESORERIE PEYREHORADE</poste>
        <poste code="0110300">TRESORERIE PEYRIAC-MINERVOIS</poste>
        <poste code="0131120">TRESORERIE PEYROLLES-EN-PROVENCE</poste>
        <poste code="0340410">TRESORERIE PEZENAS</poste>
        <poste code="0590300">TRESORERIE PHALEMPIN</poste>
        <poste code="0570350">TRESORERIE PHALSBOURG</poste>
        <poste code="02A0060">TRESORERIE EVISA</poste>
        <poste code="0800350">TRESORERIE PICQUIGNY</poste>
        <poste code="02B0170">TRESORERIE PIEDICROCE</poste>
        <poste code="0870230">TRESORERIE DE PIERRE-BUFFIERE</poste>
        <poste code="0710520">TRESORERIE PIERRE-DE-BRESSE-SAINT-MARTIN</poste>
        <poste code="0830110">TRESORERIE PIERREFEU-DU-VAR CTRE PSYCHO.</poste>
        <poste code="0250170">TRESORERIE DE PIERREFONTAINE-LES VARANS</poste>
        <poste code="0260380">TRESORERIE PIERRELATTE</poste>
        <poste code="0100260">TRESORERIE DE PINEY</poste>
        <poste code="0350250">TRESORERIE DE PIPRIAC-MAURE</poste>
        <poste code="0400130">TRESORERIE PISSOS</poste>
        <poste code="0450430">TRESORERIE PITHIVIERS</poste>
        <poste code="0290160">TRESORERIE PLABENNEC</poste>
        <poste code="0320010">TRESORERIE AIGNAN</poste>
        <poste code="0320270">TRESORERIE PLAISANCE</poste>
        <poste code="0780240">TRESORERIE PLAISIR ETS HOSP</poste>
        <poste code="0780350">TRESORERIE PLAISIR</poste>
        <poste code="0220300">TRESORERIE PLANCOET</poste>
        <poste code="0150190">TRESORERIE PLEAUX</poste>
        <poste code="0350260">TRESORERIE PLELAN-LE-GRAND</poste>
        <poste code="0220150">TRESORERIE PLENEUF-VAL-ANDRE</poste>
        <poste code="0220380">TRESORERIE PLESTIN-LES-GREVES</poste>
        <poste code="0860350">TRESORERIE PLEUMARTIN</poste>
        <poste code="0290170">TRESORERIE PLEYBEN</poste>
        <poste code="0290310">TRESORERIE SAINT-THEGONNEC</poste>
        <poste code="0560100">TRESORERIE PLOERMEL</poste>
        <poste code="0220160">TRESORERIE DE PLOEUC-SUR-LIE</poste>
        <poste code="0292060">TRESORERIE PLOGASTEL ET PLONEOUR</poste>
        <poste code="0880330">TRESORERIE PLOMBIERES-LES-BAINS</poste>
        <poste code="0220390">TRESORERIE PLOUARET</poste>
        <poste code="0560320">TRESORERIE PLOUAY</poste>
        <poste code="0220310">TRESORERIE PLOUBALAY</poste>
        <poste code="0290180">TRESORERIE PLOUDALMEZEAU</poste>
        <poste code="0290270">TRESORERIE PLOUESCAT</poste>
        <poste code="0290280">TRESORERIE PLOUIGNEAU-GUERLESQUIN</poste>
        <poste code="0560330">TRESORERIE PLUVIGNER</poste>
        <poste code="0330420">TRESORERIE PODENSAC</poste>
        <poste code="1620030">TRESORERIE DE POINDIMIE</poste>
        <poste code="1010090">TRESORERIE POINTE-A-PITRE</poste>
        <poste code="1010180">TRESORERIE POINTE-A-PITRE MUNICIPALE</poste>
        <poste code="1010100">TRESORERIE POINTE-NOIRE</poste>
        <poste code="0781140">TRESORERIE POISSY</poste>
        <poste code="0781000">RECETTE DES FINANCES POISSY VAL DE SEINE</poste>
        <poste code="0860000">TRESORERIE GENERALE DE LA VIENNE</poste>
        <poste code="0860020">TRESORERIE BIARD</poste>
        <poste code="0860150">TRESORERIE POITIERS</poste>
        <poste code="0860160">TRESORERIE POITIERS MUNICIPALE</poste>
        <poste code="0860170">TRESORERIE POITIERS ETS HOSP.</poste>
        <poste code="0860291">TRESORERIE ANNEXE OPAC VILLE DE POITIERS</poste>
        <poste code="0860800">PAIERIE REGIONALE DE POITOU-CHARENTES</poste>
        <poste code="0860900">PAIERIE DEPARTEMENTALE DE LA VIENNE</poste>
        <poste code="0860001">SERVICE CONTRLE REDEVANCE AUDIOVISUELLE DE LA VIENNE</poste>
        <poste code="0860006">PLE NATIONAL P@BLO</poste>
        <poste code="0800360">TRESORERIE POIX-DE-P-QUEVAUVILLERS</poste>
        <poste code="0080350">TRESORERIE POIX-TERRON</poste>
        <poste code="0390190">TRESORERIE POLIGNY</poste>
        <poste code="0010250">TRESORERIE PONCIN</poste>
        <poste code="0170330">TRESORERIE PONS-PERIGNAC</poste>
        <poste code="0590310">TRESORERIE PONT-A-MARCQ</poste>
        <poste code="0540200">TRESORERIE PONT-A-MOUSSON</poste>
        <poste code="0620810">TRESORERIE PONT-A-VENDIN</poste>
        <poste code="0270340">TRESORERIE DE PONT-AUDEMER</poste>
        <poste code="0292080">TRESORERIE PONT-AVEN</poste>
        <poste code="0292090">TRESORERIE DE PONT-CROIX</poste>
        <poste code="0010260">TRESORERIE PONT-D'AIN</poste>
        <poste code="0381150">TRESORERIE PONT-DE-CHERUY</poste>
        <poste code="0270350">TRESORERIE PONT-DE-L'ARCHE</poste>
        <poste code="0250430">TRESORERIE PONT-DE-ROIDE</poste>
        <poste code="0120140">TRESORERIE DU LEVEZOU</poste>
        <poste code="0010270">TRESORERIE PONT-DE-VAUX</poste>
        <poste code="0010280">TRESORERIE PONT-DE-VEYLE</poste>
        <poste code="0630220">TRESORERIE PONT-DU-CHATEAU</poste>
        <poste code="0292100">TRESORERIE PONT-L'ABBE</poste>
        <poste code="0140560">TRESORERIE PONT-L'EVEQUE</poste>
        <poste code="0600400">TRESORERIE PONT-SAINTE-MAXENCE</poste>
        <poste code="0300200">TRESORERIE PONT-SAINT-ESPRIT</poste>
        <poste code="0890490">TRESORERIE PONT-SUR-YONNE</poste>
        <poste code="0640280">TRESORERIE PONTACQ-SOUMOULOU</poste>
        <poste code="0210290">TRESORERIE PONTAILLER-SUR-SAONE</poste>
        <poste code="0250320">TRESORERIE PONTARLIER ET BANLIEUE</poste>
        <poste code="0250330">TRESORERIE PONTARLIER MUNICIPALE</poste>
        <poste code="0770280">TRESORERIE ROISSY-PONTAULT-COMBAULT</poste>
        <poste code="0630420">TRESORERIE PONTAUMUR</poste>
        <poste code="0380300">TRESORERIE PONTCHARRA</poste>
        <poste code="0441080">TRESORERIE DE PONTCHATEAU</poste>
        <poste code="02B0130">TRESORERIE MOROSAGLIA</poste>
        <poste code="0512070">TRESORERIE DE PONTFAVERGER-BEINE-NAUROY</poste>
        <poste code="0630430">TRESORERIE PONTGIBAUD</poste>
        <poste code="0560240">TRESORERIE PONTIVY</poste>
        <poste code="0950320">TRESORERIE PONTOISE CENTRE HOSP</poste>
        <poste code="0500310">TRESORERIE PONTORSON</poste>
        <poste code="0220400">TRESORERIE PONTRIEUX</poste>
        <poste code="0441170">TRESORERIE PORNIC</poste>
        <poste code="0132160">TRESORERIE PORT-DE-BOUC</poste>
        <poste code="0560350">TRESORERIE PORT-LOUIS</poste>
        <poste code="1010110">TRESORERIE PORT-LOUIS</poste>
        <poste code="0700350">TRESORERIE PORT-SUR-SAONE</poste>
        <poste code="0660160">TRESORERIE PORT-VENDRES</poste>
        <poste code="02A0130">TRESORERIE PORTO-VECCHIO</poste>
        <poste code="0490200">TRESORERIE POUANCE</poste>
        <poste code="0580220">TRESORERIE POUGUES-LES-EAUX</poste>
        <poste code="0250090">TRESORERIE POUILLEY-LES-VIGNES</poste>
        <poste code="0400270">TRESORERIE POUILLON</poste>
        <poste code="0210570">TRESORERIE POUILLY-EN-AUXOIS</poste>
        <poste code="0580230">TRESORERIE POUILLY-SUR-LOIRE</poste>
        <poste code="0850250">TRESORERIE POUZAUGES</poste>
        <poste code="0430210">TRESORERIE PRADELLES-LANDOS</poste>
        <poste code="0660170">TRESORERIE PRADES</poste>
        <poste code="0790330">TRESORERIE PRAHECQ</poste>
        <poste code="0660180">TRESORERIE PRATS-DE-MOLLO-LA-PRESTE</poste>
        <poste code="0520380">TRESORERIE DE PRAUTHOY</poste>
        <poste code="0470110">TRESORERIE DE PRAYSSAS</poste>
        <poste code="0530290">TRESORERIE PRE-EN-PAIL</poste>
        <poste code="0210300">TRESORERIE PRECY-SOUS-THIL</poste>
        <poste code="0580240">TRESORERIE PREMERY</poste>
        <poste code="0370300">TRESORERIE PREUILLY-SUR-CLAISE</poste>
        <poste code="0070000">TRESORERIE GENERALE DE L' ARDECHE</poste>
        <poste code="0070180">TRESORERIE DE PRIVAS MUNICIPALE</poste>
        <poste code="0070900">PAIERIE DEPARTEMENTALE DE L' ARDECHE</poste>
        <poste code="0070420">TRESORERIE DE PRIVAS</poste>
        <poste code="0770210">TRESORERIE PROVINS</poste>
        <poste code="0060170">TRESORERIE DE PUGET-THENIERS</poste>
        <poste code="0610390">TRESORERIE DE PUTANGES-PONT-ECREPIN</poste>
        <poste code="0920300">TRESORERIE PUTEAUX MUNICIPALE</poste>
        <poste code="9250000">AGENCE COMPTABLE AGENCE COMPTABLE PARC EQUIPEMENT</poste>
        <poste code="0571110">TRESORERIE PUTTELANGE-AUX-LACS</poste>
        <poste code="0460230">TRESORERIE PUY-L'EVEQUE-DURAVEL</poste>
        <poste code="0260180">TRESORERIE PUY-SAINT-MARTIN-BOURDEAUX</poste>
        <poste code="0810300">TRESORERIE DE PUYLAURENS</poste>
        <poste code="0590320">TRESORERIE QUESNOY-SUR-DEULE</poste>
        <poste code="0560110">TRESORERIE DE QUESTEMBERT</poste>
        <poste code="0500460">TRESORERIE QUETTEHOU</poste>
        <poste code="0110320">TRESORERIE DE QUILLAN</poste>
        <poste code="0292110">TRESORERIE QUIMPER BANLIEUE</poste>
        <poste code="0292000">RECETTE DES FINANCES QUIMPER</poste>
        <poste code="0292120">TRESORERIE QUIMPER MUNICIPALE</poste>
        <poste code="0292160">TRESORERIE QUIMPER CENTRES HOSPITALIERS</poste>
        <poste code="0292130">TRESORERIE QUIMPERLE</poste>
        <poste code="0250180">TRESORERIE QUINGEY</poste>
        <poste code="0220180">TRESORERIE QUINTIN</poste>
        <poste code="0300210">TRESORERIE QUISSAC-SAUVE</poste>
        <poste code="0810140">TRESORERIE RABASTENS-SALVAGNAC</poste>
        <poste code="0650250">TRESORERIE RABASTENS-DE-BIGORRE</poste>
        <poste code="1180000">TRESORERIE AMBASSADE DE FRANCE AU MAROC</poste>
        <poste code="0595100">TRESORERIE RAISMES</poste>
        <poste code="0880340">TRESORERIE RAMBERVILLERS-XAFFEVILLERS</poste>
        <poste code="0780260">TRESORERIE RAMBOUILLET</poste>
        <poste code="0880570">TRESORERIE RAON-L'ETAPE</poste>
        <poste code="0330680">TRESORERIE RAUZAN</poste>
        <poste code="0810150">TRESORERIE REALMONT</poste>
        <poste code="0772160">TRESORERIE REBAIS-VILLENEUVE-SUR-BELLOT</poste>
        <poste code="0210320">TRESORERIE RECEY-SUR-OURCE</poste>
        <poste code="0350270">TRESORERIE REDON</poste>
        <poste code="0740200">TRESORERIE REIGNIER</poste>
        <poste code="0512080">TRESORERIE REIMS 1ERE DIVISION</poste>
        <poste code="0512090">TRESORERIE REIMS 2EME DIVISION</poste>
        <poste code="0512100">TRESORERIE REIMS BANLIEUE BOURGOGNE</poste>
        <poste code="0512110">TRESORERIE DE REIMS MUNICIPALE</poste>
        <poste code="0512120">TRESORERIE DE REIMS CHR</poste>
        <poste code="0512001">SERVICE CONTRLE REDEVANCE AUDIOVISUELLE DE REIMS</poste>
        <poste code="0512000">RECETTE DES FINANCES REIMS</poste>
        <poste code="0610240">TRESORERIE REMALARD</poste>
        <poste code="0570390">TRESORERIE REMILLY</poste>
        <poste code="0880350">TRESORERIE REMIREMONT</poste>
        <poste code="0300220">TRESORERIE REMOULINS</poste>
        <poste code="0260390">TRESORERIE REMUZAT-LA MOTTE CHALANCON</poste>
        <poste code="0422080">TRESORERIE DE RENAISON</poste>
        <poste code="0350000">TRESORERIE GENERALE D' ILLE-ET-VILAINE</poste>
        <poste code="0350007">CENTRE REGIONAL DES PENSIONS D' ILLE-ET-VILAINE</poste>
        <poste code="0350008">CENTRE DE FORMATION DEPARTEMENTAL D' ILLE-ET-VILAINE</poste>
        <poste code="0350009">DEPARTEMENT INFORMATIQUE ILLE-ET-VILAINE</poste>
        <poste code="0350290">TRESORERIE RENNES COLOMBIER</poste>
        <poste code="0350320">TRESORERIE RENNES CH GUILLAUME REGNIER</poste>
        <poste code="0350330">TRESORERIE RENNES CHU</poste>
        <poste code="0350800">PAIERIE REGIONALE DE BRETAGNE</poste>
        <poste code="0350900">PAIERIE DEPARTEMENTALE D' ILLE-ET-VILAINE</poste>
        <poste code="0350001">SERVICE CONTRLE REDEVANCE AUDIOVISUELLE DE L' ILLE ET VILAINE</poste>
        <poste code="0350004">CE CENTRE ENCAISSEMENT RENNES</poste>
        <poste code="0350006">PLE NATIONAL DE SOUTIEN AU RESEAU DE RENNES - FPTH</poste>
        <poste code="0350002">ANNEXE PLE INTERRGIONAL APUREMENT SPL</poste>
        <poste code="0350300">TRESORERIE ILLE-ET-VILAINE AMENDES</poste>
        <poste code="0350310">TRESORERIE RENNES MUNICIPALE</poste>
        <poste code="0350500">TRESORERIE DU CONTROLE AUTOMATISE</poste>
        <poste code="0350400">TRESORERIE CENTRE ENCAISSEMENT DES AMENDES</poste>
        <poste code="0080370">TRESORERIE RENWEZ</poste>
        <poste code="0120150">TRESORERIE DU SEGALA MERIDIONAL</poste>
        <poste code="0600530">TRESORERIE RESSONS-SUR-MATZ</poste>
        <poste code="0080380">TRESORERIE DE RETHEL</poste>
        <poste code="0350340">TRESORERIE RETIERS</poste>
        <poste code="0310210">TRESORERIE REVEL</poste>
        <poste code="0440260">TRESORERIE DE REZE</poste>
        <poste code="0670370">TRESORERIE RHINAU</poste>
        <poste code="0831150">TRESORERIE RIANS</poste>
        <poste code="0680150">TRESORERIE DE RIBEAUVILLE</poste>
        <poste code="0600540">TRESORERIE RIBECOURT-DRESLINCOURT</poste>
        <poste code="0020570">TRESORERIE RIBEMONT-ORIGNY</poste>
        <poste code="0240270">TRESORERIE DE RIBERAC</poste>
        <poste code="0370310">TRESORERIE RICHELIEU</poste>
        <poste code="0310600">TRESORERIE RIEUMES</poste>
        <poste code="0120370">TRESORERIE RIEUPEYROUX</poste>
        <poste code="0040190">TRESORERIE RIEZ-ET-MOUSTIERS</poste>
        <poste code="0120160">TRESORERIE DE RIGNAC</poste>
        <poste code="0690380">TRESORERIE DE RILLIEUX-LA-PAPE</poste>
        <poste code="0630450">TRESORERIE RIOM</poste>
        <poste code="0150210">TRESORERIE RIOM-ES-MONTAGNES</poste>
        <poste code="0700360">TRESORERIE RIOZ-VORAY-SUR-L'OGNON</poste>
        <poste code="0910290">TRESORERIE RIS-ORANGIS</poste>
        <poste code="0320290">TRESORERIE RISCLE</poste>
        <poste code="0420090">TRESORERIE RIVE-DE-GIER</poste>
        <poste code="0380330">TRESORERIE RIVES</poste>
        <poste code="0660190">TRESORERIE DE RIVESALTES</poste>
        <poste code="0422090">TRESORERIE ROANNE</poste>
        <poste code="0422000">RECETTE DES FINANCES ROANNE</poste>
        <poste code="0422100">TRESORERIE ROANNE MUNICIPALE</poste>
        <poste code="0870240">TRESORERIE DE ROCHECHOUART</poste>
        <poste code="0170190">TRESORERIE DE ROCHEFORT ET BANLIEUE</poste>
        <poste code="0170200">TRESORERIE DE ROCHEFORT ET BANLIEUE MUNICIPALE</poste>
        <poste code="0630230">TRESORERIE ROCHEFORT-MONTAGNE</poste>
        <poste code="0080400">TRESORERIE ROCROI-MAUBERT</poste>
        <poste code="0120000">TRESORERIE GENERALE DE L' AVEYRON</poste>
        <poste code="0120170">TRESORERIE RODEZ</poste>
        <poste code="0120900">PAIERIE DEPARTEMENTALE DE L' AVEYRON</poste>
        <poste code="0120190">TRESORERIE RODEZ HOPITAL</poste>
        <poste code="0671150">TRESORERIE ROESCHWOOG</poste>
        <poste code="0560140">TRESORERIE ROHAN</poste>
        <poste code="0571120">TRESORERIE ROHRBACH-LES-BITCHE</poste>
        <poste code="0800570">TRESORERIE ROISEL</poste>
        <poste code="0520390">TRESORERIE DE ROLAMPONT</poste>
        <poste code="0930220">TRESORERIE DE ROMAINVILLE MUNICIPALE</poste>
        <poste code="0260190">TRESORERIE DE ROMANS-BOURG-DE-PEAGE</poste>
        <poste code="0260200">TRESORERIE DE ROMANS-BOURG DE PEAGE COL. LOC.</poste>
        <poste code="0570420">TRESORERIE ROMBAS</poste>
        <poste code="1870000">TRESORERIE AMBASSADE DE FRANCE EN ITALIE</poste>
        <poste code="0100320">TRESORERIE DE ROMILLY-SUR-SEINE</poste>
        <poste code="0410170">TRESORERIE ROMORANTIN-LANTHENAY</poste>
        <poste code="0590330">TRESORERIE DE RONCHIN</poste>
        <poste code="0060180">TRESORERIE ROQUEBILLIERE</poste>
        <poste code="0810310">TRESORERIE DE ROQUECOURBE</poste>
        <poste code="0400140">TRESORERIE ROQUEFORT</poste>
        <poste code="0300230">TRESORERIE ROQUEMAURE</poste>
        <poste code="0060190">TRESORERIE ROQUESTERON</poste>
        <poste code="0130200">TRESORERIE ROQUEVAIRE</poste>
        <poste code="0800420">TRESORERIE ROSIERES-EN-SANTERRE</poste>
        <poste code="0292140">TRESORERIE DE ROSPORDEN</poste>
        <poste code="0220410">TRESORERIE ROSTRENEN</poste>
        <poste code="0590350">TRESORERIE DE ROUBAIX</poste>
        <poste code="0590380">TRESORERIE ROUBAIX MUNICIPALE</poste>
        <poste code="0590390">TRESORERIE ROUBAIX CENTRE HOSPITALIER</poste>
        <poste code="0760000">TRESORERIE GENERALE DE LA SEINE-MARITIME</poste>
        <poste code="0760007">CENTRE REGIONAL DES PENSIONS DE LA SEINE-MARITIME</poste>
        <poste code="0760008">CENTRE DE FORMATION DEPARTEMENTAL DE LA SEINE-MARITIME</poste>
        <poste code="0760009">DEPARTEMENT INFORMATIQUE DE LA SEINE-MARITIME</poste>
        <poste code="0760370">TRESORERIE ROUEN MUNICIPALE</poste>
        <poste code="0760380">TRESORERIE ROUEN CHU</poste>
        <poste code="0760510">TRESORERIE SEINE-MARITIME AMENDES</poste>
        <poste code="0760800">PAIERIE REGIONALE DE HAUTE-NORMANDIE</poste>
        <poste code="0760900">PAIERIE DEPARTEMENTALE DE LA SEINE-MARITIME</poste>
        <poste code="0760110">TRESORERIE DARNETAL</poste>
        <poste code="0760350">TRESORERIE DE ROUEN IMPTS</poste>
        <poste code="0760001">SERVICE CONTRLE REDEVANCE AUDIOVISUELLE DE LA SEINE MARITIME</poste>
        <poste code="0760006">PLE NATIONAL DE SOUTIEN AU RESEAU DE ROUEN - RECOUVREMENT AMIABLE</poste>
        <poste code="0680180">TRESORERIE ROUFFACH</poste>
        <poste code="0680190">TRESORERIE ROUFFACH CH</poste>
        <poste code="0250210">TRESORERIE DE ROUGEMONT</poste>
        <poste code="0160360">TRESORERIE ROUILLAC</poste>
        <poste code="0381070">TRESORERIE DU ROUSSILLONNAIS</poste>
        <poste code="0620310">TRESORERIE ROUVROY</poste>
        <poste code="0170380">TRESORERIE ROYAN</poste>
        <poste code="0380340">TRESORERIE ROYBON</poste>
        <poste code="0800430">TRESORERIE ROYE</poste>
        <poste code="0230150">TRESORERIE DE ROYERE-DE-VASSIVIERE</poste>
        <poste code="0770230">TRESORERIE ROZAY</poste>
        <poste code="0020240">TRESORERIE ROZOY-SUR-SERRE-MONTCORNET</poste>
        <poste code="0800650">TRESORERIE RUE</poste>
        <poste code="0920310">TRESORERIE RUEIL-MALMAISON</poste>
        <poste code="0920320">TRESORERIE RUEIL-MALMAISON MUNICIPALE</poste>
        <poste code="0160370">TRESORERIE RUELLE-SUR-TOUVRE</poste>
        <poste code="0160380">TRESORERIE RUFFEC-NANTEUIL-EN-VALLEE</poste>
        <poste code="0270120">TRESORERIE RUGLES</poste>
        <poste code="0740220">TRESORERIE DE RUMILLY-ALBY</poste>
        <poste code="0720450">TRESORERIE SABLE-SUR-SARTHE-PRECIGNE</poste>
        <poste code="0400150">TRESORERIE SABRES</poste>
        <poste code="0150230">TRESORERIE SAIGNES</poste>
        <poste code="0660200">TRESORERIE SAILLAGOUSE</poste>
        <poste code="0595280">TRESORERIE SAINS-DU-NORD</poste>
        <poste code="0530300">TRESORERIE DE SAINT-AIGNAN-SUR-ROE</poste>
        <poste code="1040020">TRESORERIE SAINT-ANDRE</poste>
        <poste code="1040030">TRESORERIE SAINT-BENOIT</poste>
        <poste code="0480190">TRESORERIE SAINT-CHELY-D'APCHER</poste>
        <poste code="1040007">CENTRE REGIONAL DES PENSIONS DE LA REUNION</poste>
        <poste code="1040009">DEPARTEMENT INFORMATIQUE DE LA REUNION</poste>
        <poste code="1040040">TRESORERIE SAINT-DENIS</poste>
        <poste code="1040130">TRESORERIE SAINT-DENIS MUNICIPALE</poste>
        <poste code="1040900">PAIERIE DEPARTEMENTALE DE LA REUNION</poste>
        <poste code="1040050">TRESORERIE SAINT-JOSEPH</poste>
        <poste code="1040090">TRESORERIE SAINT-PIERRE</poste>
        <poste code="1050000">TRESORERIE GENERALE SAINT-PIERRE-ET-MIQUELON</poste>
        <poste code="0831190">TRESORERIE SAINT-TROPEZ</poste>
        <poste code="1040800">PAIERIE REGIONALE DE LA REUNION</poste>
        <poste code="0170360">TRESORERIE DE SAINTES ET BANLIEUE</poste>
        <poste code="0170370">TRESORERIE DE SAINTES ET BANLIEUE MUNICIPALE</poste>
        <poste code="0931000">RECETTE DES FINANCES SAINT-DENIS</poste>
        <poste code="0410210">TRESORERIE SALBRIS</poste>
        <poste code="0831200">TRESORERIE SALERNES</poste>
        <poste code="0640300">TRESORERIE SALIES-DE-BEARN</poste>
        <poste code="0310540">TRESORERIE SALIES-DU-SALAT-ST-MARTORY</poste>
        <poste code="0390220">TRESORERIE SALINS-LES-BAINS</poste>
        <poste code="0740260">TRESORERIE SALLANCHES</poste>
        <poste code="0110370">TRESORERIE SALLES-SUR-L'HERS</poste>
        <poste code="0131140">TRESORERIE SALON-DE-PROVENCE</poste>
        <poste code="0740270">TRESORERIE SAMOENS</poste>
        <poste code="0180320">TRESORERIE DE SANCERGUES</poste>
        <poste code="0180330">TRESORERIE DE SANCERRE</poste>
        <poste code="0180340">TRESORERIE SANCOINS</poste>
        <poste code="0950310">TRESORERIE SANNOIS</poste>
        <poste code="02A0090">TRESORERIE SANTA-MARIA-SICHE</poste>
        <poste code="0320330">TRESORERIE SARAMON</poste>
        <poste code="0951080">TRESORERIE SARCELLES</poste>
        <poste code="0951000">RECETTE DES FINANCES SARCELLES</poste>
        <poste code="0240350">TRESORERIE SARLAT-LA-CANEDA</poste>
        <poste code="0571140">TRESORERIE SARRALBE</poste>
        <poste code="0671160">TRESORERIE SARRE-UNION</poste>
        <poste code="0570450">TRESORERIE DE SARREBOURG</poste>
        <poste code="0571170">TRESORERIE SARREGUEMINES MUNICIPALE</poste>
        <poste code="0571000">RECETTE DES FINANCES SARREGUEMINES</poste>
        <poste code="0571160">TRESORERIE DE SARREGUEMINES CENTRE ET CAMPAGNE</poste>
        <poste code="02A0110">TRESORERIE DE SARTENE-OLMETO</poste>
        <poste code="0781150">TRESORERIE DE SARTROUVILLE COLLECTIV. LOCALES</poste>
        <poste code="0560150">TRESORERIE SARZEAU</poste>
        <poste code="0070290">TRESORERIE DE SATILLIEU</poste>
        <poste code="0430280">TRESORERIE SAUGUES</poste>
        <poste code="0170410">TRESORERIE SAUJON</poste>
        <poste code="0210370">TRESORERIE SAULIEU</poste>
        <poste code="0490390">TRESORERIE SAUMUR MUNICIPALE</poste>
        <poste code="0490410">TRESORERIE DE SAUMUR</poste>
        <poste code="0240550">TRESORERIE SIGOULES ET SAUSSIGNAC</poste>
        <poste code="0640310">TRESORERIE SAUVETERRE-DE-BEARN</poste>
        <poste code="0330760">TRESORERIE SAUVETERRE-DE-GUYENNE-PELLEGRUE</poste>
        <poste code="0630580">TRESORERIE SAUXILLANGES</poste>
        <poste code="0790380">TRESORERIE SAUZE-VAUSSAIS</poste>
        <poste code="0260340">TRESORERIE MARSANNE-SAUZET</poste>
        <poste code="0441150">TRESORERIE SAVENAY</poste>
        <poste code="0090270">TRESORERIE SAVERDUN-MAZERES</poste>
        <poste code="0671170">TRESORERIE DE SAVERNE</poste>
        <poste code="0240360">TRESORERIE DE SAVIGNAC-LES-EGLISES</poste>
        <poste code="0911140">TRESORERIE SAVIGNY-SUR-ORGE</poste>
        <poste code="0921110">TRESORERIE DE SCEAUX</poste>
        <poste code="0921140">TRESORERIE DE SCEAUX MUNICIPALE</poste>
        <poste code="0700390">TRESORERIE SCEY-SUR-SAONE-ET-SAINT-ALBIN</poste>
        <poste code="0670450">TRESORERIE STRASBOURG NORD-SCHILTIGHEIM</poste>
        <poste code="0670440">TRESORERIE SCHILTIGHEIM</poste>
        <poste code="0670005">CPS CENTRE PRLVEMENT SERVICE</poste>
        <poste code="0670460">TRESORERIE SCHIRMECK</poste>
        <poste code="0590420">TRESORERIE SECLIN</poste>
        <poste code="0790390">TRESORERIE SECONDIGNY</poste>
        <poste code="0080450">TRESORERIE DE SEDAN</poste>
        <poste code="0080440">TRESORERIE DE SEDAN MIRBRITZ</poste>
        <poste code="0260410">TRESORERIE SEDERON</poste>
        <poste code="0610260">TRESORERIE DE SEES</poste>
        <poste code="0160430">TRESORERIE SEGONZAC</poste>
        <poste code="0490260">TRESORERIE SEGRE</poste>
        <poste code="0490270">TRESORERIE SEICHES-SUR-LE-LOIR</poste>
        <poste code="0190160">TRESORERIE SEILHAC</poste>
        <poste code="0670470">TRESORERIE DE SELESTAT</poste>
        <poste code="0410220">TRESORERIE SELLES-SUR-CHER</poste>
        <poste code="0390240">TRESORERIE SELLIERES</poste>
        <poste code="0410330">TRESORERIE SELOMMES</poste>
        <poste code="0210410">TRESORERIE SELONGEY</poste>
        <poste code="0671180">TRESORERIE SELTZ</poste>
        <poste code="0210420">TRESORERIE SEMUR-EN-AUXOIS</poste>
        <poste code="0600430">TRESORERIE DE SENLIS</poste>
        <poste code="0710550">TRESORERIE DE SENNECEY-SAINT-GERMAIN-DU-PLAIN</poste>
        <poste code="0280390">TRESORERIE SENONCHES</poste>
        <poste code="0880600">TRESORERIE SENONES</poste>
        <poste code="0890510">TRESORERIE SENS AGGLOMERATION SENONAISE</poste>
        <poste code="0890520">TRESORERIE SENS MUNICIPALE</poste>
        <poste code="0681220">TRESORERIE SEPPOIS-LE-BAS</poste>
        <poste code="0890530">TRESORERIE SERGINES</poste>
        <poste code="0600280">TRESORERIE SERIFONTAINE</poste>
        <poste code="0340450">TRESORERIE SERIGNAN</poste>
        <poste code="0510180">TRESORERIE SERMAIZE-LES-BAINS</poste>
        <poste code="0050200">TRESORERIE DE SERRES-ASPRES</poste>
        <poste code="0070300">TRESORERIE SERRIERES</poste>
        <poste code="0340290">TRESORERIE SETE</poste>
        <poste code="0340300">TRESORERIE SETE MUNICIPALE</poste>
        <poste code="0210590">TRESORERIE SEURRE</poste>
        <poste code="0120430">TRESORERIE DE SEVERAC-LE-CHATEAU</poste>
        <poste code="0930290">TRESORERIE DE SEVRAN MUNICIPALE</poste>
        <poste code="0921120">TRESORERIE DE SEVRES</poste>
        <poste code="0040230">TRESORERIE SEYNE</poste>
        <poste code="0740060">TRESORERIE SEYNOD</poste>
        <poste code="0740280">TRESORERIE SEYSSEL</poste>
        <poste code="0510410">TRESORERIE DE SEZANNE</poste>
        <poste code="0570500">TRESORERIE SIERCK-LES-BAINS</poste>
        <poste code="0681230">TRESORERIE SIERENTZ</poste>
        <poste code="0110510">TRESORERIE SIGEAN</poste>
        <poste code="0080470">TRESORERIE SIGNY-L'ABBAYE-RUMIGNY</poste>
        <poste code="0720490">TRESORERIE DE SILLE-LE-GUILLAUME</poste>
        <poste code="0593090">TRESORERIE SIN-LE-NOBLE</poste>
        <poste code="0020270">TRESORERIE SISSONNE</poste>
        <poste code="0040240">TRESORERIE DE SISTERON-ST-VINCENT-SUR-JABRON</poste>
        <poste code="0830240">TRESORERIE SIX-FOURS-LES-PLAGES</poste>
        <poste code="0250470">TRESORERIE SOCHAUX</poste>
        <poste code="0020480">TRESORERIE SOISSONS</poste>
        <poste code="0593200">TRESORERIE SOLESMES</poste>
        <poste code="0830160">TRESORERIE SOLLIES-PONT</poste>
        <poste code="0595290">TRESORERIE SOLRE-LE-CHATEAU</poste>
        <poste code="0593100">TRESORERIE SOMAIN</poste>
        <poste code="0210430">TRESORERIE SOMBERNON</poste>
        <poste code="0300310">TRESORERIE SOMMIERES</poste>
        <poste code="0840160">TRESORERIE SORGUES</poste>
        <poste code="0190170">TRESORERIE SORNAC</poste>
        <poste code="0060220">TRESORERIE DE SOSPEL</poste>
        <poste code="0760440">TRESORERIE SOTTEVILLE-LES-ROUEN</poste>
        <poste code="0460290">TRESORERIE DE SOUILLAC</poste>
        <poste code="0550410">TRESORERIE DE SOUILLY</poste>
        <poste code="0330520">TRESORERIE SAINT-VIVIEN-DE-MEDOC</poste>
        <poste code="0680220">TRESORERIE SOULTZ-HAUT-RHIN</poste>
        <poste code="0671190">TRESORERIE SOULTZ-SOUS-FORETS</poste>
        <poste code="0400300">TRESORERIE SOUSTONS</poste>
        <poste code="0550420">TRESORERIE SPINCOURT</poste>
        <poste code="0120380">TRESORERIE SAINT-AFFRIQUE</poste>
        <poste code="0070210">TRESORERIE SAINT-AGREVE</poste>
        <poste code="0410190">TRESORERIE SAINT-AIGNAN</poste>
        <poste code="0170340">TRESORERIE SAINT-AIGULIN</poste>
        <poste code="0480170">TRESORERIE SAINT-ALBAN-SUR-LIMAGNOLE</poste>
        <poste code="0595120">TRESORERIE SAINT-AMAND-LES-EAUX</poste>
        <poste code="0410320">TRESORERIE SAINT-AMAND-LONGPRE</poste>
        <poste code="0180280">TRESORERIE DE SAINT-AMAND-MONTROND</poste>
        <poste code="0810320">TRESORERIE SAINT-AMANS-SOULT</poste>
        <poste code="0160390">TRESORERIE SAINT-AMANT-DE-BOIXE</poste>
        <poste code="0630240">TRESORERIE SAINT-AMANT-TALLENDE</poste>
        <poste code="0680280">TRESORERIE SAINT-AMARIN</poste>
        <poste code="0300500">TRESORERIE DE SAINT-AMBROIX</poste>
        <poste code="0880390">TRESORERIE DE SAINT-AME</poste>
        <poste code="0132100">TRESORERIE SAINT-ANDIOL</poste>
        <poste code="0590400">TRESORERIE SAINT-ANDRE</poste>
        <poste code="0330740">TRESORERIE SAINT-ANDRE-DE-CUBZAC</poste>
        <poste code="0270130">TRESORERIE SAINT-ANDRE-DE-L'EURE</poste>
        <poste code="0040200">TRESORERIE SAINT-ANDRE-LES-ALPES</poste>
        <poste code="0820200">TRESORERIE SAINT-ANTONIN-NOBLE-VAL</poste>
        <poste code="0780270">TRESORERIE SAINT-ARNOULT-EN-YVELINES</poste>
        <poste code="0240210">TRESORERIE DE NEUVIC</poste>
        <poste code="0240290">TRESORERIE SAINT-ASTIER</poste>
        <poste code="0350350">TRESORERIE SAINT-AUBIN-D'AUBIGNE</poste>
        <poste code="0760390">TRESORERIE SAINT-AUBIN-LES-ELBEUF</poste>
        <poste code="0240300">TRESORERIE SAINT-AULAYE-LA-ROCHE-CHALAIS</poste>
        <poste code="0571130">TRESORERIE SAINT-AVOLD</poste>
        <poste code="1010120">TRESORERIE DE SAINT-BARTHELEMY</poste>
        <poste code="0310520">TRESORERIE SAINT-BEAT-CIERP</poste>
        <poste code="0580260">TRESORERIE SAINT-BENIN-D'AZY</poste>
        <poste code="0520240">TRESORERIE DE SAINT-BLIN-SEMILLY</poste>
        <poste code="0050150">TRESORERIE DE SAINT-BONNET-SAINT-FIRMIN</poste>
        <poste code="0420260">TRESORERIE SAINT-BONNET-LE-CHATEAU</poste>
        <poste code="0441180">TRESORERIE MINDIN ETS MEDICO-SOCIAUX</poste>
        <poste code="0220000">TRESORERIE GENERALE DES COTES-D'ARMOR</poste>
        <poste code="0220100">TRESORERIE SAINT-BRIEUC CENTRE HOSPITALIER</poste>
        <poste code="0220190">TRESORERIE DE SAINT-BRIEUC LA BAIE</poste>
        <poste code="0220200">TRESORERIE DE SAINT-BRIEUC BANLIEUE</poste>
        <poste code="0220210">TRESORERIE SAINT-BRIEUC MUNICIPALE</poste>
        <poste code="0220900">PAIERIE DEPARTEMENTALE DES COTES-D'ARMOR</poste>
        <poste code="0220001">SERVICE CONTRLE REDEVANCE AUDIOVISUELLE DES CTES D'ARMOR</poste>
        <poste code="0720460">TRESORERIE SAINT-CALAIS BESSE</poste>
        <poste code="0460240">TRESORERIE SAINT-CERE</poste>
        <poste code="0420100">TRESORERIE SAINT-CHAMOND</poste>
        <poste code="0300250">TRESORERIE SAINT-CHAPTES</poste>
        <poste code="0320300">TRESORERIE DE SAINT-CLAR-MIRADOUX</poste>
        <poste code="0160410">TRESORERIE SAINT-CLAUD</poste>
        <poste code="0390410">TRESORERIE SAINT-CLAUDE MUN. ET BAN</poste>
        <poste code="0920330">TRESORERIE SAINT-CLOUD</poste>
        <poste code="0830040">TRESORERIE SAINT-CYR-SUR-MER</poste>
        <poste code="1040990">SERVICE COMPTABLE DE LA COLLECTIVIT DES TERRES AUSTRALES ANTARCTIQUES FR</poste>
        <poste code="0931060">TRESORERIE SAINT-DENIS</poste>
        <poste code="0931070">TRESORERIE SAINT-DENIS MUNICIPALE</poste>
        <poste code="0931080">TRESORERIE SAINT-DENIS CENTRE HOSPITALIER</poste>
        <poste code="1040120">TRESORERIE SAINT-DENIS CTRE HOSP. DPT</poste>
        <poste code="1040000">TRESORERIE GENERALE DE LA REUNION</poste>
        <poste code="0430240">TRESORERIE SAINT-DIDIER-EN-VELAY</poste>
        <poste code="0880580">TRESORERIE DE SAINT-DIE CARNOT</poste>
        <poste code="0880590">TRESORERIE SAINT-DIE MUNICIPALE</poste>
        <poste code="0520280">TRESORERIE SAINT-DIZIER ETS HOSP. ET OPHLM</poste>
        <poste code="0520250">TRESORERIE SAINT-DIZIER</poste>
        <poste code="0260220">TRESORERIE SAINT-DONAT-SUR-L'HERBASSE</poste>
        <poste code="0380350">TRESORERIE SAINT-EGREVE</poste>
        <poste code="1030080">TRESORERIE SAINT-ESPRIT</poste>
        <poste code="0660280">TRESORERIE SAINT-ESTEVE</poste>
        <poste code="0420120">TRESORERIE SAINT-ETIENNE NORD</poste>
        <poste code="0420130">TRESORERIE SAINT-ETIENNE SUD EST</poste>
        <poste code="0420140">TRESORERIE SAINT-ETIENNE SUD OUEST</poste>
        <poste code="0420150">TRESORERIE SAINT-ETIENNE BANLIEUE</poste>
        <poste code="0420900">PAIERIE DEPARTEMENTALE DE LA LOIRE</poste>
        <poste code="0420000">TRESORERIE GENERALE DE LA LOIRE</poste>
        <poste code="0420160">TRESORERIE SAINT-ETIENNE MUNICIPALE</poste>
        <poste code="0420170">TRESORERIE SAINT-ETIENNE CHU</poste>
        <poste code="0640420">TRESORERIE SAINT-ETIENNE-DE-BAIGORRY</poste>
        <poste code="0440370">TRESORERIE SAINT-ETIENNE-DE-MONTLUC</poste>
        <poste code="0380360">TRESORERIE SAINT-ETIENNE-DE-SAINT-GEOIRS</poste>
        <poste code="0060200">TRESORERIE SAINT-ETIENNE-DE-TINEE</poste>
        <poste code="0770030">TRESORERIE SAINT FARGEAU PONTHIERRY</poste>
        <poste code="0070230">TRESORERIE DE SAINT-FELICIEN</poste>
        <poste code="02B0200">TRESORERIE SAINT-FLORENT</poste>
        <poste code="0490490">TRESORERIE SAINT-FLORENT-LE-VIEIL</poste>
        <poste code="0180290">TRESORERIE DE SAINT-FLORENT-SUR-CHER</poste>
        <poste code="0890370">TRESORERIE DE SAINT-FLORENTIN</poste>
        <poste code="0150250">TRESORERIE SAINT-FLOUR</poste>
        <poste code="0850150">TRESORERIE SAINT-FULGENT</poste>
        <poste code="0420270">TRESORERIE SAINT-GALMIER</poste>
        <poste code="0310530">TRESORERIE SAINT-GAUDENS</poste>
        <poste code="0420190">TRESORERIE DE SAINT-GENEST-MALIFAUX</poste>
        <poste code="0120220">TRESORERIE DES DEUX VALLEES</poste>
        <poste code="0170350">TRESORERIE SAINT-GENIS-DE-SAINTONGE-ST-FORT</poste>
        <poste code="0690280">TRESORERIE SAINT-GENIS-LAVAL</poste>
        <poste code="0381220">TRESORERIE SAINT-GEOIRE-EN-VALDAINE</poste>
        <poste code="0860190">TRESORERIE SAINT-GEORGES-LES-BAILLARGEAUX</poste>
        <poste code="0490240">TRESORERIE SAINT-GEORGES-SUR-LOIRE</poste>
        <poste code="0030330">TRESORERIE SAINT-GERMAIN-DES-FOSSES</poste>
        <poste code="0710530">TRESORERIE SAINT-GERMAIN-DU-BOIS-MERVANS</poste>
        <poste code="0780280">TRESORERIE SAINT-GERMAIN-EN-LAYE</poste>
        <poste code="0780110">TRESORERIE SAINT-GERMAIN-POISSY CH</poste>
        <poste code="0422110">TRESORERIE SAINT-GERMAIN-LAVAL</poste>
        <poste code="0630270">TRESORERIE SAINT-GERMAIN-LEMBRON</poste>
        <poste code="0630460">TRESORERIE DE SAINT-GERVAIS-D'AUVERGNE</poste>
        <poste code="0740230">TRESORERIE SAINT-GERVAIS-LES-BAINS</poste>
        <poste code="0460260">TRESORERIE DE SAINT-GERY</poste>
        <poste code="0300270">TRESORERIE SAINT-GILLES</poste>
        <poste code="0850370">TRESORERIE SAINT-GILLES-CROIX-DE-VIE</poste>
        <poste code="0090160">TRESORERIE SAINT-GIRONS</poste>
        <poste code="0440170">TRESORERIE SAINT-HERBLAIN</poste>
        <poste code="0110340">TRESORERIE SAINT-HILAIRE</poste>
        <poste code="0500320">TRESORERIE SAINT-HILAIRE - ISIGNY</poste>
        <poste code="0250450">TRESORERIE SAINT-HIPPOLYTE</poste>
        <poste code="0300280">TRESORERIE SAINT-HIPPOLYTE-DU-FORT</poste>
        <poste code="0500330">TRESORERIE SAINT-JAMES</poste>
        <poste code="0170120">TRESORERIE SAINT-JEAN-D'ANGELY</poste>
        <poste code="0740070">TRESORERIE LE BIOT</poste>
        <poste code="0381090">TRESORERIE SAINT-JEAN-DE-BOURNAY</poste>
        <poste code="0450250">TRESORERIE ST-JEAN-DE-BRAYE</poste>
        <poste code="0500170">TRESORERIE SAINT-JEAN-DE-DAYE</poste>
        <poste code="0210580">TRESORERIE SAINT-JEAN-DE-LOSNE</poste>
        <poste code="0640430">TRESORERIE SAINT-JEAN-DE-LUZ</poste>
        <poste code="0730320">TRESORERIE SAINT-JEAN-DE-MAURIENNE</poste>
        <poste code="0850380">TRESORERIE SAINT-JEAN-DE-MONTS</poste>
        <poste code="0860360">TRESORERIE SAINT-JEAN-DE-SAUVES</poste>
        <poste code="0300510">TRESORERIE SAINT-JEAN-DU-GARD-ST ANDRE</poste>
        <poste code="0260230">TRESORERIE SAINT-JEAN-EN-ROYANS</poste>
        <poste code="0640440">TRESORERIE SAINT-JEAN-PIED-DE-PORT</poste>
        <poste code="0420290">TRESORERIE SAINT-JEAN-SOLEYMIEUX</poste>
        <poste code="0050180">TRESORERIE SAINT-JEAN-SAINT-NICOLAS</poste>
        <poste code="0740240">TRESORERIE SAINT-JEOIRE</poste>
        <poste code="0430250">TRESORERIE SAINT-JULIEN-CHAPTEUIL</poste>
        <poste code="0740250">TRESORERIE SAINT-JULIEN-EN-GENEVOIS</poste>
        <poste code="0860200">TRESORERIE SAINT-JULIEN-L'ARS</poste>
        <poste code="0870260">TRESORERIE SAINT-JUNIEN</poste>
        <poste code="0600550">TRESORERIE SAINT-JUST-EN-CHAUSSEE</poste>
        <poste code="0420300">TRESORERIE SAINT-JUST-SAINT-RAMBERT</poste>
        <poste code="0690290">TRESORERIE SAINT-LAURENT-DE-CHAMOUSSET</poste>
        <poste code="0660210">TRESORERIE SAINT-LAURENT-DE-LA-SALANQUE</poste>
        <poste code="0650260">TRESORERIE SAINT-LAURENT-DE-NESTE</poste>
        <poste code="1020030">TRESORERIE SAINT-LAURENT-DU-MARONI</poste>
        <poste code="0380390">TRESORERIE SAINT-LAURENT-DU-PONT</poste>
        <poste code="0061170">TRESORERIE SAINT-LAURENT DU VAR</poste>
        <poste code="0010310">TRESORERIE SAINT-LAURENT-SUR-SAONE</poste>
        <poste code="0870280">TRESORERIE SAINT-LEONARD-DE-NOBLAT</poste>
        <poste code="1040060">TRESORERIE SAINT-LEU</poste>
        <poste code="0600410">TRESORERIE SAINT-LEU-D'ESSERENT</poste>
        <poste code="0500000">TRESORERIE GENERALE DE LA MANCHE</poste>
        <poste code="0500180">TRESORERIE SAINT-LO-CANISY</poste>
        <poste code="0500900">PAIERIE DEPARTEMENTALE DE LA MANCHE</poste>
        <poste code="0330480">TRESORERIE SAINT-LOUBES</poste>
        <poste code="0681200">TRESORERIE SAINT-LOUIS</poste>
        <poste code="1040070">TRESORERIE SAINT-LOUIS</poste>
        <poste code="0700370">TRESORERIE SAINT-LOUP-CONFLANS</poste>
        <poste code="0310620">TRESORERIE SAINT-LYS</poste>
        <poste code="0790360">TRESORERIE SAINT-MAIXENT L'ECOLE</poste>
        <poste code="0350490">TRESORERIE SAINT MALO</poste>
        <poste code="0350470">TRESORERIE DE SAINT-MALO MUNICIPALE</poste>
        <poste code="0150260">TRESORERIE SAINT-MAMET-LA-SALVETAT</poste>
        <poste code="0380400">TRESORERIE SAINT-MARCELLIN</poste>
        <poste code="1010140">TRESORERIE DE SAINT-MARTIN</poste>
        <poste code="0180300">TRESORERIE SAINT-MARTIN-D'AUXIGNY</poste>
        <poste code="0380560">TRESORERIE SAINT-MARTIN-D'HERES</poste>
        <poste code="0170130">TRESORERIE SAINT-MARTIN-DE-RE</poste>
        <poste code="0400280">TRESORERIE SAINT-MARTIN-DE-SEIGNANX</poste>
        <poste code="0150270">TRESORERIE SAINT-MARTIN-VALMEROUX</poste>
        <poste code="0490250">TRESORERIE SAINT-MATHURIN-SUR-LOIRE</poste>
        <poste code="0941080">TRESORERIE SAINT-MAUR-DES-FOSSES</poste>
        <poste code="0941090">TRESORERIE SAINT-MAUR-DES-FOSSES MUNICIPALE</poste>
        <poste code="0940340">TRESORERIE SAINT-MAURICE ETS HOSPITALIERS</poste>
        <poste code="9940000">RECETTE DES FINANCES COMPTABLE SPCIALIS DU DOMAINE</poste>
        <poste code="9930000">DIRECTION NATIONALE DES INTERVENTIONS DOMANIALES</poste>
        <poste code="0830130">TRESORERIE SAINT-MAXIMIN-LA-SAINTE-BAUME</poste>
        <poste code="0330620">TRESORERIE SAINT-MEDARD-EN-JALLES</poste>
        <poste code="0350380">TRESORERIE SAINT-MEEN-LE-GRAND</poste>
        <poste code="0160040">TRESORERIE ANGOULEME CENTRE HOSPITALIER</poste>
        <poste code="0730330">TRESORERIE SAINT-MICHEL-DE-MAURIENNE</poste>
        <poste code="0550230">TRESORERIE DE SAINT-MIHIEL</poste>
        <poste code="0441130">TRESORERIE SAINT-NAZAIRE MUNICIPALE</poste>
        <poste code="0441160">TRESORERIE SAINT-NAZAIRE ETAB.HOSPITALIERS</poste>
        <poste code="0441000">RECETTE DES FINANCES SAINT-NAZAIRE</poste>
        <poste code="0441110">TRESORERIE DE SAINT-NAZAIRE</poste>
        <poste code="0820210">TRESORERIE SAINT-NICOLAS-DE-LA-GRAVE</poste>
        <poste code="0540230">TRESORERIE SAINT-NICOLAS-DE-PORT</poste>
        <poste code="0220420">TRESORERIE SAINT-NICOLAS-DU-PELEM</poste>
        <poste code="0622320">TRESORERIE DE SAINT-OMER</poste>
        <poste code="0931090">TRESORERIE SAINT-OUEN</poste>
        <poste code="0931100">TRESORERIE SAINT-OUEN MUNICIPALE</poste>
        <poste code="0950220">TRESORERIE SAINT-OUEN-L'AUMONE</poste>
        <poste code="0640450">TRESORERIE SAINT-PALAIS</poste>
        <poste code="0720080">TRESORERIE SAINT-PATERNE</poste>
        <poste code="1040150">TRESORERIE SAINT PAUL MUNICIPALE HOPITAUX</poste>
        <poste code="0810330">TRESORERIE SAINT-PAUL-CAP-DE-JOUX</poste>
        <poste code="1040080">TRESORERIE SAINT-PAUL</poste>
        <poste code="0660220">TRESORERIE SAINT-PAUL-DE-FENOUILLET</poste>
        <poste code="0400220">TRESORERIE DE SAINT-PAUL-LES-DAX</poste>
        <poste code="0260400">TRESORERIE SAINT-PAUL-TROIS-CHATEAUX-SUZE</poste>
        <poste code="0430270">TRESORERIE SAINT-PAULIEN</poste>
        <poste code="0070270">TRESORERIE SAINT-PERAY</poste>
        <poste code="0440300">TRESORERIE DE SAINT-PHILBERT-DE-GRAND-LIEU</poste>
        <poste code="1030090">TRESORERIE SAINT-PIERRE</poste>
        <poste code="1040140">TRESORERIE SAINT-PIERRE GHSR</poste>
        <poste code="0730340">TRESORERIE SAINT-PIERRE-D'ALBIGNY</poste>
        <poste code="0170220">TRESORERIE SAINT-PIERRE-D'OLERON</poste>
        <poste code="0240330">TRESORERIE DE SAINT-PIERRE-DE-CHIGNAC</poste>
        <poste code="0370400">TRESORERIE DE TOURS BANLIEUE SUD</poste>
        <poste code="0500480">TRESORERIE SAINT-PIERRE-EGLISE</poste>
        <poste code="0580270">TRESORERIE SAINT-PIERRE-LE-MOUTIER</poste>
        <poste code="0140580">TRESORERIE DE SAINT-PIERRE-SUR-DIVES</poste>
        <poste code="0070280">TRESORERIE SAINT-PIERREVILLE</poste>
        <poste code="0290300">TRESORERIE SAINT-POL-DE-LEON</poste>
        <poste code="0594120">TRESORERIE SAINT-POL-SUR-MER</poste>
        <poste code="0620430">TRESORERIE DE SAINT-POL-MONCHEAUX</poste>
        <poste code="0340430">TRESORERIE DE SAINT-PONS-DE-THOMIERES</poste>
        <poste code="0170400">TRESORERIE ST-PORCHAIRE-PT-L'ABBE-D'ARNOULT</poste>
        <poste code="0030110">TRESORERIE SAINT-POURCAIN-SUR-SIOULE</poste>
        <poste code="0690390">TRESORERIE DE SAINT-PRIEST</poste>
        <poste code="0190150">TRESORERIE SAINT-PRIVAT</poste>
        <poste code="0300410">TRESORERIE DE PAYS D'ALES</poste>
        <poste code="0020580">TRESORERIE DE SAINT-QUENTIN</poste>
        <poste code="0020600">TRESORERIE DE SAINT-QUENTIN MUNICIPALE</poste>
        <poste code="0020610">TRESORERIE SAINT-QUENTIN CENTRE HOSPITALIER</poste>
        <poste code="0260010">TRESORERIE ALBON</poste>
        <poste code="0010320">TRESORERIE SAINT-RAMBERT-EN-BUGEY</poste>
        <poste code="0831160">TRESORERIE SAINT-RAPHAEL</poste>
        <poste code="0710490">TRESORERIE CHALON-SUR-SAONE PERIPHERIE</poste>
        <poste code="0132110">TRESORERIE SAINT-REMY-DE-PROVENCE</poste>
        <poste code="0630550">TRESORERIE SAINT-REMY-SUR-DUROLLE</poste>
        <poste code="0290190">TRESORERIE SAINT-RENAN</poste>
        <poste code="0762180">TRESORERIE SAINT-ROMAIN-DE-COLBOSC</poste>
        <poste code="0120400">TRESORERIE SAINT-ROME-DE-TARN-BROQUIES</poste>
        <poste code="0580280">TRESORERIE SAINT-SAULGE</poste>
        <poste code="0890380">TRESORERIE ST-SAUVEUR-EN-PUISAYE-LAINSECQ</poste>
        <poste code="0060210">TRESORERIE SAINT-SAUVEUR-SUR-TINEE</poste>
        <poste code="0330750">TRESORERIE SAINT-SAVIN</poste>
        <poste code="0860210">TRESORERIE SAINT-SAVIN</poste>
        <poste code="0170230">TRESORERIE SAINT-SAVINIEN</poste>
        <poste code="0210360">TRESORERIE SAINT-SEINE-L'ABBAYE</poste>
        <poste code="0140350">TRESORERIE SAINT-SEVER-CALVADOS</poste>
        <poste code="0400160">TRESORERIE SAINT-SEVER</poste>
        <poste code="0020620">TRESORERIE SAINT-SIMON-FLAVY</poste>
        <poste code="0810340">TRESORERIE DE SAINT-SULPICE</poste>
        <poste code="0690400">TRESORERIE DE SAINT-SYMPHORIEN-D'OZON</poste>
        <poste code="0422150">TRESORERIE SAINT-SYMPHORIEN-DE-LAY</poste>
        <poste code="0690300">TRESORERIE SAINT-SYMPHORIEN-SUR-COISE</poste>
        <poste code="0010330">TRESORERIE SAINT-TRIVIER-DE-COURTES</poste>
        <poste code="0010340">TRESORERIE SAINT-TRIVIER-SUR-MOIGNANS</poste>
        <poste code="0760740">TRESORERIE SAINT-VALERY-EN-CAUX</poste>
        <poste code="0800660">TRESORERIE DE SAINT-VALERY-SUR-SOMME</poste>
        <poste code="0260240">TRESORERIE SAINT-VALLIER</poste>
        <poste code="0790370">TRESORERIE SAINT-VARENT</poste>
        <poste code="0230160">TRESORERIE SAINT-VAURY</poste>
        <poste code="0620820">TRESORERIE SAINT-VENANT</poste>
        <poste code="0400290">TRESORERIE SAINT-VINCENT-DE-TYROSSE</poste>
        <poste code="0250240">TRESORERIE SAINT-VIT-BOUSSIERES</poste>
        <poste code="0870320">TRESORERIE DE SAINT-YRIEIX-LA-PERCHE</poste>
        <poste code="0931110">TRESORERIE STAINS</poste>
        <poste code="0240540">TRESORERIE SAINTE-ALVERE</poste>
        <poste code="1010150">TRESORERIE SAINTE-ANNE</poste>
        <poste code="0090150">TRESORERIE SAINTE-CROIX-VOLVESTRE</poste>
        <poste code="0430020">TRESORERIE AUZON-SAINTE-FLORINE</poste>
        <poste code="0330690">TRESORERIE SAINTE-FOY-LA-GRANDE</poste>
        <poste code="0911130">TRESORERIE SAINTE-GENEVIEVE-DES-BOIS</poste>
        <poste code="0120210">TRESORERIE DE L' ARGENCE ET DU CARLADEZ</poste>
        <poste code="0850260">TRESORERIE SAINTE-HERMINE</poste>
        <poste code="0470290">TRESORERIE SAINTE-LIVRADE-SUR-LOT</poste>
        <poste code="0680210">TRESORERIE SAINTE-MARIE-AUX-MINES</poste>
        <poste code="0370330">TRESORERIE SAINTE-MAURE-DE-TOURAINE</poste>
        <poste code="0510160">TRESORERIE STE-MENEHOULD-VILLE-SUR-TOURBE</poste>
        <poste code="0500470">TRESORERIE SAINTE-MERE-EGLISE</poste>
        <poste code="1010160">TRESORERIE SAINTE-ROSE</poste>
        <poste code="0250380">TRESORERIE MONTBELIARD ET DES DEUX VALLEES</poste>
        <poste code="1040100">TRESORERIE SAINTE-SUZANNE</poste>
        <poste code="0594200">TRESORERIE STEENVOORDE</poste>
        <poste code="0550430">TRESORERIE STENAY</poste>
        <poste code="0670000">TRESORERIE GENERALE DU BAS-RHIN</poste>
        <poste code="0670007">CENTRE REGIONAL DES PENSIONS DU BAS-RHIN</poste>
        <poste code="0670008">CENTRE DE FORMATION DEPARTEMENTAL DU BAS-RHIN</poste>
        <poste code="0670009">DEPARTEMENT INFORMATIQUE DU BAS-RHIN</poste>
        <poste code="0670530">TRESORERIE STRASBOURG KLEBER</poste>
        <poste code="0670540">TRESORERIE STRASBOURG EST</poste>
        <poste code="0670570">TRESORERIE STRASBOURG AMENDES</poste>
        <poste code="0670600">TRESORERIE STRASBOURG HOP. UNIVERSITAIRES</poste>
        <poste code="0670900">PAIERIE DEPARTEMENTALE DU BAS-RHIN</poste>
        <poste code="0670580">RECETTE DES FINANCES STRASBOURG MUNICIPALE ET COM.URB</poste>
        <poste code="0670800">PAIERIE REGIONALE D'ALSACE</poste>
        <poste code="0510210">TRESORERIE SUIPPES</poste>
        <poste code="0450300">TRESORERIE SULLY-SUR-LOIRE</poste>
        <poste code="0920360">TRESORERIE DE SURESNES</poste>
        <poste code="0170140">TRESORERIE SURGERES</poste>
        <poste code="0260250">TRESORERIE TAIN-L'HERMITAGE</poste>
        <poste code="0330180">TRESORERIE BORDEAUX CHU</poste>
        <poste code="0330540">TRESORERIE TALENCE</poste>
        <poste code="0050210">TRESORERIE DE TALLARD</poste>
        <poste code="0740290">TRESORERIE TANINGES</poste>
        <poste code="0580290">TRESORERIE TANNAY</poste>
        <poste code="0690530">TRESORERIE TARARE</poste>
        <poste code="0132120">TRESORERIE TARASCON</poste>
        <poste code="0090200">TRESORERIE TARASCON-SUR-ARIEGE</poste>
        <poste code="0650000">TRESORERIE GENERALE DES HAUTES-PYRENEES</poste>
        <poste code="0650240">TRESORERIE TARBES ADOUR ECHEZ</poste>
        <poste code="0650280">TRESORERIE DE TARBES</poste>
        <poste code="0650290">TRESORERIE TARBES MUNICIPALE</poste>
        <poste code="0650900">PAIERIE DEPARTEMENTALE DES HAUTES-PYRENEES</poste>
        <poste code="0640330">TRESORERIE TARDETS-SORHOLUS</poste>
        <poste code="0400310">TRESORERIE TARTAS</poste>
        <poste code="0690310">TRESORERIE DE TASSIN-LA-DEMI-LUNE</poste>
        <poste code="0590440">TRESORERIE DE TEMPLEUVE-LA-PVLE</poste>
        <poste code="0430310">TRESORERIE TENCE</poste>
        <poste code="0060230">TRESORERIE DE TENDE</poste>
        <poste code="0020350">TRESORERIE TERGNIER</poste>
        <poste code="0240380">TRESORERIE DE THENON</poste>
        <poste code="0240370">TRESORERIE TERRASSON-LA-BACHELLERIE</poste>
        <poste code="0520400">TRESORERIE TERRE-NATALE</poste>
        <poste code="0680290">TRESORERIE THANN</poste>
        <poste code="0880400">TRESORERIE THAON-LES-VOSGES</poste>
        <poste code="0622330">TRESORERIE DE THEROUANNE</poste>
        <poste code="0640340">TRESORERIE DE THEZE</poste>
        <poste code="0540240">TRESORERIE DE THIAUCOURT-REGNIEVILLE</poste>
        <poste code="0270400">TRESORERIE THIBERVILLE</poste>
        <poste code="0630560">TRESORERIE THIERS</poste>
        <poste code="0570640">TRESORERIE THIONVILLE-TROIS-FRONTIERES</poste>
        <poste code="0570540">TRESORERIE THIONVILLE MUNICIPALE</poste>
        <poste code="0570611">TRESORERIE DE METZ-THIONVILLE ETS.HOSP.BEL AIR</poste>
        <poste code="0240390">TRESORERIE DE THIVIERS</poste>
        <poste code="0690540">TRESORERIE DE THIZY-COURS-LA-VILLE</poste>
        <poste code="0010370">TRESORERIE THOISSEY</poste>
        <poste code="0740300">TRESORERIE THONES</poste>
        <poste code="0740310">TRESORERIE THONON-LES-BAINS-LULLIN</poste>
        <poste code="0490280">TRESORERIE DE THOUARCE</poste>
        <poste code="0790410">TRESORERIE THOUARS</poste>
        <poste code="0600460">TRESORERIE THOUROTTE</poste>
        <poste code="0070320">TRESORERIE DE THUEYTS</poste>
        <poste code="0660240">TRESORERIE THUIR</poste>
        <poste code="0140360">TRESORERIE THURY-HARCOURT</poste>
        <poste code="0490290">TRESORERIE TIERCE</poste>
        <poste code="0140370">TRESORERIE TILLY-SUR-SEULLES</poste>
        <poste code="0610400">TRESORERIE TINCHEBRAY</poste>
        <poste code="0350480">TRESORERIE TINTENIAC</poste>
        <poste code="0240400">TRESORERIE DE TOCANE-SAINT-APRE-LISLE</poste>
        <poste code="0170240">TRESORERIE TONNAY-BOUTONNE</poste>
        <poste code="0170250">TRESORERIE TONNAY-CHARENTE</poste>
        <poste code="0470310">TRESORERIE TONNEINS</poste>
        <poste code="0890410">TRESORERIE TONNERRE</poste>
        <poste code="0500230">TRESORERIE TORIGNI-TESSY</poste>
        <poste code="0760650">TRESORERIE DE TOTES</poste>
        <poste code="0890420">TRESORERIE TOUCY</poste>
        <poste code="0540070">TRESORERIE DE TOUL</poste>
        <poste code="0540250">TRESORERIE DE TOUL-COLLECTIVITES</poste>
        <poste code="0830000">TRESORERIE GENERALE DU VAR</poste>
        <poste code="0830180">TRESORERIE TOULON EST</poste>
        <poste code="0830190">TRESORERIE TOULON CENTRE ET OUEST</poste>
        <poste code="0830200">TRESORERIE TOULON MUNICIPALE</poste>
        <poste code="0830230">TRESORERIE VAR AMENDES</poste>
        <poste code="0830001">SERVICE CONTRLE REDEVANCE AUDIOVISUELLE DU VAR</poste>
        <poste code="0830900">PAIERIE DEPARTEMENTALE DU VAR</poste>
        <poste code="0310000">TRESORERIE GENERALE DE LA HAUTE-GARONNE</poste>
        <poste code="0310007">CENTRE REGIONAL DES PENSIONS DE LA HAUTE-GARONNE</poste>
        <poste code="0310008">CENTRE DE FORMATION DEPARTEMENTAL DE LA HAUTE-GARONNE</poste>
        <poste code="0310009">DEPARTEMENT INFORMATIQUE DE LA HAUTE-GARONNE</poste>
        <poste code="0310270">TRESORERIE DE TOULOUSE CITE</poste>
        <poste code="0310280">TRESORERIE TOULOUSE-COTE-PAVEE</poste>
        <poste code="0310290">TRESORERIE TOULOUSE BASSO CAMBO</poste>
        <poste code="0310340">TRESORERIE TOULOUSE AMENDES</poste>
        <poste code="0310350">RECETTE DES FINANCES TOULOUSE MUNICIPALE</poste>
        <poste code="0310360">TRESORERIE TOULOUSE CHU</poste>
        <poste code="0310370">TRESORERIE HOPITAL SPEC. MARCHANT-TOULOUSE</poste>
        <poste code="0310800">PAIERIE REGIONALE DE MIDI-PYRENEES</poste>
        <poste code="0310006">PLE NATIONAL DE SOUTIEN AU RESEAU DOMAINE DES RESSOURCES HUMAINES</poste>
        <poste code="0310900">PAIERIE DEPARTEMENTALE DE LA HAUTE-GARONNE</poste>
        <poste code="0310910">PLE NATIONAL DE LA REDEVANCE AUDIOVISUELLE DE TOULOUSE</poste>
        <poste code="0310005">CENTRE AMENDE SERVICE DE TOULOUSE</poste>
        <poste code="0590470">TRESORERIE DE TOURCOING MUNICIPALE</poste>
        <poste code="0590480">TRESORERIE TOURCOING CENTRE HOSPITALIER</poste>
        <poste code="0590450">TRESORERIE TOURCOING</poste>
        <poste code="0500490">TRESORERIE TOURLAVILLE</poste>
        <poste code="0770240">TRESORERIE TOURNAN-EN-BRIE</poste>
        <poste code="0650300">TRESORERIE TOURNAY</poste>
        <poste code="0470320">TRESORERIE TOURNON-D'AGENAIS</poste>
        <poste code="0070330">TRESORERIE TOURNON-SUR-RHONE</poste>
        <poste code="0710350">TRESORERIE TOURNUS</poste>
        <poste code="0370000">TRESORERIE GENERALE EN INDRE-ET-LOIRE</poste>
        <poste code="0370007">CENTRE REGIONAL DES PENSIONS D' INDRE-ET-LOIRE</poste>
        <poste code="0370008">CENTRE DE FORMATION DEPARTEMENTAL D' INDRE-ET-LOIRE</poste>
        <poste code="0370009">DEPARTEMENT INFORMATIQUE D' INDRE-ET-LOIRE</poste>
        <poste code="0370370">TRESORERIE DE TOURS</poste>
        <poste code="0370410">TRESORERIE DE TOURS MUNICIPALE</poste>
        <poste code="0370420">TRESORERIE TOURS CHU</poste>
        <poste code="0370440">TRESORERIE OPAC D'INDRE-ET-LOIRE</poste>
        <poste code="0370900">PAIERIE DEPARTEMENTALE D' INDRE-ET-LOIRE</poste>
        <poste code="0370001">SERVICE CONTRLE REDEVANCE AUDIOVISUELLE DE L' INDRE ET LOIRE</poste>
        <poste code="0370450">TRESORERIE DE L' OPAC DE TOURS</poste>
        <poste code="0710360">TRESORERIE DE TRAMAYES</poste>
        <poste code="0780430">TRESORERIE TRAPPES</poste>
        <poste code="0220430">TRESORERIE DE TREGUIER-LA ROCHE-DERRIEN</poste>
        <poste code="0190180">TRESORERIE TREIGNAC</poste>
        <poste code="0490300">TRESORERIE DE TRELAZE</poste>
        <poste code="0595300">TRESORERIE TRELON</poste>
        <poste code="0930370">TRESORERIE TREMBLAY-EN-FRANCE</poste>
        <poste code="0131150">TRESORERIE TRETS</poste>
        <poste code="0140380">TRESORERIE TREVIERES</poste>
        <poste code="0010390">TRESORERIE TREVOUX</poste>
        <poste code="0650310">TRESORERIE TRIE-SUR-BAISE</poste>
        <poste code="0781160">TRESORERIE TRIEL-SUR-SEINE</poste>
        <poste code="0595110">TRESORERIE TRITH-SAINT-LEGER</poste>
        <poste code="0140390">TRESORERIE TROARN-ARGENCES</poste>
        <poste code="0140590">TRESORERIE TROUVILLE-SUR-MER-DEAUVILLE</poste>
        <poste code="0100360">TRESORERIE DE TROYES MUNICIPALE</poste>
        <poste code="0100350">TRESORERIE DE TROYES</poste>
        <poste code="0100000">TRESORERIE GENERALE DE L' AUBE</poste>
        <poste code="0100280">TRESORERIE DE PONT-SAINTE-MARIE</poste>
        <poste code="0100330">TRESORERIE DE SAINTE-SAVINE</poste>
        <poste code="0100370">TRESORERIE DE TROYES CENTRE HOSPITALIER</poste>
        <poste code="0100900">PAIERIE DEPARTEMENTALE DE L' AUBE</poste>
        <poste code="0670620">TRESORERIE DE TRUCHTERSHEIM</poste>
        <poste code="0110520">TRESORERIE TUCHAN</poste>
        <poste code="0190000">TRESORERIE GENERALE DE LA CORREZE</poste>
        <poste code="0190190">TRESORERIE TULLE</poste>
        <poste code="0759001">AGENCE COMPTABLE DE LA RIEP - ANNEXE TULLE</poste>
        <poste code="0190900">PAIERIE DEPARTEMENTALE DE LA CORREZE</poste>
        <poste code="0380460">TRESORERIE TULLINS</poste>
        <poste code="1190000">TRESORERIE AMBASSADE DE FRANCE EN TUNISIE</poste>
        <poste code="0730350">TRESORERIE UGINE</poste>
        <poste code="0190200">TRESORERIE USSEL</poste>
        <poste code="0640460">TRESORERIE USTARITZ</poste>
        <poste code="1610010">TRESORERIE DES ILES-SOUS-LE-VENT</poste>
        <poste code="1630000">PAIERIE DES ILES WALLIS ET FUTUNA</poste>
        <poste code="0190210">TRESORERIE UZERCHE</poste>
        <poste code="0300350">TRESORERIE UZES</poste>
        <poste code="0810350">TRESORERIE VABRE</poste>
        <poste code="0020490">TRESORERIE DE VAILLY-SUR-AISNE-CHASSEMY</poste>
        <poste code="0840270">TRESORERIE DE VAISON-LA-ROMAINE</poste>
        <poste code="0520360">TRESORERIE LE VAL-DE-MEUSE</poste>
        <poste code="0270410">TRESORERIE VAL-DE-REUIL</poste>
        <poste code="0380470">TRESORERIE VALBONNAIS</poste>
        <poste code="0250250">TRESORERIE VALDAHON</poste>
        <poste code="0900100">TRESORERIE VALDOIE</poste>
        <poste code="0360290">TRESORERIE DE VALENCAY</poste>
        <poste code="0260000">TRESORERIE GENERALE DE LA DROME</poste>
        <poste code="0260260">TRESORERIE VALENCE</poste>
        <poste code="0260270">TRESORERIE VALENCE MUNICIPALE</poste>
        <poste code="0260280">TRESORERIE VALENCE HOPITAUX</poste>
        <poste code="0260290">TRESORERIE VALENCE OPHLM</poste>
        <poste code="0260900">PAIERIE DEPARTEMENTALE DE LA DROME</poste>
        <poste code="0820230">TRESORERIE VALENCE-D'AGEN</poste>
        <poste code="0810170">TRESORERIE VALENCE-D'ALBIGEOIS</poste>
        <poste code="0320360">TRESORERIE VALENCE-SUR-BAISE</poste>
        <poste code="0595000">RECETTE DES FINANCES VALENCIENNES</poste>
        <poste code="0595090">TRESORERIE ONNAING</poste>
        <poste code="0595160">TRESORERIE VALENCIENNES CENTRE HOSPITALIER</poste>
        <poste code="0595140">TRESORERIE DE VALENCIENNES</poste>
        <poste code="0061120">TRESORERIE VALLAURIS</poste>
        <poste code="0300360">TRESORERIE VALLERAUGUE</poste>
        <poste code="0070350">TRESORERIE VALLON-PONT-D'ARC</poste>
        <poste code="0762150">TRESORERIE VALMONT</poste>
        <poste code="0500500">TRESORERIE VALOGNES</poste>
        <poste code="0840280">TRESORERIE VALREAS</poste>
        <poste code="0070360">TRESORERIE VALS-LES-BAINS</poste>
        <poste code="0540280">TRESORERIE VANDOEUVRE-LES-NANCY</poste>
        <poste code="0560000">TRESORERIE GENERALE DU MORBIHAN</poste>
        <poste code="0560170">TRESORERIE VANNES-CLISSON</poste>
        <poste code="0560180">TRESORERIE VANNES-MENIMUR</poste>
        <poste code="0560190">TRESORERIE VANNES MUNICIPALE</poste>
        <poste code="0560900">PAIERIE DEPARTEMENTALE DU MORBIHAN</poste>
        <poste code="0560001">SERVICE CONTRLE REDEVANCE AUDIOVISUELLE DU MORBIHAN</poste>
        <poste code="0921130">TRESORERIE VANVES</poste>
        <poste code="0550440">TRESORERIE DE VARENNES-EN-ARGONNE</poste>
        <poste code="0030340">TRESORERIE VARENNES-SUR-ALLIER</poste>
        <poste code="0090280">TRESORERIE VARILHES</poste>
        <poste code="0580300">TRESORERIE VARZY</poste>
        <poste code="0550280">TRESORERIE DE VAUCOULEURS - VOID VACON</poste>
        <poste code="0690320">TRESORERIE VAUGNERAY</poste>
        <poste code="0690450">TRESORERIE VAULX-EN-VELIN</poste>
        <poste code="0300370">TRESORERIE VAUVERT</poste>
        <poste code="0700410">TRESORERIE VAUVILLERS</poste>
        <poste code="0240560">TRESORERIE DE VELINES ET LAMOTHE-MONTRAVEL</poste>
        <poste code="0210440">TRESORERIE VENAREY-LES-LAUMES</poste>
        <poste code="0061130">TRESORERIE VENCE</poste>
        <poste code="0100380">TRESORERIE DE VENDEUVRE-SUR-BARSE</poste>
        <poste code="0410350">TRESORERIE VENDOME</poste>
        <poste code="0690330">TRESORERIE DE VENISSIEUX</poste>
        <poste code="0550450">TRESORERIE DE VERDUN</poste>
        <poste code="0820240">TRESORERIE VERDUN-SUR-GARONNE</poste>
        <poste code="0710560">TRESORERIE VERDUN-SUR-LE-DOUBS</poste>
        <poste code="0300380">TRESORERIE VERGEZE</poste>
        <poste code="0240410">TRESORERIE VERGT</poste>
        <poste code="0020630">TRESORERIE VERMAND</poste>
        <poste code="0890440">TRESORERIE VERMENTON</poste>
        <poste code="0270140">TRESORERIE VERNEUIL-SUR-AVRE</poste>
        <poste code="0270150">TRESORERIE VERNON</poste>
        <poste code="0570550">TRESORERIE VERNY</poste>
        <poste code="0780000">TRESORERIE GENERALE DES YVELINES</poste>
        <poste code="0780008">CENTRE DE FORMATION DEPARTEMENTAL DES YVELINES</poste>
        <poste code="0780009">DEPARTEMENT INFORMATIQUE DES YVELINES</poste>
        <poste code="0780330">TRESORERIE DE VERSAILLES</poste>
        <poste code="0780360">TRESORERIE DE VERSAILLES BANLIEUE</poste>
        <poste code="0780370">TRESORERIE DE VERSAILLES MUNICIPALE</poste>
        <poste code="0780900">PAIERIE DEPARTEMENTALE YVELINES</poste>
        <poste code="0780450">TRESORERIE DE L' OPIEVOY-HLM</poste>
        <poste code="0780001">SERVICE CONTRLE REDEVANCE AUDIOVISUELLE DES YVELINES</poste>
        <poste code="0630320">TRESORERIE VERTAIZON</poste>
        <poste code="0440180">TRESORERIE DE VERTOU</poste>
        <poste code="0020690">TRESORERIE VERVINS</poste>
        <poste code="0512160">TRESORERIE DE VERZY</poste>
        <poste code="02B0220">TRESORERIE VESCOVATO</poste>
        <poste code="0700000">TRESORERIE GENERALE DE LA HAUTE-SAONE</poste>
        <poste code="0700440">TRESORERIE VESOUL</poste>
        <poste code="0700900">PAIERIE DEPARTEMENTALE DE LA HAUTE-SAONE</poste>
        <poste code="0050230">TRESORERIE VEYNES</poste>
        <poste code="0300530">TRESORERIE DE VEZENOBRES</poste>
        <poste code="0951090">TRESORERIE VIARMES</poste>
        <poste code="0720520">TRESORERIE VIBRAYE</poste>
        <poste code="0650320">TRESORERIE VIC-EN-BIGORRE</poste>
        <poste code="0320370">TRESORERIE VIC-FEZENSAC</poste>
        <poste code="0630330">TRESORERIE VIC-LE-COMTE</poste>
        <poste code="0020500">TRESORERIE VIC-SUR-AISNE</poste>
        <poste code="0150300">TRESORERIE VIC-SUR-CERE</poste>
        <poste code="0570560">TRESORERIE VIC-SUR-SEILLE</poste>
        <poste code="0090210">TRESORERIE VICDESSOS</poste>
        <poste code="0030350">TRESORERIE VICHY</poste>
        <poste code="02A0120">TRESORERIE VICO</poste>
        <poste code="0650330">TRESORERIE VIELLE-AURE</poste>
        <poste code="0381000">RECETTE DES FINANCES VIENNE</poste>
        <poste code="0381140">TRESORERIE VIENNE MUNICIPALE</poste>
        <poste code="0381130">TRESORERIE DE VIENNE</poste>
        <poste code="0180400">TRESORERIE DE VIERZON VILLE ET CAMPAGNE</poste>
        <poste code="0380480">TRESORERIE VIF</poste>
        <poste code="0190320">TRESORERIE VIGEOIS</poste>
        <poste code="0550290">TRESORERIE DE VIGNEULLES-LES-HATTONCHATEL</poste>
        <poste code="0910320">TRESORERIE VIGNEUX-SUR-SEINE</poste>
        <poste code="0520260">TRESORERIE VIGNORY</poste>
        <poste code="0950270">TRESORERIE VIGNY</poste>
        <poste code="0570570">TRESORERIE VIGY</poste>
        <poste code="0490530">TRESORERIE DE VIHIERS</poste>
        <poste code="0530320">TRESORERIE VILLAINES-LA-JUHEL</poste>
        <poste code="0380490">TRESORERIE VILLARD-DE-LANS</poste>
        <poste code="0010400">TRESORERIE VILLARS-LES-DOMBES</poste>
        <poste code="0670630">TRESORERIE VILLE</poste>
        <poste code="02B0050">TRESORERIE CAP CORSE</poste>
        <poste code="0512180">TRESORERIE VILLE-EN-TARDENOIS</poste>
        <poste code="0160440">TRESORERIE VILLEBOIS-LAVALETTE</poste>
        <poste code="0500370">TRESORERIE DE VILLEDIEU-PERCY</poste>
        <poste code="0480230">TRESORERIE VILLEFORT</poste>
        <poste code="0660260">TRESORERIE DU CONFLENT</poste>
        <poste code="0310390">TRESORERIE VILLEFRANCHE-DE-LAURAGAIS</poste>
        <poste code="0120450">TRESORERIE VILLEFRANCHE-DE-ROUERGUE</poste>
        <poste code="0690550">TRESORERIE DE VILLEFRANCHE HERON</poste>
        <poste code="0060250">TRESORERIE VILLEFRANCHE-SUR-MER</poste>
        <poste code="0690560">TRESORERIE VILLEFRANCHE RIVOLI</poste>
        <poste code="0940320">TRESORERIE VILLEJUIF CHS PAUL GUIRAUD</poste>
        <poste code="0940210">TRESORERIE VILLEJUIF</poste>
        <poste code="0911150">TRESORERIE VILLEMOISSON-SUR-ORGE</poste>
        <poste code="0330590">TRESORERIE VILLENAVE-D'ORNON</poste>
        <poste code="0120460">TRESORERIE VILLENEUVE</poste>
        <poste code="0590010">TRESORERIE DE VILLENEUVE-D'ASCQ</poste>
        <poste code="0070390">TRESORERIE VILLENEUVE-DE-BERG</poste>
        <poste code="0400180">TRESORERIE VILLENEUVE-DE-MARSAN</poste>
        <poste code="0890560">TRESORERIE DE VILLENEUVE-L'ARCHEVEQUE</poste>
        <poste code="0920380">TRESORERIE VILLENEUVE-LA-GARENNE</poste>
        <poste code="0940220">TRESORERIE DE VILLENEUVE-LE-ROI</poste>
        <poste code="0300400">TRESORERIE VILLENEUVE-LES-AVIGNON</poste>
        <poste code="0940230">TRESORERIE VILLENEUVE-SAINT-GEORGES</poste>
        <poste code="0470330">TRESORERIE VILLENEUVE-SUR-LOT</poste>
        <poste code="0890570">TRESORERIE DE VILLENEUVE-SUR-YONNE</poste>
        <poste code="0930360">TRESORERIE AULNAY-SOUS-BOIS ET. HOSP.</poste>
        <poste code="0470340">TRESORERIE VILLEREAL</poste>
        <poste code="0140420">TRESORERIE DE VILLERS-BOCAGE</poste>
        <poste code="0800460">TRESORERIE VILLERS-BOCAGE</poste>
        <poste code="0020510">TRESORERIE DE VILLERS-COTTERETS</poste>
        <poste code="0700450">TRESORERIE VILLERSEXEL</poste>
        <poste code="0690340">TRESORERIE DE VILLEURBANNE</poste>
        <poste code="0690350">TRESORERIE DE VILLEURBANNE MUNICIPALE</poste>
        <poste code="0951110">TRESORERIE VILLIERS-LE-BEL</poste>
        <poste code="0941100">TRESORERIE DE VILLIERS-SUR-MARNE</poste>
        <poste code="0610420">TRESORERIE VIMOUTIERS</poste>
        <poste code="0620470">TRESORERIE VIMY</poste>
        <poste code="0380500">TRESORERIE VINAY</poste>
        <poste code="0660270">TRESORERIE VINCA</poste>
        <poste code="0941120">TRESORERIE VINCENNES MUNICIPALE</poste>
        <poste code="0941110">TRESORERIE DE VINCENNES</poste>
        <poste code="0140430">TRESORERIE VIRE</poste>
        <poste code="0381240">TRESORERIE VIRIEU</poste>
        <poste code="0910330">TRESORERIE VIRY-CHATILLON</poste>
        <poste code="0350390">TRESORERIE VITRE</poste>
        <poste code="0131170">TRESORERIE VITROLLES</poste>
        <poste code="0620480">TRESORERIE VITRY-EN-ARTOIS</poste>
        <poste code="0510150">TRESORERIE DE VITRY - RURAL</poste>
        <poste code="0510280">TRESORERIE DE VITRY-LE-FRANCOIS</poste>
        <poste code="0940260">TRESORERIE VITRY-SUR-SEINE</poste>
        <poste code="0940270">TRESORERIE VITRY-SUR-SEINE MUNICIPALE</poste>
        <poste code="0210470">TRESORERIE VITTEAUX</poste>
        <poste code="0880450">TRESORERIE VITTEL-REMONCOURT</poste>
        <poste code="0860260">TRESORERIE VIVONNE</poste>
        <poste code="0380520">TRESORERIE VIZILLE</poste>
        <poste code="0380530">TRESORERIE VOIRON</poste>
        <poste code="0390270">TRESORERIE VOITEUR</poste>
        <poste code="0040280">TRESORERIE VOLONNE</poste>
        <poste code="0630470">TRESORERIE VOLVIC</poste>
        <poste code="0430320">TRESORERIE VOREY</poste>
        <poste code="0860270">TRESORERIE VOUILLE</poste>
        <poste code="0370430">TRESORERIE DE VOUVRAY</poste>
        <poste code="0080510">TRESORERIE VOUZIERS</poste>
        <poste code="0280310">TRESORERIE DE VOVES-ORGERES EN BEAUCE</poste>
        <poste code="1780000">TRESORERIE AMBASSADE DE FRANCE AUX ETATS-UNIS</poste>
        <poste code="0590090">TRESORERIE DE WASQUEHAL</poste>
        <poste code="0670640">TRESORERIE WASSELONNE</poste>
        <poste code="0020640">TRESORERIE WASSIGNY</poste>
        <poste code="0520270">TRESORERIE DE WASSY</poste>
        <poste code="0590490">TRESORERIE WATTIGNIES</poste>
        <poste code="0590500">TRESORERIE WATTRELOS</poste>
        <poste code="0590110">TRESORERIE FOURNES-EN-WEPPES</poste>
        <poste code="0671200">TRESORERIE DE WISSEMBOURG</poste>
        <poste code="0671210">TRESORERIE WOERTH</poste>
        <poste code="0594150">TRESORERIE WORMHOUT</poste>
        <poste code="0880480">TRESORERIE XERTIGNY</poste>
        <poste code="1390000">TRESORERIE AMBASSADE DE FRANCE AU CAMEROUN</poste>
        <poste code="0730360">TRESORERIE D' YENNE</poste>
        <poste code="0760480">TRESORERIE YERVILLE</poste>
        <poste code="0430330">TRESORERIE YSSINGEAUX</poste>
        <poste code="0760490">TRESORERIE YVETOT</poste>
        <poste code="0030130">TRESORERIE DE MOULINS</poste>
    </xsl:variable>
 
    <xsl:template match="/*[position()=1]">
        <xsl:if test="local-name() = 'PES_Aller'">
            <PES_Aller xmlns="http://www.minefi.gouv.fr/cp/helios/pes_v2/Rev0/aller"
                xmlns:added="http://projets.admisource.gouv.fr/xemelios/namespaces#added"
                xmlns:n="http://www.minefi.gouv.fr/cp/helios/pes_v2/Rev0/aller"            
                xmlns:ano="http://projets.admisource.gouv.fr/xemelios/namespaces#anomally">
                <xsl:for-each select="./@*">
                    <xsl:attribute name="{local-name(.)}" namespace="{namespace-uri(.)}" select="."/>
                </xsl:for-each>
                <xsl:for-each select="./*">
                    <xsl:call-template name="writeElement">
                        <xsl:with-param name="el" select="."/>
                    </xsl:call-template>
                </xsl:for-each>
            </PES_Aller>
        </xsl:if>
    </xsl:template>
    
    <xsl:template name="writeElement">
        <xsl:param name="el"/>
        <xsl:choose>
            <xsl:when test="namespace-uri($el) = 'http://projets.admisource.gouv.fr/xemelios/namespaces#anomally'">
                <xsl:element name="{name($el)}" namespace="http://projets.admisource.gouv.fr/xemelios/namespaces#anomally">
                    <xsl:for-each select="$el/@*">
                        <xsl:attribute name="{name(.)}" namespace="{namespace-uri(.)}">
                            <xsl:value-of select="."/>
                        </xsl:attribute>
                    </xsl:for-each>
                    <xsl:value-of select="text()" disable-output-escaping="yes"/>
                    <xsl:for-each select="$el/*">
                        <xsl:call-template name="writeElement"><xsl:with-param name="el" select="."/></xsl:call-template>
                    </xsl:for-each>
                </xsl:element>
            </xsl:when>
            <xsl:when test="namespace-uri($el) = 'http://www.w3.org/2000/09/xmldsig#'">
                <xsl:element name="{name($el)}" namespace="http://www.w3.org/2000/09/xmldsig#">
                    <xsl:for-each select="$el/@*">
                        <xsl:attribute name="{name(.)}" namespace="{namespace-uri(.)}">
                            <xsl:value-of select="."/>
                        </xsl:attribute>
                    </xsl:for-each>
                    <xsl:value-of select="text()" disable-output-escaping="yes"/>
                    <xsl:for-each select="$el/*">
                        <xsl:call-template name="writeElement"><xsl:with-param name="el" select="."/></xsl:call-template>
                    </xsl:for-each>
                </xsl:element>
            </xsl:when>
            <xsl:when test="namespace-uri($el) = 'http://uri.etsi.org/01903/v1.1.1#'">
                <xsl:element name="{name($el)}" namespace="http://uri.etsi.org/01903/v1.1.1#">
                    <xsl:for-each select="$el/@*">
                        <xsl:attribute name="{name(.)}" namespace="{namespace-uri(.)}">
                            <xsl:value-of select="."/>
                        </xsl:attribute>
                    </xsl:for-each>
                    <xsl:value-of select="text()" disable-output-escaping="yes"/>
                    <xsl:for-each select="$el/*">
                        <xsl:call-template name="writeElement"><xsl:with-param name="el" select="."/></xsl:call-template>
                    </xsl:for-each>
                </xsl:element>
            </xsl:when>
            <xsl:otherwise>
                <xsl:choose>
                    <xsl:when test="local-name($el) = 'LibellePoste'"></xsl:when>
                    <xsl:otherwise>
                        <xsl:element name="{local-name($el)}" namespace="http://www.minefi.gouv.fr/cp/helios/pes_v2/Rev0/aller">
                            <xsl:for-each select="$el/@*">
                                <xsl:choose>
                                    <xsl:when test="namespace-uri(.) = 'http://projets.admisource.gouv.fr/xemelios/namespaces#anomally'">
                                        <xsl:attribute name="{local-name(.)}" namespace="http://projets.admisource.gouv.fr/xemelios/namespaces#anomally">
                                            <xsl:value-of select="."/>
                                        </xsl:attribute>
                                    </xsl:when>
                                    <xsl:otherwise>
                                        <xsl:attribute name="{local-name(.)}">
                                            <xsl:value-of select="."/>
                                        </xsl:attribute>
                                    </xsl:otherwise>
                                </xsl:choose>
                            </xsl:for-each>
                            <xsl:choose>
                                <xsl:when test="contains('|Bordereau|Piece|LigneDePiece|PJRef',concat('|',name($el)))">
                                    <xsl:attribute name="generated-id" namespace="http://projets.admisource.gouv.fr/xemelios/namespaces#added">
                                        <xsl:value-of select="generate-id()"/>
                                    </xsl:attribute>
                                    <!--xsl:attribute name="tag-name" namespace="http://projets.admisource.gouv.fr/xemelios/namespaces#added">
                                        <xsl:value-of select="name($el)"/>
                                        </xsl:attribute-->
                                </xsl:when>
                                <xsl:when test="local-name($el) = 'InfoTiers'">
                                    <xsl:attribute name="key" namespace="http://projets.admisource.gouv.fr/xemelios/namespaces#added">
                                        <xsl:value-of select="concat(./*[local-name()='Nom'][1]/@V,' ',./*[local-name()='Prenom'][1]/@V)"/>
                                    </xsl:attribute>
                                </xsl:when>
                                <xsl:when test="local-name($el) = 'InfoLignePce' or local-name($el) = 'InfoLignePiece'">
                                    <xsl:attribute name="imputation" namespace="http://projets.admisource.gouv.fr/xemelios/namespaces#added">
                                        <xsl:value-of select="concat(./*[local-name()='Nature'][1]/@V,'-',./*[local-name()='Fonction'][1]/@V,'-',./*[local-name()='Operation'][1]/@V)"/>
                                    </xsl:attribute>
                                </xsl:when>
                            </xsl:choose>
                            <!--xsl:choose>
                                <xsl:when test="local-name($el)='Bordereau'">
                                    <xsl:attribute name="nbPiece" namespace="http://projets.admisource.gouv.fr/xemelios/namespaces#added"><xsl:value-of select="count(./*[local-name()='Piece'])"/></xsl:attribute>
                                    <xsl:attribute name="montantTTC" namespace="http://projets.admisource.gouv.fr/xemelios/namespaces#added">
                                        <xsl:value-of select="sum(./*[local-name()='BlocBordereau'][1]/*[local-name()='MtBordHT'][1]/@V) + sum(./*[local-name()='BlocBordereau'][1]/*[local-name()='MtBord'][1]/*[local-name()='TVA'][1]/@V)"/>
                                    </xsl:attribute>
                                    <xsl:attribute name="LibelleTypBord" namespace="http://projets.admisource.gouv.fr/xemelios/namespaces#added">
                                        <xsl:variable name="codTypBord" select="./*[local-name()='BlocBordereau'][1]/*[local-name()='TypBord'][1]/@V"/>  
                                        <xsl:choose>
                                            <xsl:when test="$codTypBord='01'">Bordereau de mandats</xsl:when>
                                            <xsl:when test="$codTypBord='02'">Bordereau d'annulation de mandats</xsl:when>
                                            <xsl:when test="$codTypBord='03'">Bordereau d'ordres de paiement ordonnateur</xsl:when>
                                            <xsl:when test="$codTypBord='04'">Bordereau de mandats mis d'office</xsl:when>
                                        </xsl:choose>
                                    </xsl:attribute>
                                </xsl:when>
                                <xsl:when test="name($el)='Piece'">
                                    <xsl:attribute name="nbLigne" namespace="http://projets.admisource.gouv.fr/xemelios/namespaces#added"><xsl:value-of select="count(./LigneDePiece)"/></xsl:attribute>
                                    <xsl:attribute name="montantHT" namespace="http://projets.admisource.gouv.fr/xemelios/namespaces#added">
                                        <xsl:value-of select="sum(./*[local-name()='LigneDePiece']/*[local-name()='BlocLignePiece']/*[local-name()='InfoLignePce']/*[local-name()='MtHT']/@V)"/>
                                    </xsl:attribute>
                                    <xsl:attribute name="LibelleTypPiece" namespace="http://projets.admisource.gouv.fr/xemelios/namespaces#added">
                                        <xsl:variable name="codTypPiece" select="./*[local-name()='BlocPiece']/*[local-name()='InfoPce']/*[local-name()='TypPce']/@V"/>  
                                        <xsl:choose>
                                            <xsl:when test="$codTypPiece='01'">Mandat ordinaire</xsl:when>
                                            <xsl:when test="$codTypPiece='02'">Mandat correctif</xsl:when> 
                                            <xsl:when test="$codTypPiece='03'">Mandat ordre budgtaire</xsl:when>
                                            <xsl:when test="$codTypPiece='04'">Mandat d&apos;ordre mixte</xsl:when>
                                            <xsl:when test="$codTypPiece='05'">Mandat mis aprs paiement</xsl:when> 
                                            <xsl:when test="$codTypPiece='06'">Mandat global</xsl:when>
                                            <xsl:when test="$codTypPiece='07'">Mandat d&apos;admission en non valeurs</xsl:when>
                                            <xsl:when test="$codTypPiece='08'">Mandat collectif</xsl:when>
                                            <xsl:when test="$codTypPiece='09'">Mandat sur march</xsl:when>
                                            <xsl:when test="$codTypPiece='10'">Mandat de rattachement</xsl:when>
                                            <xsl:when test="$codTypPiece='11'">Ordre de paiement</xsl:when>
                                            <xsl:when test="$codTypPiece='13'">Charges constates d&apos;avance</xsl:when>    
                                        </xsl:choose>
                                    </xsl:attribute>
                                    <xsl:attribute name="LibelleNatPiece" namespace="http://projets.admisource.gouv.fr/xemelios/namespaces#added">
                                        <xsl:variable name="codNatPiece" select="./*[local-name()='BlocPiece']/*[local-name()='InfoPce']/*[local-name()='NatPce']/@V"/>  
                                        <xsl:choose>
                                            <xsl:when test="$codNatPiece='01'">Fonctionnement</xsl:when>
                                            <xsl:when test="$codNatPiece='02'">Investissement</xsl:when> 
                                            <xsl:when test="$codNatPiece='03'">Inventaire</xsl:when>
                                            <xsl:when test="$codNatPiece='04'">Emprunt</xsl:when>
                                            <xsl:when test="$codNatPiece='05'">Rgie</xsl:when> 
                                            <xsl:when test="$codNatPiece='06'">Annulation / Rduction</xsl:when>
                                            <xsl:when test="$codNatPiece='07'">Complmentaire</xsl:when>
                                            <xsl:when test="$codNatPiece='08'">R-mis</xsl:when>
                                            <xsl:when test="$codNatPiece='09'">Annulant un titre</xsl:when>
                                            <xsl:when test="$codNatPiece='10'">Annulation du mandat de rattachement</xsl:when>
                                            <xsl:when test="$codNatPiece='11'">Paie</xsl:when>
                                            <xsl:when test="$codNatPiece='12'">Retenue de garantie</xsl:when>
                                            <xsl:when test="$codNatPiece='13'">Dernier acompte sur march</xsl:when>    
                                            <xsl:when test="$codNatPiece='14'">Avance forfaitaire</xsl:when>
                                            <xsl:when test="$codNatPiece='15'">Autre</xsl:when>
                                            <xsl:when test="$codNatPiece='18'">Cession</xsl:when>
                                        </xsl:choose>
                                    </xsl:attribute>
                                    <xsl:attribute name="montantTTC" namespace="http://projets.admisource.gouv.fr/xemelios/namespaces#added">
                                        <xsl:value-of select="sum(./*[local-name()='LigneDePiece']/*[local-name()='BlocLignePiece']/*[local-name()='InfoLignePce']/*[local-name()='MtHT']/@V) + sum(./*[local-name()='LigneDePiece']/*[local-name()='BlocLignePiece']/*[local-name()='InfoLignePce']/*[local-name()='MtTVA']/@V)"/>
                                    </xsl:attribute>
                                    <xsl:choose>
                                        <xsl:when test="local-name()='Piece'">
                                            <xsl:attribute name="avecPJ" namespace="http://projets.admisource.gouv.fr/xemelios/namespaces#added">
                                                <xsl:value-of select="count(descendant::PJRef) &gt; 0"/>
                                            </xsl:attribute>
                                        </xsl:when>
                                    </xsl:choose>
                                    <xsl:choose>
                                        <xsl:when test="*[local-name()='BlocPiece']/*[local-name()='DGP']/*[local-name()='Dgp']/@V = 'true'">
                                            <xsl:attribute name="DGP" namespace="http://projets.admisource.gouv.fr/xemelios/namespaces#added">true</xsl:attribute>
                                        </xsl:when>
                                        <xsl:otherwise>
                                            <xsl:attribute name="DGP" namespace="http://projets.admisource.gouv.fr/xemelios/namespaces#added">false</xsl:attribute>                                    
                                        </xsl:otherwise>
                                    </xsl:choose>
                                </xsl:when>
                                <xsl:when test="local-name($el)='LigneDePiece'">
                                    <xsl:attribute name="montantTTC" namespace="http://projets.admisource.gouv.fr/xemelios/namespaces#added">
                                        <xsl:value-of select="sum(./*[local-name()='BlocLignePiece']/*[local-name()='InfoLignePce']/*[local-name()='MtHT']/@V) + sum(./*[local-name()='BlocLignePiece']/*[local-name()='InfoLignePce']/*[local-name()='MtTVA']/@V)"/>
                                    </xsl:attribute>
                                    <xsl:attribute name="LibelleCatTiersLignePiece" namespace="http://projets.admisource.gouv.fr/xemelios/namespaces#added">
                                        <xsl:variable name="codCatTiers" select="./*[local-name()='Tiers']/*[local-name()='InfoTiers']/*[local-name()='CatTiers']/@V"/>  
                                        <xsl:choose>
                                            <xsl:when test="$codCatTiers='01'">Personnes physiques</xsl:when>
                                            <xsl:when test="$codCatTiers='20'">tat et tablissements publics nationaux</xsl:when>
                                            <xsl:when test="$codCatTiers='21'">Rgions</xsl:when>
                                            <xsl:when test="$codCatTiers='22'">Dpartements</xsl:when>
                                            <xsl:when test="$codCatTiers='23'">Communes</xsl:when>
                                            <xsl:when test="$codCatTiers='24'">Groupements de collectivits</xsl:when>
                                            <xsl:when test="$codCatTiers='25'">Caisses des coles</xsl:when>
                                            <xsl:when test="$codCatTiers='26'">CCAS</xsl:when>
                                            <xsl:when test="$codCatTiers='27'">tablissements publics de sant</xsl:when>
                                            <xsl:when test="$codCatTiers='28'">cole nationale de la sant publique</xsl:when>
                                            <xsl:when test="$codCatTiers='29'">Autres tablissements publics et organismes internationaux</xsl:when>
                                            <xsl:when test="$codCatTiers='50'">Personnes morales de droit priv autres qu'organismes sociaux</xsl:when>
                                            <xsl:when test="$codCatTiers='60'">Caisses de scurit sociale rgime gnral</xsl:when>
                                            <xsl:when test="$codCatTiers='61'">Caisses de scurit sociale rgime agricole</xsl:when>
                                            <xsl:when test="$codCatTiers='62'">Scurit sociale des travailleurs non salaris et professions non agricoles</xsl:when>
                                            <xsl:when test="$codCatTiers='63'">Autres rgimes obligatoires de scurit sociale</xsl:when>
                                            <xsl:when test="$codCatTiers='64'">Mutuelles et organismes d'assurance</xsl:when>
                                            <xsl:when test="$codCatTiers='65'">Divers autres tiers payants</xsl:when>
                                            <xsl:when test="$codCatTiers='70'">CNRACL</xsl:when>
                                            <xsl:when test="$codCatTiers='71'">IRCANTEC</xsl:when>
                                            <xsl:when test="$codCatTiers='72'">ASSEDIC</xsl:when>
                                            <xsl:when test="$codCatTiers='73'">Caisses mutualistes de retraite complmentaires</xsl:when>
                                            <xsl:when test="$codCatTiers='74'">Autres organismes sociaux</xsl:when>
                                        </xsl:choose>
                                    </xsl:attribute>
                                    <xsl:attribute name="LibelleNatIdTiersLignePiece" namespace="http://projets.admisource.gouv.fr/xemelios/namespaces#added">
                                        <xsl:variable name="codNatIdTiers" select="./*[local-name()='Tiers']/*[local-name()='InfoTiers']/*[local-name()='NatIdTiers']/@V"/>
                                        <xsl:choose>
                                            <xsl:when test="$codNatIdTiers='01'">Siret</xsl:when>
                                            <xsl:when test="$codNatIdTiers='02'">Siren</xsl:when>
                                            <xsl:when test="$codNatIdTiers='03'">Finess</xsl:when>
                                            <xsl:when test="$codNatIdTiers='04'">Nir</xsl:when>
                                        </xsl:choose>
                                    </xsl:attribute>
                                    <xsl:attribute name="LibelleNatJurLignePiece" namespace="http://projets.admisource.gouv.fr/xemelios/namespaces#added">
                                        <xsl:variable name="codNatJur" select="./*[local-name()='Tiers']/*[local-name()='InfoTiers']/*[local-name()='NatJur']/@V"/>
                                        <xsl:choose>
                                            <xsl:when test="$codNatJur='00'">Inconnue</xsl:when>
                                            <xsl:when test="$codNatJur='01'">Particuliers</xsl:when>
                                            <xsl:when test="$codNatJur='02'">Artisan / Commerant / Agriculteur</xsl:when>
                                            <xsl:when test="$codNatJur='03'">Socit</xsl:when>
                                            <xsl:when test="$codNatJur='04'">CAM ou caisse appliquant les mmes rgles</xsl:when>
                                            <xsl:when test="$codNatJur='05'">Caisse complmentaire</xsl:when>
                                            <xsl:when test="$codNatJur='06'">Association</xsl:when>
                                            <xsl:when test="$codNatJur='07'">Etat ou organisme d'Etat</xsl:when>
                                            <xsl:when test="$codNatJur='08'">Etablissement public national</xsl:when>
                                            <xsl:when test="$codNatJur='09'">Collectivit territoriale / EPL / EPS</xsl:when>
                                            <xsl:when test="$codNatJur='10'">Etat tranger / Ambassade</xsl:when>
                                            <xsl:when test="$codNatJur='11'">CAF</xsl:when>
                                        </xsl:choose>
                                    </xsl:attribute>
                                </xsl:when>
                            </xsl:choose-->
                            <xsl:choose>
                                <xsl:when test="contains('|CptBancaire',concat('|',local-name($el)))"><xsl:attribute name="rib" namespace="http://projets.admisource.gouv.fr/xemelios/namespaces#added"><xsl:value-of select="$el/*[local-name()='CodeEtab']/@V"/><xsl:value-of select="$el/*[local-name()='CodeGuic']/@V"/><xsl:value-of select="$el/*[local-name()='IdCpte']/@V"/><xsl:value-of select="$el/*[local-name()='CleRib']/@V"/></xsl:attribute></xsl:when>
                            </xsl:choose>
                            <xsl:if test="contains('|Bordereau',concat('|',local-name($el)))"><xsl:attribute name="primary-key" namespace="http://projets.admisource.gouv.fr/xemelios/namespaces#added"><xsl:value-of select="*[local-name()='BlocBordereau']/*[local-name()='Exer']/@V"/>-<xsl:value-of select="*[local-name()='BlocBordereau']/*[local-name()='TypBord']/@V"/>-<xsl:value-of select="*[local-name()='BlocBordereau']/*[local-name()='IdBord']/@V"></xsl:value-of></xsl:attribute></xsl:if>
                            <xsl:for-each select="$el/*">
                                <xsl:call-template name="writeElement">
                                    <xsl:with-param name="el" select="."/>
                                </xsl:call-template>
                            </xsl:for-each>
                            <xsl:value-of select="$el/text()" disable-output-escaping="yes"/>
                        </xsl:element>
                        <xsl:if test="contains('|IdPost',concat('|',local-name($el)))">
                            <xsl:element name="LibellePoste" namespace="http://www.minefi.gouv.fr/cp/helios/pes_v2/Rev0/aller">
                                <xsl:variable name="code" select="$el/@V"/>
                                <xsl:attribute name="V"><xsl:value-of select="$postes/poste[starts-with(@code,$code)][1]/text()"/></xsl:attribute>
                            </xsl:element>
                        </xsl:if>
                    </xsl:otherwise>
                </xsl:choose>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    
</xsl:transform>